2016-02-18  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	bindings/php5: fix enum getters and setters (fixes #10032)
	enumeration type were being wrongly interpreted as objects types because
	is_object() was used instead of the local specialisation done in
	PhpCode.is_object().

	Also fix docstring of getters/setters.

2016-02-18  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	tools.c: use correct NID and digest length when building RSA signature using SHA-2 digest (fixes #10019)
	Thanks to Brett Gardner for the bug report and patch.

	Licence: MIT

2016-01-13  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix wrong snippet type (fixes #9616)
	In elements samlp2:RequestedAuthnContext, Comparison is an attribute, not a text
	child node.

2016-01-11  Frédéric Péters  <fpeters@entrouvert.com>

	perl: remove quotes from $PERL -V::ccflags: output (#9572)

2015-11-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	tests: update valgrind suppressions

	tests: fix leak

	saml-2.0: fix leaks of url

	profile: fix leak of private idp_list field

	xml: fix leak in lasso_soap_envelope_new_full

2015-11-24  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	xml: fix wrong termination of comment

	tests: fix leaks in test_ecp

	saml-2.0: fix leak of message_id in lasso_profile_saml20_build_paos_request_msg

	id-ff: fix leak of profile->private_data->message_id

	tests: fix leak in test test16_test_get_issuer

2015-10-30  Rob Crittenden  <rcritten@redhat.com>

	Set NotBefore in SAML 2.0 login assertions
	License: MIT

2015-10-15  John Dennis  <jdennis@redhat.com>

	Add missing urn constants used in PAOS HTTP header
	The new OASIS "SAML V2.0 Enhanced Client or Proxy Profile Version 2.0"
	specification added new options that can appear in the PAOS HTTP header.

	Section 2.3.1 enumerates the following URN options which can appear
	in the PAOS HEADER:

	urn:oasis:names:tc:SAML:protocol:ext:channel-binding
	urn:oasis:names:tc:SAML:2.0:cm:holder-of-key
	urn:oasis:names:tc:SAML:2.0:profiles:SSO:ecp:2.0:WantAuthnRequestsSigned
	urn:oasis:names:tc:SAML:2.0:conditions:delegation

	Of these only the holder-of-key was previously defined in Lasso,
	this patch adds the other 3 constants.

	License: MIT

2015-09-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Release 2.5.0

	remove errors.c, it breaks computation of version from tags

	java: fix AllJunitTests generation when building out of source directory

2015-09-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Revert "Add messageID and idp_list to profile properties"
	This reverts commit b10c48058ed5942b135712f46888e0697fb593ff.

2015-09-01  John Dennis  <jdennis@redhat.com>

	fix test08_lasso_key test failure
	Note: the rest of this message is formatted as reStructuredText (rst).

	Test Failure
	============

	The unit tests run by "make check" fail with the following error:

	::

	    tests.c:61:F:Lasso keys:test08_lasso_key:0: No logging output expected: message «ID _E3F8E9116EE08F0E2607CF9789649BB4 already defined
	    » was emitted for domain «Lasso» at the level «128»

	This is not a regression in Lasso, rather the failure is caused by one
	of the components Lasso is dependent upon. It was first observed when
	the identical Lasso package was built in Fedora 22, no problems were
	observed in Fedora 21. This implies one or more updated components in
	Fedora 22 is the cause.

	This was a particularity difficult error to track down, first one had
	to identify who was emitting the message and on what file descriptor
	(stream) and who was triggering on the message emission and causing a
	check failure. The obvious assumption the check library was
	responsible for detecting the message emission and failing the test is
	wrong.

	Who is emitting the message and why?
	------------------------------------

	The message is emitted by libxml2 in the function `xmlAddID()`
	(valid.c:2578). It occurs at the end of xmlAddID() when it detects the
	ID (which is supposed to be unique to the document is already defined,
	which for valid XML is illegal (violates uniquenesss constraint). The
	message emission occurs because of the code fragment

	::

	        if (xmlHashAddEntry(table, value, ret) < 0) {
	    #ifdef LIBXML_VALID_ENABLED
	            /*
	             * The id is already defined in this DTD.
	             */
	            xmlErrValidNode(ctxt, attr->parent, XML_DTD_ID_REDEFINED,
	                            "ID %s already defined\n", value, NULL, NULL);
	    #endif /* LIBXML_VALID_ENABLED */
	            xmlFreeID(ret);
	            return(NULL);
	        }

	Why is the message emission different between libxml2 versions?
	---------------------------------------------------------------

	The change occured between libxml2 version 2.9.1 and 2.9.2 in commit
	a16eb968075a82ec33b2c1e77db8909a35b44620

	::

	    commit a16eb968075a82ec33b2c1e77db8909a35b44620
	    Author: Daniel Veillard <veillard@redhat.com>
	    Date:   Tue Jun 10 16:06:14 2014 +0800

	        erroneously ignores a validation error if no error callback set

	        Reported by Stefan Behnel
	        https://bugzilla.gnome.org/show_bug.cgi?id=724903

	    diff --git a/valid.c b/valid.c
	    index aedd9d7..1e03a7c 100644
	    --- a/valid.c
	    +++ b/valid.c
	    @@ -2633,11 +2633,8 @@ xmlAddID(xmlValidCtxtPtr ctxt, xmlDocPtr doc, const xmlChar *value,
	            /*
	             * The id is already defined in this DTD.
	             */
	    -	if ((ctxt != NULL) && (ctxt->error != NULL)) {
	    -	    xmlErrValidNode(ctxt, attr->parent, XML_DTD_ID_REDEFINED,
	    -	                    "ID %s already defined\n",
	    -			    value, NULL, NULL);
	    -	}
	    +	xmlErrValidNode(ctxt, attr->parent, XML_DTD_ID_REDEFINED,
	    +			"ID %s already defined\n", value, NULL, NULL);
	     #endif /* LIBXML_VALID_ENABLED */
	            xmlFreeID(ret);
	            return(NULL);

	In both versions of libxml2 the conditional complilation
	LIBXML_VALID_ENABLED is enabled by default via the configure
	script. What is different is the the requirement ctxt be
	non-NULL. Lasso invokes xmlAddID with a NULL ctxt parameter. Because
	the NULL test for ctxt is absent in libxlm2 2.9.2 the message is now
	emitted where previously it was not.

	Who triggers on messge emission and fails the test?
	---------------------------------------------------

	This is a Lasso feature, it is not part of libcheck. In tests/tests.c
	is the following function

	::

	    void error_logger(const gchar *log_domain, GLogLevelFlags log_level,
	                    const gchar *message, G_GNUC_UNUSED gpointer user_data)
	    {
	            fail("No logging output expected: message «%s» was emitted for domain «%s» at the level"
	                            " «%d»", message, log_domain, log_level);
	    }

	Before the test are run the error_logger function is installed as a
	glib handler

	::

	    g_log_set_default_handler(error_logger, NULL);

	When the message is emitted the error_logger traps it and invokes the
	libcheck (deprecated) function fail() which aborts the test case.

	Why does `test08_lasso_key` cause an XML validation failure?
	------------------------------------------------------------

	`test08_lasso_key` invokes `lasso_key_saml2_xml_verify()` twice on the
	same XML document. Any time `lasso_key_saml2_xml_verify()` is called
	more than once the XML validation will fail on the second and
	subsequent invocations. This occurs because
	`lasso_key_saml2_xml_verify()` invokes `lasso_verify_signature()`
	passing it the node id in the `id_attr_name` parameter. Inside
	`lasso_verify_signature()` is this code fragment:

	::

		/* Find ID */
		if (id_attr_name) {
			id = xmlGetProp(signed_node, (xmlChar*)id_attr_name);
			if (id) {
				xmlAddID(NULL, doc, id, xmlHasProp(signed_node, (xmlChar*)id_attr_name));
			}
		}

	Note that it unconditionally invokes `xmlAddID()`, which adds the ID
	to the set of unique element ID's in the document. But if you invoke
	`xmlAddID()` more than once with the same ID in the same document you
	violate the uniqueness constraint.

	The ID needs to be registered in the document because the <Reference>
	element of the <SignedInfo> may utilize an XPointer reference to the
	signed data. In it's simplest form the XPointer reference is an ID
	attribute on a node. Thus to locate the signed data referenced by the
	ID it should (must?) be in a table of ID's for the document.

	Simple Solution (patch)
	-----------------------

	The solution is simple now that the problem is understood. The ID
	should not be unconditionally added to the document, instead it should
	only be added if it's not already registered. Prior to calling
	`xmlAddID()` one should call `xmlGetID()` and test for a NULL result
	indicating the ID has not be registered previously.

	License: MIT

2015-09-01  John Dennis  <jdennis@redhat.com>

	add support for automake 1.15
	License: MIT

2015-09-01  John Dennis  <jdennis@redhat.com>

	Fix coverity lasso_get_hmac_key() warning
	lasso_get_hmac_key() did not check return value. Now check the return
	code, emit a critical message and return early with cleanup.

	License: MIT

2015-09-01  John Dennis  <jdennis@redhat.com>

	Add messageID and idp_list to profile properties
	ECP needs a place to store the messageID and idp_list. Normally values
	like this would located in a "context" passed to the relevant
	routines. But currently there is no such context, the closest thing to
	a context we have is the profile so we add them here in the profile
	private data using accessors. They are currently not relevant outside
	of ECP.

	Adds functions:

	lasso_profile_get_message_id()
	lasso_profile_set_message_id()
	lasso_profile_get_idp_list()
	lasso_profile_set_idp_list()

	License: MIT

2015-08-24  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	configure.ac: move test framework detection after pkg-config detection

	debian-jessie: add build dependency on pkg-config

	Add 'debian-jessie/' from commit 'dc7374e9f41214557dd45735789a7535d6bbe681'
	git-subtree-dir: debian-jessie
	git-subtree-mainline: 83f6319c01ef633fe17625d9ec8d15f1f9dbfc36
	git-subtree-split: dc7374e9f41214557dd45735789a7535d6bbe681

	bindings/java: fix test script generation

2015-08-24  John Dennis  <jdennis@redhat.com>

	add ECP unit test
	Test ECP.
	3 different variations of the SP provided IDP List are exercised.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Implement PAOS request and response messages
	Re-implement lasso_profile_saml20_build_paos_request_msg() and
	lasso_saml20_login_process_paos_response_msg() to use the
	functionality introduced by earlier patches and to assure they are
	functionally complete.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Add messageID and idp_list to profile properties
	ECP needs a place to store the messageID and idp_list. Normally values
	like this would located in a "context" passed to the relevant
	routines. But currently there is no such context, the closest thing to
	a context we have is the profile so we add them here in the profile
	private data using accessors. They are currently not relevant outside
	of ECP.

	Adds functions:

	lasso_profile_get_message_id()
	lasso_profile_set_message_id()
	lasso_profile_get_idp_list()
	lasso_profile_set_idp_list()

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	ECP and PAOS special handling
	ECP does not require an SP to know the remote IdP provider. Existing
	code made the assumption the remote provider always was
	necessary. Determination and setting of the remote consumer URL is
	different in the presence of ECP. Rework the logic to reflect
	differing requirements.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Add function to set protocol conformance
	Lasso uses an internal private variable bound to the provider to
	indicate which protocol the provider is servicing. It is vital this
	value be correctly set because many Lasso routines used it to dispatch
	to the appropriate protocol handlers.

	Normally the provider's protocol conformance is set as a side-effect
	of parsing the XML metadata that describes the provider (e.g. an SP or
	IdP). However there are some providers (e.g. an ECP client) which do
	not have metadata. For providers lacking metadata it is essential
	there be a mechanism to set the protocol conformance otherwise the
	library will malfunction.

	The function comes with documentation that includes a clear warning
	this is to be used only in limited circumstances.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Implement ECP client functionality
	Implement everything needed to support a SAMLv2 ECP client.

	Re-implement lasso_ecp_process_authn_request_msg() and
	lasso_ecp_process_response_msg() to use the Lasso XML serialization
	subsystem with the ECP and PASO LassoNode's introduced earlier. This
	replaces one-off explicit direct use of the libxml API with Lasso
	common code. In the process provide support for 100% of the ECP and
	PAOS SAMLv2 parameters, not just a subset. Include support for
	receiving an IDPList from the SP in conjuction with selecting an IdP
	known to the ECP client. Add extensive documentation.

	Modify LassoSamlp2AuthnRequest to preserve it's original XML (enable
	keep_xmlnode flag) so that when serializing the SOAP request the
	LassoSamlp2AuthnRequest received from the SP is exactly duplicated.

	Add the following internal static utility functions:

	is_provider_in_sp_idplist()
	is_idp_entry_in_entity_id_list()
	intersect_sp_idplist_with_entity_id_list()

	Add the following exported utility functions:

	lasso_ecp_is_provider_in_sp_idplist()
	lasso_ecp_is_idp_entry_known_idp_supporting_ecp()
	lasso_ecp_set_known_sp_provided_idp_entries_supporting_ecp()
	lasso_ecp_has_sp_idplist()
	lasso_ecp_get_endpoint_url_by_entity_id()
	lasso_ecp_process_sp_idp_list()

	Add the following members to the ECP class:

	message_id
	response_consumer_url
	relaystate
	issuer
	provider_name
	is_passive
	sp_idp_list
	known_sp_provided_idp_entries_supporting_ecp
	known_idp_entity_ids_supporting_ecp

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Clean up ECP and PAOS XML generation
	Re-implement lasso_node_export_to_ecp_soap_response() and
	lasso_node_export_to_paos_request(). Add new function
	lasso_node_export_to_paos_request_full() with full functionality which
	deprecates lasso_node_export_to_paos_request().

	The existing code had two significant deficiencies, it performed
	explicit direct xml manipulation using the libxml API rather than
	calling into Lasso's extensive XML utilities, this was in stark
	contrast the rest of the Lasso library. It also failed to handle a
	number of ECP parameters leaving a functionality gap in the API.

	The new code makes use of the Lasso XML serialization
	subsystem. Rather than hand crafted xml manipulation we use the ECP
	and PAOS LassoNode objects introduced in an earlier patch. This is
	consistent with the rest of Lasso and because those LassoNodes are
	used elsewhere we have a better guarantee of robustness because the
	same common code is being called from multiple places. Other Lasso
	common utilities (some introduced in previous patches) are invoked
	instead of handcrafted xml manipulation, once again common code is
	preferred.

	Finally lasso_node_export_to_paos_request_full() was introduced to
	expose in the Lasso API all ECP
	parameters. lasso_node_export_to_paos_request() now trivially calls
	into lasso_node_export_to_paos_request_full().

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Server utility returns list of providers supporting endpoint type
	Add lasso_server_get_filtered_provider_list() utility.

	Iterate over the server providers and build a list of provider EntityID's who
	have the specified role and at least one endpoint matching the
	protocol_type and http_method. Return a GList list of EntityID's

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Add server utility lasso_server_get_endpoint_url_by_id()
	Locate the provider in the server's list of providers, then select an
	endpoint given the @endpoint_description and return that endpoint's URL.
	If the provider cannot be found or if the provider does not have a
	matching endpoint NULL will be returned.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Add ECP and PAOS to prefix_from_href_and_nodename()
	prefix_from_href_and_nodename() did not know about the ECP and PAOS
	XML prefixes so add them.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Export LassonNode to SOAP with arbitrary SOAP headers
	Add function lasso_node_export_to_soap_with_headers()

	Utility function to build a full SOAP envelope message with arbitrary
	headers. The LassoNode becomes the body of the SOAP envelope. The
	headers are passed as a GList of LassoNode's and are added as header
	elements to the SOAP envelope header. This is a flexible way to build
	a SOAP envelope that contains headers without constraints on the
	headers.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	LassoSamlp2IDPList is not list capable
	LassoSamlp2IDPList is supposed to handle a list of LassoSamlp2IDPEntry
	but in fact it had no list support. Change the snippet flag
	SNIPPET_NODE to SNIPPET_LIST_NODES and add the special list comment on
	the struct member so that the binding generator knows what type of
	GList it is.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Add LassoNode objects for ECP and PAOS
	The SAMLv2 protocol defines 5 XML types which we need to map to
	LassoNode objectes so thay can be serialized from XML and back into
	XML.

	ecp:RelayState
	ecp:Request
	ecp:Response
	paos:Request
	paso:Response

	This patch addes these 5 new LassoNode's and updates the build
	configuration to include them.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Enhance process soap response to include processing soap headers
	The existing lasso_saml20_profile_process_soap_response() assumed
	there were no SOAP headers (prior to ECP none of the SOAP messages
	contained headers). A new function
	lasso_saml20_profile_process_soap_response_with_headers() was
	implemented that serializes from the XML SOAP headers into a
	LassoSoapHeader node and optionally will return the LassoSoapHeader
	node.

	The functionality in lasso_saml20_profile_process_soap_response() was
	moved into the new
	lasso_saml20_profile_process_soap_response_with_headers() and now
	lasso_saml20_profile_process_soap_response() simply calls
	lasso_saml20_profile_process_soap_response_with_headers() passing NULL
	for the header return.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Add new LassoSoapEnvelope constructor, lasso_soap_envelope_new_full()
	The existing LassoSoapEnvelope constructors did not populate the node
	with it's constituent members, namely a SOAP header (LassoSoapHeader)
	and a SOAP body (LassoSoapBody). lasso_soap_envelope_new_full() allows
	one to create a SOAP envelope and immediately begin to add header and
	body elements.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Fix LassoSoapHeader, was unable to serialize from XML.
	The existing Lasso code never made use of SOAP headers because up
	until now nothing used them. LassoSoapHeader was unable to serialize
	from XML into a GList of LassoNode objects because it was missing one
	of the necessary snippet flags. This corrects this omission and now
	parsing a SOAP header will yield a sequence of LassoNode's.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Add new error codes and their matching error descriptions
	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Add lasso_is_in_list_of_strings macro to utils.h
	Add macro that tests to see if a string is a member in a list of
	strings.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Fix build failure, remove inclusion of xml/private.h in utils.h
	The public utils.h header includes the private xml/private.h file
	which is not installed. Therefore anyone trying to build against lasso
	and include utils.h will fail because xml/private.h cannot be
	found. There doesn't seem to be any need to include this file.

	License: MIT

2015-08-24  John Dennis  <jdennis@redhat.com>

	Eliminate _BSD_SOURCE and _SVID_SOURCE deprecation warning
	Because all warnings are treated as errors and this warning is emitted:

	warning "_BSD_SOURCE and _SVID_SOURCE are deprecated, use _DEFAULT_SOURCE"

	the build fails.

	The fix is to define _DEFAULT_SOURCE in lasso/xml/tools.c

	The effect of defining the _DEFAULT_SOURCE macro is equivalent to
	the effect of explicitly defining three macros in earlier glibc
	versions: -D_BSD_SOURCE -D_SVID_SOURCE -D_POSIX_C_SOURCE=200809C

	License: MIT

2015-08-24  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	configure.ac: provide fallback for systems where libcheck is not installed with pkg-config

	Add checks for failure of an allocation function from libxml (#8070)
	g_malloc always trap on allocation errors but not xmlMalloc.

	xml: handle failure of xmlSecBase64Decode() (fixes #8070)
	Thanks to fpeters for the patch.

	FAQ: add section about getting the issuer before parsing the received message (#4378)

	profile: add two new class methods, lasso_profile_get_issuer and lasso_profile_get_in_response_to (#4378)
	The goal of those two methods is to allow IdP and SP to load metadata
	dynamically without processing completely the incoming. Currently it's
	impossible as message parsing and signature checking is done in the same
	function.

	configure.ac: use pkg-config for libcheck

	saml-2.0/login.c: change default value of WantAuthnRequestSigned (fixes #8105)
	Specification says it should default to FALSE. We comply.

2015-08-24  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Makefile.am: fix automake warning
	It fixes this warning:

		warning: 'INCLUDES' is the old name for 'AM_CPPFLAGS' (or '*_CPPFLAGS')

	it seems INCLUDES is not to be used anymore.

2015-04-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add 'debian-squeeze/' from commit '33d67ddd1352a2db97d252c7d18f7806ec91e616'
	git-subtree-dir: debian-squeeze
	git-subtree-mainline: 80a2e0ea4763d3f0bc611ab98c8e207b6a82c099
	git-subtree-split: 33d67ddd1352a2db97d252c7d18f7806ec91e616

	Add 'debian-wheezy/' from commit '0001ab9af1e3a7e19000a65b75ebc3c42f76a739'
	git-subtree-dir: debian-wheezy
	git-subtree-mainline: 9f99176b3c8dd2d7c9a6ebf9c619d9c7fea2b64b
	git-subtree-split: 0001ab9af1e3a7e19000a65b75ebc3c42f76a739

2015-03-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML-2.0: rework on commit 05fe802b8d, improve handling of ProtocolBinding and AssertionConsumerServiceURL
	When the same URL was used for many bindings, the current code did not
	work. Now we use
	lasso_saml20_provider_check_assertion_consumer_service_url() to validate
	url and binding are matching, if no binding is suggested we take the
	first one defined for this URL.

	Using AssertionConsumerServiceIndex and any of the other assertion
	consumer designator attributes is still forbidden.

2015-03-23  John Dennis  <jdennis@redhat.com>

	Fix build failures
	Fix a mistake in the documentation markup that prevented the
	doc from building, needed to reverse the order of two tags.

	Remove the $(PYTHON) from TESTS_ENVIRONMENT, it was causing
	python to be invoked passing /bin/sh to it as a script.

	License: MIT

2015-03-11  John Dennis  <jdennis@redhat.com>

	Add Destination attribute for SAML ECP Response
	The Destination attribute on SAML Response element was not being set
	when handling an ECP response. It is a requirement of SAML 2.0 that
	signed values contain a Destination attribute on the root element
	otherwise the client will reject the response. This is documented in
	the SAML Bindings Specification, Section 3.4.5.2 "Security
	Considerations":

	    If the message is signed, the Destination XML attribute in the
	    root SAML element of the protocol message MUST contain the URL to
	    which the sender has instructed the user agent to deliver the
	    message. The recipient MUST then verify that the value matches the
	    location at which the message has been received.

	Normally on login one calls
	lasso_saml20_login_build_authn_response_msg() which then calls
	lasso_saml20_profile_build_response_msg() which sets the Destination
	attribute on the SAML Response. But when doing ECP you do not call
	lasso_saml20_login_build_authn_response_msg(), instead you call call
	lasso_saml20_login_build_response_msg() and if it's ECP it then calls
	lasso_node_export_to_ecp_soap_response(). Thus the ECP
	response never gets the Destination attribute set because of the
	different code path, plus for ECP the destination is different, it's
	the assertion consumer service.

	FWIW this line of code was copied almost verbatim from
	lasso_saml20_profile_build_response_msg which also sets the
	Destination attribute.

	License: MIT

2015-02-26  Jérôme Schneider  <jschneider@entrouvert.com>

	php5-lasso.prerm: s/phpdismod/php5dismod/

	Merge with lasso in Jessie, re-activate java and gen-default-control.sh

	control: build depends on dh-python

2015-02-25  Jérôme Schneider  <jschneider@entrouvert.com>

	python-lasso.install: just install python 2 files

	python-lasso.install: python-lasso is for python2 only

	liblasso-perl.install.in: fixes path

	rules: cleanning clean target

	perl; fix build for Jessie

	remove java support

	control: update build-dependencies for python3

	debian/control: like control.in, control must be updated

2015-02-25  EO builder bot  <admin@entrouvert.com>

	debian: add python3 support

2015-02-13  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Re-add control for eobuilder

	Remove control and add python-six to control.in

	Revert "Remove control.in"
	This reverts commit 176e0716f8f8593860e0603697db5dec5675f5b3.

2015-02-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Remove control.in

	Add dependency on python-six

	Update AUHTORS file

	Port Java binding generator to Python 3

	Port Perl binding generator to Python 3

	Port PHP5 binding generator to Python 3

	Make python generator scripts and tests run with python >= 3.2

2015-02-12  Houzéfa Abbasbhay  <houzefa.abba@xcg-consulting.fr>

	Python 3: Fix the pygobject init macro and restore it

	Python 3: Fix a string conversion helper

	Python 3: Oops (see rev 279959f)

	Python 3: Fix Python 2 support (use six.print_)

	Mention Python 3 support in the changelog

	Python 3: Disable "PyGObjectPtrType" to avoid crashes (needs investigation)

	Python 3: Fix a string function

	Python 3: Fix module init

	Python 3: PyObject_HEAD_INIT(NULL) -> PyVarObject_HEAD_INIT(NULL, 0) (to play better with C strict aliasing rules - see PEP 3123)

	Python 3: Defs for int & string related functions

	Python 3: - file(...) -> open(...) - print ... -> print(...) - print >> fd, ... -> print(..., file=fd) - basestring -> str - map(...) -> list(map(...))

	Python 3: PyObject.ob_type is deeper in the structure; use the Py_TYPE macro instead

	Python 3: Fix print calls in configure.ac

	Ignore some Perl binding files

	Ignore /test-driver

2015-02-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML-2.0: Rework protocol profile selection when parsing AuthnRequest messages
	This commit also add tests around authn request parsing.

2015-02-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add support for SHA-2 family of hash functions for RSA and HMAC signatures

2015-01-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Check return value of lasso_session_add_assertion() in lasso_login_build_assertion()

	Remove _POSIX_SOURCE declaration as it's not needed

2014-12-09  Simo Sorce  <simo@redhat.com>

	Fix coverity issue about unchecked return
	If find_path() does not find MinorVersion, then no value is changed and
	we repeate the search with the values for thr major version.
	Check if we have found anything and if not set the minor version to 0.

	License: MIT

2014-10-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Improve top level commint in CGI script example

	Add simple example of a CGI service provider script written in C

2014-10-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Remove dead code in the PHP5 binding

2014-09-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	xml: modify xschema snippets to handle xsd:choice constructs

	xml: support xsd:choices by allowing to rewind or advance after match or miss of a snippet

2014-08-28  Simo Sorce  <simo@redhat.com>

	Fix header guard
	Found by clang

	License: MIT

2014-08-28  Simo Sorce  <simo@redhat.com>

	Assert on missing id
	In this function id is required, so just assert if it is missing.
	This also silences a warning about "reference" being used unintialized
	if "id" is null.

	License: MIT

2014-08-28  Simo Sorce  <simo@redhat.com>

	Missing variable initialization
	If name_id s unconditonally dereferenced in the cleanup code.
	If it is not initialized it may cause segfaults or other misbehaviors.

	License: MIT

2014-08-28  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix release date of 2.4.1

	Release 2.4.1

	Add tool gitlog-to-changelog

2014-08-12  Frédéric Péters  <fpeters@entrouvert.com>

	saml-2.0: set NotOnOrAfter on the Conditions element (#5248)
	This is actually required for interoperability with Dropbox SAML support.

2014-08-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	doc: add lasso_server_add_provider2 and lasso_server_load_metadata

2014-08-11  Frédéric Péters  <fpeters@entrouvert.com>

	debian: don't move perl files

	debian: accomodate perl now installing in the right directory

	perl: keep on using PREFIX, required for distcheck

	reformat gtk-doc function comment to work with gtk-doc 1.21

2014-08-11  Simon Josefsson  <simon@josefsson.org>

	fix pkg-config typo.

2014-08-06  Niko Tyni  <ntyni@debian.org>

	Use INSTALLDIRS=vendor for the Perl bindings, as per the Debian Perl policy
	Debian packaged Perl modules should be installed into the vendor
	directories (currently /usr/lib/perl5 and /usr/share/perl5), but the
	upstream default puts the into the 'site' ones (modified with the
	PREFIX setting.) Explicitly using INSTALLDIRS=vendor simplifies
	the install rules and removes the need for PREFIX, which has
	been deprecated in ExtUtils::MakeMaker for a long time.

2014-07-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Restore not-unused code
	Clang was wrong on one instance, a value must be initialized to its NULL
	state before using any lasso_assign_ macro with it.

	Bug introduced in 4789e8d4d68eb.

2014-07-30  Simo Sorce  <simo@redhat.com>

	One more uninitialized value
	encode_key may be release when not initialized if va_args returns null
	on the first while loop.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Fix potential null dereference errors
	Ina  number of cases function inputs are not checked for NULL although
	values may end up with a NULL value and then they are dereferenced
	directly.
	Check values in the function (or the caller) if appropriate.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Do not dereference null pointers
	Sounds like these should all be boolean 'OR's, otherwise,
	if profile is not in fact a lasso profile then profile->private_data
	will be dereferenced even if it is NULL.
	Found by Clang

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Rearrange case checking to avoid compiler warnings
	The compiler was complaining that 'compa' could be uninitialized.
	USe this occasion to make the code simpler to understand and assign
	actually meaningful values to the variable, even though the proper
	actions are not implemented yet.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Properly exit on error
	The rc error was being set but then it was being ignored.
	Get out immediately if an Issuer can't be found.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Consistently check dsig_reference_ctx
	Check if this is not NULL in all cases, to avoid NULL pointer dereference.
	Found by clang

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Trim unused code
	Clang complains these values are never used, avoid even assigning them.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Trim dead code
	These conditions can never be reached as the list is filtered with
	and and to the value of 0xff, so just drop them, they are misleading.
	(Also silences checkers which were screaming of deadcode, for each and
	every unmatchable value ...)

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Fix confusing loop test
	Coverity was marking the check for tsnippet after the while loop,
	confused by the check. Make it more readable, and in the process
	make checkers happy too.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Fix some uninitialized value
	The compiler complain about these values not being initialized.
	come of them do not really matter as they are only really used when
	later initialized in the code and the code paths would not use them
	if not initialized in a previous block, however some of these seem
	real issues.
	In all cases make the compiler happy so we get less noise in the build
	and less false positives in code chckers.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Missing check for Sig_Alg value
	Initialize the sig_alg value to NULL (The compilers was complaining it may
	be used initialized), but also make sure to check the re is any sig_alg at
	all, otherwise return a proper error.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Fix boundary check
	Coverity was marking this as an array overun as the check would never be
	possible and wuld allow any value for query_request_type, including "unset"
	wihch is 0.
	fix the boundary checks.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Fix uninitialized values found by Coverity
	These values where being used without being initialized at least in some edge
	cases. Make Coverity happy by properly initializing them.
	Some of these are real bugs, not just silencing a tool.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Fix format check for date
	Coverity was complaining that tm was used uninitialized, but the truth is
	that a third error condition where the string passed in matches no valid
	format was not handled. Just return an error in that case.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Fix error checking in xml.c
	Coverity was complaining that 'integer' was being used without
	initialization (from the caller). Turns out it was erroneously used
	to test the result instead of the just sourced 'what'.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Fixes for unchecked return values
	Coverity complains that in a number of places errors are not checked.
	Some of them are ok not to check so put a silencing (void).
	Check errors that need to be checked.

	Coverity also complains g_malloc() return is never checked but given it is
	never checked anywahere let it be for now.

	License: MIT

2014-07-30  Simo Sorce  <simo@redhat.com>

	Be correct in dealing with varargs
	Although in this cases it may be safe to omit va_end() that is not generally
	so with an arbitrary compiler on an arbitrary platform.

	Quoting from the spec: "Each invocation of va_start() must be matched by
	a corresponding invocation of va_end() in the same function."
	note the "must"

	Checker tools like Coverity complain if va_start() is not always paired with
	va_end(), so this patch mutes them.

	License: MIT

2014-06-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	bindings/python/tests: session indexes storage preserves order now

	tests: add target to Makefile to produce valgrind suppression entries

	tests/valgrind: add suppression of all leaks related to initialisation of the GLib type system

	tests: fix leaks

	saml-2.0/profile: fix leak of xmlSecKey when building signed query strings

	id-ff/provider: fix leak of xmlSecKey

	xml/samlp2_logout_request: fix leaks around session indexes

	server: fix leak of xmlSecKey objects

	session: fix leak of _NidAndSessionIndex structures

2014-06-07  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	saml-2.0/server: fix invalid memory access
	GList must never be allocated through malloc as it internally managed
	using gslice. Always use Glib constructors and methods.

	tests: fix leak in log message checker

	tests: do not reuse tc_response_new_from_xmlNode test case

2014-05-28  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	bindings/python: fix conversion of unicode value to UTF-8 for setters

2014-05-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	login: complete document of lasso_login_process_authn_response_msg on expectable error codes

2014-04-24  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	website: update links section

	website: add news about 2.4.0 release

	website: fix HTML grammar errors

	xml/xml.c: fix liberal use of casting for the SNIPPET_INTEGER and SNIPPET_BOOLEAN case
	Some behaviour are also made more explicit like the optional if equals
	to -1 case for integer fields, and the optional if FALSE for boolean
	fields.

	INSTALL: add php-cli to needed dependencie when compiling on Debian

	tests: pass automake CFLAGS when compiling tests2

	lasso/xml/tools.c: fix reference to unitialized memory

	NEWS: fix wrong date for 2.4.0 release

	update website for 2.4.0 release
	- remove windows installer reference
	- update debian repository configuration
	- point to cgit browser and releases directory

2014-04-23  Simo Sorce  <simo@redhat.com>

	Fix generators for parsing of integer values
	All number types including enums are parse as if they were integers,
	this breaks in many ways, long and int are not the same size in all
	architectures as well as enum may vary in size depening on compiler,
	architecture and optimizations.

	Always pass an actual long to PyArg_ParseTuple() and rely on the a
	cast from long to the destination variable type in the following
	assignment.

2014-04-15  Simo Sorce  <simo@redhat.com>

	Fix java version detection

2014-03-31  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	update NEWS

	bindings/perl/Makefile: it's difficult to control produced code so disable warning on unused-but-set-variable

2014-03-31  Frédéric Péters  <fpeters@entrouvert.com>

	perl: get required CFLAGS from $(perl -V::ccflags:)

2014-03-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	fix: remove warning by not calling g_type_init() with glib > 2.36 as it's deprecated

2014-01-07  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	configure.ac: update LASSO_VERSION_INFO

	Revert "configure.ac: desactivate the PHP5 binding if no CLI interpreter is available"
	This reverts commit a3d53764fa75c30ee9a118088f0a224bc20059e4.

	docs: remove section

2014-01-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	configure.ac: desactivate the PHP5 binding if no CLI interpreter is available

	configure.ac: remove checks for SWIG

2013-12-29  Frédéric Péters  <fpeters@entrouvert.com>

	import 2.3.6-3 changelog entry

	use php5enmod and php5dismod

2013-12-29  Moritz Muehlenhoff  <jmm@debian.org>

	enable hardened build flags

2013-12-29  Frédéric Péters  <fpeters@entrouvert.com>

	import 2.3.6-2.2 changelog entry

	import 2.3.6-2.1 leftovers

2013-12-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	configure.ac,fedora/lasso.spec: remove expat dependency

	INSTALL: add paragraph about build dependencies

	more work toward release 2.4.0

2013-12-18  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	id-ff/providerprivate.h,id-ff/provider.h: make lasso_provider_verify_signature public API
	It's necessary for the crudeSAML SASL mechanism.

2013-12-11  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	bindings/python: automatically encode string into utf-8 when passing unicode string to Lasso methods
	fixes #4077

2013-12-10  Jérôme Schneider  <jschneider@entrouvert.com>

	python-lasso.install: replace site-packages by dist-packages

	add python-lasso.install with python files

2013-12-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	id-ff/session.c: fix wrong variable reference in init_from_xml_nid_and_session_index

2013-12-08  Thomas NOEL  <tnoel@entrouvert.com>

	update control.in with control

2013-12-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	remove the debian directory from the project

2013-12-06  Jérôme Schneider  <jschneider@entrouvert.com>

	python-lasso.install: don't install old /usr/lib/python*/site-packages

2013-12-06  Frédéric Péters  <fpeters@entrouvert.com>

	doc: remove broken gtk-doc tests for now

	perl: make it compatible with recent libxml2

2013-12-05  Frédéric Péters  <fpeters@entrouvert.com>

	doc: remove reference to init.xml that is not created anymore

	build: replace python $libdir by our own

2013-12-05  Simo Sorce  <simo@redhat.com>

	Better python detection in configure.ac
	License: MIT

	Support automake 1.13 and 1.14
	License: MIT

2013-12-04  Jérôme Schneider  <jschneider@entrouvert.com>

	debian: replace dh_pycentral by dh_python

2013-12-03  Simo Sorce  <simo@redhat.com>

	Fix license boilerplates
	Instad of referring to an old FSF address, point the reader to the FSF
	website where the latest licenses and addresses are published.

2013-11-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	jenkins.sh: do not ignore errors

2013-10-23  Frédéric Péters  <fpeters@entrouvert.com>

	python: do not fail displaying a non-C error (fixes #3866)
	The binding does a raise Error('failed to create object') but the local Error
	exception class expects a lasso error code, and will thus fail if printed.

	  File ".../lasso.py", line 54, in __str__
	    return '<lasso.%s(%s): %s>' % (self.__class__.__name__, self.code,
	             _lasso.strError(self.code))
	  TypeError: an integer is required

2013-10-11  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	saml-2.0/provider: when looking for endpoints take a null role as meanning « take the first one »

2013-10-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	saml-2.0/profile: fix typo in commit 8de55

	saml-2.0/profile: add warning message when unable to build an artifact response message due to an unfound artifact resolution endpoint

2013-10-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	web: update mailing list urls

2013-09-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	debian: add a source/format file

	debian: add a source/format file

	toosl/git-version-gen: use a dot to separate the commit string from the regular version

	lasso/xml/tools.c: fix misuse of xmlURIUnescapeString
	If the length argument is NULL, the full string is unescaped; the
	behaviour we expected is to return a 0 length string.

	tools/git-version-gen: keep the g before the git commit number

	debian: import current packging for debian wheezy

	.gitignore: add more

	bindings/perl: fix type of size variable incompatible with 64 bits arch

	id-ff/login.c: initialize role status of sp and idp in lasso_login_init_authn_request

2013-09-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	jenkins.sh: build a first time before running distcheck, in order to have the documentation compiled

	tests/data/Makefile: regenerate list of files and directories to distribute

	docs/Makefile: always set DIST_SUBDIRS

	add jenkins.sh script

2013-09-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	saml2/profile.c: add resolving of the endpoint index in artifacts
	 * lasso/saml-2.0/profile.c: add new argument role to lasso_saml20_profile_init_artifact_resolve()
	   for looking up ArtifactResolutionService location; extract endpoint index
	   from artifact and use it to resolve the endpoint location.
	 * login.c: pass new argument ; force msg_url as it is preinitialized by
	   lasso_saml20_profile_init_artifact_resolve()

	saml2/provider.c: add new function lasso_saml20_provider_get_endpoint_url() for retrieving endpoint locations using the new endpoints list

	errors.{c,h}: add new error LASSO_PROFILE_ERROR_ENDPOINT_INDEX_NOT_FOUND for reporting when a recevied artifact does match any declared endpoint

	saml2/profile: fix missing ArtifactResolutionService index in artifacts

	tests: add non-regression test to check that we correctly provide the ArtifactResolutionService index in artifacts

	saml2/login: fix role of providers in process_authn_request() and idp_initiated_authn_request()
	It is necessary for endpoint resolution to know the role of providers.

	tests: in check_equals() and check_not_equals() macros use long long int as a catchall type for printing compared values

	fix compilation errors on 64bits architectures
	 * sizeof(unsigned int) != sizeof(size_t)
	 * INT_MAX != LONG_MAX

	fix warnings about unused but set variables

2013-08-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Revert "doc: fix EXTRA_DIST definition in reference/lasso/Makefile.am"
	This reverts commit a223afc6077528792055def999c29ac5f4d8a418.
	It seems to be incompatible with recent version of gtk-doc, I need to
	investigate more this problem.

	doc: fix EXTRA_DIST definition in reference/lasso/Makefile.am

2013-07-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge remote-tracking branch 'origin/libxml2.9-compat'

2013-07-20  Frédéric Péters  <fpeters@entrouvert.com>

	website: fix commercial licencee page location

2013-06-19  Tim Newsome  <tnewsome@aristanetworks.com>

	AM_C_PROTOTYPES is no longer supported in autoconf 1.12.

	Add support for automake 1.12.

2013-06-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	configure.ac: do not passe the full version suffix as the release number

	FAQ.rst: start a FAQ file

2013-05-15  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	configure: generate version number from git revision between tagged release
	The script git-version-gen is copied from the autoconf project.

2013-03-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	python: fix logout request parsing test
	adapt to new checks done on logout request nodes

	tests: comment out dump/restore checks against complex nodes

	saml-2.0: fix missing signature on logout responses

2013-03-07  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	pkgconfig: do not leak lasso dependencies to users
	Change Require into Require.private

	Thanks to Thijs Kinkhorst and Olav Morken for the suggestion.

2013-01-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	xml-saml-2.0: ManageNameIDRequest must have a NameID

	xml-saml-2.0: LogoutRequest must have a NameID

	xml: really enforce elements cardinality when parsing messages
	 - add a new SNIPPET_MANDATORY:
		 we could only indicate 0-1 and 0-* cardinalities, now we can also
		 indicate 1-1 and 1-* cardinalities.
	 - repect cadinalities when parsing an xmlNode tree into a LassoNode
		 tree.

	xml-saml-2.0: add missing namespace declaration for the KeyInfoSujectConfirmationData sub-type

	fix memory leak in lasso_node_impl_init_from_xml: release the class_list

	utils: add a lasso_release_slist macro

	add a lasso_release_slist

	fix potential segfault in lasso_node_impl_init_from_xml

	Fix distcheck build problem in docs/Makefile.am
	Bug introduced in commit e97a36fa

	fix warning in docs/reference/lasso/Makefile.am

2012-09-28  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Rewrite all xmlNode serialization code to be compatible with libxml 2.9.0
	Libxml stopped exposing the internal of the xmlOutputBuffer structure;
	it was replace by proper use of the API and of the xmlBuffer structure.

	There could be regression for older version of libxml as some functions
	appeared in recent version of libxml; but the reference API document
	does not give any introduction date for functions so it's hard to be
	sure.

2012-09-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	fix segfault in saml-2.0/provider.c:load_endpoint_type2
	Thanks to Hiromitsu Fujita for the patch. fixes #1582.

2012-07-11  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	tests: add a SSO test with DSA keys to python bindings tests

2012-06-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix compilation on solaris
	Thanks Wojciech Lichota for the patch.

	Fixes #1516

2012-06-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	fix SIGSEGV when loading metadata files
	Thanks Wojciech Lichota for the patch.

	Fixes #1516

2012-05-05  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings/php5] remove redundant check to is_transfer_full

	[bindings/php5] add missing release for xmlnodes in return value wrapper

	[abi] update for release 2.4.0

	[bindings/python] in constructors wrappers build the return value before

	[bindings/python] free xmlnode argument owned by the callee

	[bindings/python] fix some indentation

	[bindings/python] boolean values does not need to be released

	[bindings] add a default parameter to is_transfer_full whose default is False

	[bindings] improve matching for object types

	[xml] fix wrong forward declaration

	[xml] add missing include

	[xml] fix typos

	[lasso] add missing GObjectIntrospection annotations to lasso_node_get_original_xmlnode

	[lasso] add missing GObjectIntrospection annotations to lasso_misc_text_node_get_xml_content

	[NEWS] improve 2.4.0 release notes

	Merge branch 'release-2.4.0'

2012-04-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	fix wrong EXTRA_DIST in lasso/xml/dsig/Makefile.am

2012-04-26  Thomas NOEL  <tnoel@entrouvert.com>

	fix compilation error with xmlsec 1.2.18 / freebsd (#1365)
	see http://dev.entrouvert.org/issues/1365

2012-04-23  Frédéric Péters  <fpeters@entrouvert.com>

	Allow building from git without gtk-doc installed

2012-04-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[saml2] modify behaviour of lasso_saml2_assertion_add_attribute_with_node
	If an AttributeStatement already exists, we add the new attribute to it.

2012-04-02  Frédéric Péters  <fpeters@entrouvert.com>

	build: do not include multiple glib headers

2012-03-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] including glib headers directly is deprecated, we must only use <glib.h> now

2012-03-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[tests] add test cases for the LassoKey class

	[key] add methods to send message using SAML 2.0 redirect and post bindings

	[saml2] fix handling of SingleSignOnServer in lasso_saml20_provider_get_first_http_method
	When checking if a synchronous http method can be used for sending a
	request to the SingleSignOnService we must check if the response can
	received by the AssertionConsumerService with a synchronous binding not
	the SingleSignOnService.

2012-03-05  Frédéric Péters  <fpeters@entrouvert.com>

	php5: use zend_function_entry, for compatibility with PHP 5.4

2012-03-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings php5] fix missing wrappers for constructors

2012-02-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings php5] improve generation of php call stubs by using type case helpers, raise exception in unknown case

2012-02-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[website] add piwik tracking code to base template

2011-12-29  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	update NEWS

	Add release notes

	Add missing abi files

	Update files for release 2.4.0

	Incompatibility with clang: local functions with closure does not work

2011-12-23  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'more-datas-in-sessions'

	[tests] remove work-around for letting ID-FF 1.2 tests work with the thin-sessions flag activated
	But when thin-sessions is activated we use the new way of passing artifact
	message content around.

2011-12-23  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[id-ff 1.2] change websso with artifact binding to work as SAML 2.0
	The old way of transmiting the assertion to return via the session is kept,
	but a new way more semblable to the one used in the SAML 2.0 code is added.

	After lasso_login_build_artifact_msg() you must save the return of
	lasso_profile_get_artifact_message() linked to the value of the artifact
	obtained via lasso_profile_get_artifact().

	In the artifact-resolve endpoint you must find the artifact message
	corresponding to the return value of lasso_profile_get_artifact()
	reinstall the artifact message using lasso_profile_set_artifact_message()
	just before calling lasso_login_build_response_msg().

	This change is necessary for ID-FF 1.2 SSO profile to work with the
	thin-sessions.

2011-12-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[id-ff 1.2] in lasso_login_build_assertion() always add the assertion to the response

	[tests] protect the ID-FF 1.2 test cases from effect of the thin-sessions flag until it is migrated to work also with thin sessions

	[doc] do some documentation fixing

	[id-ff 1.2] provision the SessionIndex into the assertions
	Without it SLO session management is broken.

	[id-ff 1.1] add support for multiple SessionIndex to lib:LogoutRequest
	Combined with the new LassoSession storage for SessionIndex, it
	should fix many bugs when doing SLO.

	[saml 2.0] use the new SessionIndex storage for SLO management
	It shoulf fix any missing functionnalities regarding missing session indexes
	in logout requests sent by identity providers or service providers.

	[core] add support for thin-sessions environment flag, to reduce size of LassoSession dumps

	[core] add simpler storage for SessionIndexes in the LassoSession

2011-12-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[id-ff 1.2] add lasso_saml_name_identifier_equals() to compare NameIDs

	[website] remove the buildbox link for now

	[website] target the bug report link to on redmine

2011-12-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[saml2] fix lasso_saml20_logout_validate_request when more than one SessionIndex is sent

	[Makefile] add strings.h to the dsig module includes

	[xml/saml2] replace magic string by a define

	Simplify useless complexity in include paths

	[xml] in is_interaction_request.h move new field to the end of the structure fto limit ABI impact

	Merge branch 'rewrite-node-impl'

	[tests] fix tests to comply with new implementation of parsing
	The test around parsing of EncryptedAssertion was wrong since it was
	missing the XMLEnc namespace declaration.

2011-12-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[xml] rewrite schema directed serialization/deserialization methods
	The new implementations of lasso_node_impl_init_from_xml now validate
	namespace of all child nodes befores parsing. It stops on any error. For
	node which implement their own parsing of an attribute or a node, it
	must declare an XmlSnippet with an offset field set to 0. The 0 value is
	invalid for public GObject structure (it's the place of the GObject
	machinery like the reference count). The 0 offset can be used for
	XmlSnippet in a private structure, so never set the offset to 0 with the
	flag SNIPPET_PRIVATE, for a field which is parsed by you get_xmlNode
	virtual method.

	Other ameliorations in this commit is the possibility to set attributes
	with namespace when using the flags SNIPPET_ATTRIBUTE|SNIPPET_ANY. The
	syntax for an attribute is inspired by the element tree API from Python:

		{namespace}attribute_name

	an example:

		{http://www.w3.org/2001/XMLSchema-instance}type

	for the classic xsi:type attribute.

2011-12-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[xml] add LASSO_XMLENC_PREFIX and LASSO_XMLENC_HREF defines

	[xml] add missing nodes to LassoIsInteractionRequest

	[xml] change saml_advice.h to declarer the real node type
	It also needed a change to bindings.py to parse struct as well as
	typedef node classes.

	[xml] complete missing namespace declarations for child nodes
	To allow lasso_node_impl_init_from_xmlnode to do proper namespace
	checking, child node which are not of the same namespace as their parent
	in their XSD schema must have an explicit namespace declared in the
	XmlSnippet.

	[core] mark private_data field of the LassoKey structure as private

	[tests] improve checking for log output
	- now any non expected log output is considered an error, by setting a
	  g_log default   handler.
	- block_lasso_logs()/unblock_lasso_logs() will block logging output at
	  the DEBUG level
	- begin_check_do_log(level, message, endswith)/end_check_do_log() with
	  check that the only message emitted between the two macros is one
	  equals to "message" at the level "level", or ending (to work around
	  variable parts in a log message) with "message" if "endswith" is True.

	[tests] rename login test suite, with mentions of ID-FF 1.2 and SAML 2.0

	[Makefile] fix missing soap11 nodes when compiling for Mingw

	[core] fix uninitialized pointer to a GError structure

	[core] move XMLDsig related nodes in their own sub-library, add X509Data node implementation
	The goal is to use the KeyInfo structure as a transport format for our cryptographic keys

2011-12-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	remove debugging printf statement

2011-12-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[provider] fix doc comment

	[id-ff] move LassoLogout to use LassoSignatureContext

	[logging] add an error() macro

	[id-ff] move LassoLogin to use LassoSignatureContext

2011-12-05  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] rename lasso_provider_set_specific_signing_key to lasso_provider_set_server_signing_key

	[perfs] add command line options, add option to use shared secret key cryptography
	Performance with HMAC-SHA1 is 100x the one with 2048 bits RSA.

	[core] add the HMAC-SHA1 shared secret signature method

	[core] refactor lasso_query_verify_signature and lasso_saml2_query_verify_signature
	This commit introduces lasso_query_verify_helper which factorize
	cryptographic operations.

	[tests] use helper macros in id-ff test case

	[core] add lasso_provider_add_key to add other key for signature validation
	The added key can be appended or prepended, depending on the need for the key:
	 - rollover
	 - improving performances (using simpler cryptographic algorithmss using shared secret keys)

	[core] add method lasso_provider_set_specific_signing_key
	Using this method you can specify a signing which will be used for
	communication with the specified provider instead of the one configured
	on the LassoServer object. The main objective is to allow shared secret
	cryptography instead of public key cryptography.

	[core] add a new class LassoKey
	LassoKey currenly store a LassoSignatureContext inside a
	reference-counted and bindable object. It will be used to export API
	around key management to bindings.

	[core] set the xmlSec log handler globally
	The log handler is not set in lasso_init().

	[saml2] introduce a lasso_saml2_assertion_get_audirence_restrictions to factorize some code

	[core] introduce the LassoSignatureContext context, to pass around signature parameters
	This structure is used to pass around the signature algorithm
	and the signature key.

	[core] add a lasso_base64_decode function

	[core] replace explicit allocation of LassoProviderPrivate by use of g_type_class_add_private
	The private part is allocated contiguously to the public structure data.

	[configure.ac] fix compilation on Mac Os X

	[xml] use lasso_node_export_to_query_with_password to implement lasso_node_export_to_query

	[tools] fix lasso_sha1 to return a glib allocated string

	[id-ff/saml2] add a lasso_server_add_provider2
	It allows to add LassoProvider objects directly to a LassoServer object,
	without using the metadata loading methods.

	[utils] add lasso_crypto_memequal function
	This method compare byte strings in constant time.

	[tools] add a LassoSignatureContext structure to pass signature parameters around
	Signature parameters are mainly a LassoSignatureMethod and a xmlSecKey.

	[xml] add an inline function to validate LassoSignatureMethod values
	- add also a LASSO_SIGNATURE_METHOD_NONE value

	[utils] add lasso_transfer_xml_node macros

	[core] simplify lasso_provider_load_public_key

2011-11-29  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[web] fix link on the download page

	Merge branch 'multi-certificates'

	Merge branch 'excl-c14n-fix'

	[web] add release news for release 2.3.6

	[release] 2.3.6

2011-11-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[integration tests] does not use full leak report

	[integration tests] show more callers when using valgrind memcheck looking for leaks in authentic and lcs

	[tests] add test for rollover on the SP side, i.e. rollover of encryption keys
	This test case is the first to abstract the workflow between two
	LassoLogin object (for the idp and sp side). This part of the code could
	be used to simplify the code of other tests in the future.

2011-11-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] do not emit a warning for expected decryption errors
	The only expected decryption error is on decryption of the symetric key
	used to crypt the data. All other errors are critical and must be
	logged.

	Client of lasso_node_decrypt_xmlnode can then log the decryption failure
	of the symetric if they tried with all possible keys (key rollover
	case).

2011-11-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] add a new class of errors for xml encryption errors
	add LASSO_XMLENC_ERROR_INVALID_ENCRYPTED_DATA for generic unrecoverable
	xml decryption errors.

	[leakcheck] fix leaks seen by the unit tests
	This commit also improved valgrind suppression file to hide static
	allocations done by the GLib type system.

	[core] fix wrong XML canonicalization when assertion is extracted without its namespace context

2011-11-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[misc] apply changes to remove warning blocking compilation with gcc 4.5.2 and php 5.3.5
	 - gcc now warns when you compate a typedef to the anonymous enum which
	   define it.
	 - some inline function in the zend.h header do compare between signed
	   and unsigned char.

2011-11-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] multiple decryption keys support
	This commit complements the support for multiple signing certificate
	support in the metadata files. The use-case is still key roll-over.

	The structure LassoServerPrivateData was changed to accomodate multiple
	decryption keys, and so:

	 xmlSecKey *encryption_private_key

	became:

	 GList *encryption_private_keys

	All uses of this key were replaced by a loop over this list, terminating
	with the first key to be able to decrypt the content.

	The private key passed to lasso_server_new() or
	lasso_server_new_from_buffers() is first added to the list of decryption
	keys. Any other call to
	lasso_server_set_encryption_private_key_with_password() or
	lasso_server_set_encryption_private_key() will add a new key to the
	list.

2011-11-18  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'extension-abi-respecting'

	[saml2] add missing extension point for LassoSaml2SubjectConfirmationData
	 - it can support any content and any attribute without validation
	   xs:any with processContents="lax"

	[xml] allow to store XSchema data into a private stucture
	 - added new macros SNIPPET_STRUCT_MEMBER and SNIPPET_STRUCT_MEMBER_P
	   replaces use of G_STRUCT_MEMBER/_P macros.
	 - we use the GType of the class containing a given XmlSnippet to find
	   the proper private structure.
	 - added flag SNIPPET_PRIVATE to state XmlSnippet whose value
	   should be extracted from the private structure and not the public
	   one.

	[binding python] prevent warning in wrapper_top.c under hardy with gcc 4.2.4

	[core] add missing break to switch/case

2011-11-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings] fix bug introduced in last commit

2011-10-18  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings] fix tree traversal on windows
	 - The file path separator is not / on all platforms, so do not use it
	   when matching filenames.

	[misc] apply changes to remove warning blocking compilation with gcc 4.5.2 and php 5.3.5
	 - gcc now warns when you compate a typedef to the anonymous enum which
	   define it.
	 - some inline function in the zend.h header do compare between signed
	   and unsigned char.

	[xml saml-2.0] add missing annotation for binding generation to header for LassoKeyInformationDataType

2011-10-13  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[xml saml-2.0] add a class to handle the KeyInfoConfirmationData type
	 * use a direct mapping to map this class to SubjectConfirmationData
	   node having the xsi:type attribute.
	 * overload get_xmlNode method to add the xsi:type attribute on output.

	[xml] allow node classes to not defined their nodename, useful for simple Type

2011-10-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[id-wsf2 profile] check provider->private_data->roles instead of provider->role
	Fixes #140.

	[id-wsf discovery] provider can now contain multiple public keys, only consider the first key for id-wsf token generation
	ID-WSF never contemplated the fact that sometimes key roll-over happend
	(SubjectConfirmation can only containg on ds:KeyInfo), whatever...

	[saml-2.0] augment lasso_saml20_provider_get_first_http_method to verify presence of synchronous bindings

	[xml] if a SNIPPET_LIST_NODES as the SNIPPET_ANY flag, allows really any kind of node through LassoMiscTextNode

	[xml] allows LassoMiscText.init_from_xml to parse any xmlNode
	If the node has no attributes and has a simple string content, we use the
	classic embedding by setting, name, ns_href, ns_prefix. Otherwise the complete
	xmlNode is copied.

	[tests] add non-regression tests concerning the parsing of any xmlNode tree by LassoMiscTextNode when SNIPPET_ANY is used by a LassoNode

	[xml] only try to map an xmlNode to a class ame if the node has a namespace

	[xml saml-2.0] change AttributeValue snippets to accept any children
	An AttributeValue has an XSchema type of xs:any.

2011-10-07  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[xml] create a static version of lasso_node_new_from_xmlNode_with_type without error logging
	When used inside lasso_node_impl_init_from_xml the error logging is
	prematurely sent as there is a backup procedure for parsing unknown
	nodes inside a SNIPPET_LIST_NODES by creating a LassoMiscTextNode
	containing a copy of the parsed xmlNode child.

2011-09-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[configure.ac] default AM_MAINTAINER_MODE to enable

2011-07-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[configure.ac] remove useless semi-colons

	Fix wrong version exported in the PHP binding

2011-06-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Change the glob expression to match darwin $host_os
	Also use the $DARWIN flag to control the setting of JNI_EXTRA_LDFLAGS.

2011-05-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[java] try to make test works under Mac Os X

	[core] finish transition from single encryption key to multiple ones
	Some code still reference provider->private->encryption_public_key, this
	commit make them use lasso_provider_get_encryption_public_key().

2011-05-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings perl] remove --as-needed from linker flags, it is not supported evrywhere
	It can come back if we add proper checking of the support on the
	platform, maybe we can leverage tests made by autoconf.

	Disable metadata loading test with the UK federation files

2011-05-23  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'multi-certificates'

2011-05-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings perl] in Makefile.am, gives a default template to mktemp
	Thanks to Nathan Sowatskey for the bug report and the fix.

	[core] start of support multiple keys for encryption

	[tests] add unit test for the provider with multiple key feature

	[tests] add sample metadata for testing metadata with multiple key descriptors

2011-05-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] first try at multiple signing keys support
	The idea was to replace every use of an xmlSecKey* by a loop over a
	GList* of xmlSecKey*.

	 - In the structure LassoProviderPrivate changed
	    xmlSecKey*public_key            ->   GList* signing_public_keys
	    xmlNode*signing_key_descriptor  ->   GList* signing_key_descriptors.
	 - Renamed lasso_provider_try_loading_public_key to
	   lasso_provider_try_loading_public_keys and chaned its signature
	   accordingly
	 - Renamed lasso_provider_get_public_key to
	   lasso_provider_get_public_keys and changed the signature accordingly.
	 - Changed lasso_provider_get_encryption_public_key to return the first
	   signing key from the list as a temporary work around. Multiple
	   encryption keys will be supported later.
	 - Changed lasso_provider_load_public_key to load keys from the passed
	   file on the LassoProvider constructor, from every key descriptors
	   found for signing and eventually from the key descriptor marked for
	   encryption.
	 - Every failure to load from a file or an XML KeyInfo descriptor are
	   noew reported as warning.
	 - Query signature checking was completely moved to
	   lasso_provider_verify_query_signature and
	   lasso_provider_verify_signature now calls it.
	 - lasso_provider_verify_signature is now using lasso_verify_signature
	   from the xml/tools.o module.
	 - lasso_provider_verify_single_signature was modified to support
	   multiple signing keys.

2011-05-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[utils] add macros to append to and release a list of xmlSecKey*
	[core] make lasso_provider_verify_query_signature use lasso_provider_verify_signature

	[bindings perl] in Makefile.am, gives a default template to mktemp

2011-05-18  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[xml] use g_strndup instead of strndup, as it is more portable

2011-05-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[tests] fix broken renater metadata file
	A modification was introduced which broke the signature, updating to the
	last version.

2011-05-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[tests] move renater metadata files into the metadata/ subdirectory

2011-05-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[saml2] add proper error code for partial logout status code

	[saml2] fix build_request_msg for AuthzDecision assertion queries
	The servicepoints and roles arrays did not match the provider role
	enumerations.

2011-04-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[saml2] if Status is not Success pass continue processing the response
	lasso_saml20_login_process_response_status_and_assertion does analyze
	the response status code login specific error codes, if the generic
	processing from lasso_saml20_profile_process_any_response returns a
	status of response is not success, we must continue processing.

	[saml2] for any RequestDenied SAML2 response return LASSO_PROFILE_ERROR_REQUEST_DENIED as error

	[core] add a generic LASSO_PROFILE_ERROR_REQUEST_DENIED

2011-04-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] make LassoServerLoadMetadataFlag enum a typedef

2011-04-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'load-federation'

	[tools] redirect xmlsec errors to lasso error handler

	[tools] use LASSO_LOG_DOMAIN instead of magic constant

	[Makefile] move lasso/xml/tools.h to public headers

2011-04-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] add flags parameter to lasso_server_load_metadata to tune signature checking on metadata files
	The flags parameter allows to control the checking of digital signature
	upon EntityDescriptor and EntitiesDescriptor nodes in SAML 2.0 metadata
	files.

	The default behaviour is to check all found signatures and to inherit
	signature from EntitiesDescriptor to their children.

	By only enabling checking of EntityDescrtiptor node signatures it's also
	possible to only check signature at the EntityDescriptor level and so
	only trust individual entities and not the aggregating provider.

2011-04-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] update documentation of lasso_server_load_metadata

2011-04-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] make lasso_server_load_metadata load any metadata file
	The new code can load metadata file with a EntityDescriptor root node,
	and with nested EntitiesDescriptor.

	Idea and prototype by Olav Morken.

2011-04-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[server] in lasso_server_load_metadata do not duplicate checks already made by lasso_verify_signature
	lasso_verify_signature already checks that reference is to the given
	signed node, be it referenced through an ID or through an empty
	reference.

	[xml] if signature reference is empty check that signed node is the document root
	An empty reference means the complete document, so the signed node is
	the root element of this document. We must check that the parameter
	signe_node dmatches our assumption.

	[core] rename lasso_server_load_federation to lasso_server_load_metadata
	The aim of this function is now to load any metadata file, and to
	replace completely the use of lasso_server_add_provider.
	The metadata content argument is replaced by a metadata file path to
	more closely match other APIs.

	[web] update download page

2011-03-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] add a loaded_entity_ids output parameter to lasso_server_load_federation
	It allows to know which entity has been loaded from the metadata file.
	It must be freed by the caller.

	[core] add a blacklisted_entity_ids parameter to lasso_server_load_federation
	The goal is to prevent loading of provider known to have problems.

2011-03-29  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[tests] remove spurious output

	[tests] continue improving the lasso_server_load_federation test cases

	[tests] test lasso_server_load_federation
	The test operates on the metadata file of the french university network
	Renater.

	[tests] add renater federation metadata file for testing

	[core] add a lasso_server_load_federation method
	This method allows to load providers in bulk from what is called a
	federation file, i.e a SAML metadata file containing declarations for
	more than one provider. Those file are usually signed to bind some trust
	to its content, so lasso_server_load_federation can take an optional
	file path to a certificate chain file used to check the signature on the
	given XML content. Only same document signature is accepted (i.e. there
	must be only one XML signature reference and it should be to the empty
	string meaning the « current » document).

	[core] add a private constructor to build LassoProvider object from an xmlNode
	I'm not sure of the need outside lasso so I will let this method private
	for the moment. It's an helper method for the
	lasso_server_load_federation method which traverses an
	EntitiesDescriptor node to find all the EntityDescriptor contained
	inside.

	[saml2] add and internal method to load a federation metadata file
	It only loads one kind of provider (idp or sp). It's currently
	impossible for a provider to have the two roles at the same time toward
	a given LassoServer object, i.e. the current service is a service
	provider or an identity provider, it cannot be the two at the same time.

	[saml2] improve reporting of errors when loading a provider metadata file

	[xml] allow empty reference in XML signature (document signature)

	[xml] make id_attr_name parameter optional for lasso_verify_signature

2011-03-07  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[xml] fix lasso_node_get_xmlnode_for_any_type
	xmlCopyPropList does not copy the property list into the target it just
	copy it with respect to the target (mainly for namespace references).

	This patch adds the real copy into the target node.

2011-03-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[core] add missing namespace definitions to internal objects
	Identity, Lecp, Login, Logout, NameIdentifierMapping, NameRegistration,
	Session, AssertionQuery, Ecp and NameIdManagement objects were missing a
	namespace association to their GObject class. It broke when you try to
	dump a node created by lasso_node_new_from_dump.

	[tests] add test case for multiple load and dump of the same object

2011-02-08  Frédéric Péters  <fpeters@entrouvert.com>

	[debian] adapt packaging to official section overrides

	[debian] adapt packaging to official section overrides

	[debian] sync packaging with official package

	[debian] sync packaging with official package

2011-01-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'master' of git@dev.entrouvert.org:lasso

2011-01-25  Jean-Marc Liger  <jmliger@athena.siris.sorbonne.fr>

	[Fedora RPM] spec file update

2011-01-24  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[tests] change perfs to accept a second parameter giving the data files to use
	Also add metadata files to check performance with 512 and 1024 bit RSA
	keys.

2011-01-14  Frédéric Péters  <fpeters@entrouvert.com>

	[php5] Comments starting with '#' are deprecated

2011-01-05  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Remove right column with download, binary packages and source links
	It is redundant with other columns.

	[web] fix date and version in news 19

	[web] fix typo in news for release 2.3.5

	Merge branch 'hotfixes-2.3.5'

	[ŕelease] Add release notes, update doap files and website

	[dist] create Changelog directly from git

2011-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[tests] adapt Makefile.am to new path of metadata dir

	Merge branch 'hotfixes-2.3.5'

	[wsf] fix wsf preprocessor conditionals

	[bindings python] configure basic logging

	[ghashtable] add G_GNUC_UNUSED to remove unused static functions warning

	[saml2] when parsing short numbers reinitialize errno

	[bindings perl] fix get_hash_of_objects

	[bindings php5] remove hardcoding the php5 cli interpreter
	The test script did fail under Centos/Fedora because the interpreter for
	php5 is named php.

2010-12-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'hotfixes-2.3.5'

	[bindings perl] downgrade requirement on perl version to 5 instead of 5.10

	[bindings perl] downgrade require on perl version to 5 instead of 5.10

	Merge branch 'hotfixes-2.3.5'

	[xml] fix null pointer access in lasso_node_get_encryption

2010-12-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[configure.ac] increment version and libtool version info

	[saml2] fix errors in lasso)provider_get_first_http_method when a binding is unknown

	[saml2 provider] change critical messages to debug messages

	[saml2 profile] fix bug in binding_uri_to_http_method with the POST binding

	[saml login] suppress unused argument warning

2010-12-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[samlv2 logout] check that the assertion is well formed before accessing the subject nameid

	[profile] prefer to lookup the session before the identity for looking up a name identifier;

	[samlv2 logout] setup the NameID from the assertion

	[samlv2 login] do not setup conditions->notBefore/notOnOrAfter only notOnOrAfter on SubjectConfirmationData

2010-12-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[binding php5] add inline implementation of lasso_log since it is a private function of lasso

	[binding php5] add inline implementation of lasso_log since it is a private function of lasso

	Merge branch 'hotfixes-2.3.5'

	[saml2] make LASSO_SIGNATURE_VERIFY_HINT_FORCE as least as stringent as _MAYBE when checking signature on messages

	Merge branch 'hotfixes-2.3.5'

	[xml] remove duplicate EncryptedKey around EncryptedData elements
	The key is already embedded in the EncryptedData, so there is no need to
	also fill the EncryptedKey field of the saml:EncryptedElement object.

	[xml] add exportation of the encrypting public key in EncryptedData elements
	This commit check if the given is a simple RSA key or a full certificate
	and choose the better serialization method between RSAKeyValue and
	X509Data.

	[tools] fix xml decryption
	This commit rewrite the extraction of the EncryptedKey when it is
	embedded inside the EncryptedData element, which seem to be the frequent
	case.

	Merge with new field in custome element

	[saml2] use new encryption structure instead for internal field in LassoSaml2Assertion

	[xml] add field to contains encryption parameters inside CustomElement structure

	[utils] fix typo in lasso_assign_sec_key

	[bindings python] make constructor failure raise a lasso.Error exception

2010-12-13  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[saml2] do not set SPNameQualifier it should be reserved for SP member of an affiliation

2010-12-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'hotfixes-2.3.5'

	[tests idwsf2] add missing include for ID-WSF strings

2010-12-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[tests] include the backward compatibility include for GHashTable

	[bindings perl] change ghashtable interface to not use GHashTableIter

	[bindings perl] add dependency upon the Makefile.perl for the install target

2010-11-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings] add missing static modifier for g_hash_table_get_values replacement

	[tests] include header for backward compatible methods on GHashTable structures

2010-11-15  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[bindings] fix bad use of lasso_return_if_fail in ghashtable backward compatibility header

2010-10-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'hotfixes-2.3.5'

2010-10-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] fix segfault in has_signature by initializing local variables

2010-10-13  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'hotfixes-2.3.4'

	Merge branch 'hotfixes-2.3.4' into release

	Update doap and news file

	Update NEWS file

2010-10-11  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[tests data request] add googleapps sample AuthnRequest

	[tests] move metadata directory into data

	[tests data] add idp and sp example with 1024 bits RSA keys, for performance testing purpose

	[tools] add a repository for semantic patches as reference

	[tests metadata] add more examples of metadata files

	[tests integration] adapt to string change in lcs/qommon/saml2.ptl

	[SAMLv2] delete an unused local variable

	Merge branch 'hotfixes-2.3.4'

2010-10-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] user server->signature_method when signing request and response

	[tests] add non regression test on assertion consumer endpoints ordering

	[core] check type of first argument of lasso_provider_get_assertion_consumer_url

2010-10-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	fix pardus capitalisation in NEWS file

	Merge branch 'hotfixes-2.3.4'
	Conflicts:
		lasso/xml/xml.c
		website/web/download/index.xml
		website/web/index.xml

	Update release notes and website for release 2.3.4

	[xml] fix waring on use of strndup on pardus

2010-10-08  Jérôme Schneider  <jschneider@entrouvert.com>

	Add missing include <errno.h>

2010-10-07  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] handle unknown provider in artifact resolve, and also alow to ignore signature validation
	In lasso_saml20_profile_process_artifact_resolve, we know take a short
	path with an error when the remote provider is unknown and we also
	respect the lasso_profile_get_signature_verify_hint() when checking the
	signature on the artifact resolve message.

	[SAMLv2] fix bad double free bug in lasso_saml20_provider_get_assertion_consumer_service_url_by_binding

	[core] adapt lasso_provider_get_assertion_consumer_service_url for SAMLv2

2010-10-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[docs lasso-book] add figures to the tarball

2010-10-06  Jérôme Schneider  <jschneider@entrouvert.com>

	Add missing include <errno.h>

2010-10-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'hotfixes-2.3.4'

	[configure.ac] increment version and libtool version info

2010-10-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[ID-FFv1.2] in lasso_login_process_authn_request_msg() adopt simpler behaviour for checking signatures
	There is two sources of advice for signature checking:
	AuthnRequestsSigned attribute in service provider metadata files and
	value of lasso_profile_get_signature_verify_hint().

	If lasso_profile_get_signature_verify_hint() forbid to check signature,
	we do not check.
	If the SP advise to check signature, we check.
	If lasso_profile_get_signature_verify_hint() forces to check signature,
	we do not check.
	In all other cases we only check if a signature is present, i.e. we
	ignore the error LASSO_DS_ERROR_SIGNATURE_NOT_FOUND.

2010-10-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[ID-FFv1.2] make lasso_login_process_authn_request_msg() return LASSO_PROFILE_ERROR_INVALID_MSG if received request is not a lib:AuthnRequest

	[SAMLv2] adopt same behaviour as ID-FFv1.2 for invalid AuthnRequest

	[SAMLv2&ID-FFv1.2] improve documentation of lasso_login_process_authn_request_msg

	[SAMLv2] fix ordering of endpoints
	Ordering by binding is wrong, first order by isDefault (as stated in
	saml-metadata-2.0.pdf) then by index.

	[Core] change isdefault type in EndpointType structure
	As integer we can represent the three value of isdefault:
	- true
	- false
	- attribute absent

	[docs] update copyright years

2010-10-05  Frédéric Péters  <fpeters@entrouvert.com>

	[website] "Subversion Status" -> "Git Status"

	[website] Only keep two latest news items

	[website] Fixed 2.3.3 release date

	[website] Update right download box for 2.3.3

	[website] Don't duplicate link to git repository in link text

	[website] Refer to Git in buildbox title

	[website] Updated copyright years

2010-10-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Website] Fix bad date

	[Web] chmod +x on convert-to-static.py

	[Web] update links for download v2.3.3, add lines to feature matrix

	[Web] add news file about 2.3.3

	Merge commit 'v2.3.3'

2010-10-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'hotfixes-2.3.3' into release

	[Website] add news about 2.3.3 and update doap and main page

	[Release] add release notes

2010-10-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] restore setting of SubjectConfirmationData->NotOnOrAfter
	This was wrongly removed by me in commit
	9d22f29e55524034dfda34c15b76f1b0b78c4413.

	This is the responsability of the caller to adjust value on the
	Conditions and SubjectConfirmationData independently after.

2010-10-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Binding java] replace use of strcmp by g_strcmp0

	[Tests] add annotation to remove compiler warnings

	[Core] replace all use of g_strcmp0 by lasso_strisequal and lasso_strisnotequal
	Too much human errors with strcmp kind of functions. Also change name os
	lasso_is_empty_string to lasso_strisempty.

	[Core] add helper API for string comparaison
	It should remove most errors when comparing strings.

	[SAMLv2] add missing compare to 0 introduced in 7386dc8189
	I hate strcmp.

2010-09-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Bindings] change prefix for ignoring soap_binding related files

	[SAMLv2] also initialize Destination for response messages
	asynchronous bindings needs Destination attribute even for response
	messages.

	[SAMLv2] when NidPolicy->Format is NULL or unspecified, return transient
	Add more default cases.

2010-09-29  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Tests] update perfs to test each phase of WebSSO separately and use SAMLv2
	I removed signature at the message level for the response, it should
	simulate apporiately the artifact binding with SSL transport.

	[Bindings] restore presence of SOAP nodes
	The node to exclude when ID-WSF is disactivated was soap_binding_ ones.

	[Core] fix break of lasso_profile_get_request_type_from_soap_msg from commit b9d535625
	ManageNameIDRequest is not an ID-WSF kind of request.

2010-09-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Core] add missing annotation to lasso_*_dump functions
	The string returned by these functions is newly allocated and must be
	freed by the caller.

	[ID-WSFv1] fix other misuses of the macro lasso_foreach

	[SAMLv2] fix wrong order in use of macro lasso_foreach
	The first argument must be the iterator, the second is the iterable.
	Also add a non-regression test with Googleapps metadata and and a
	typical authn request.

2010-09-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] fix early release of the request when using idp_initiaed login

	[SAMLv2] fix memleak of request in lasso_name_id_management_process_request_msg

	Add files to .gitignore

	[Tests] remove a valgrind suppression on g_log_default_handler

	[Tests] add valgrind targets in the Makefile: leakcheck, leakcheck-reachable and massif

	[SAMLv2] fix memleak of request in lasso_saml20_login_process_authn_request_msg

	[Core] fix leak of provider->private_data->endpoints

	[Tests] fix leak of content in test01_server_new

	[Tests] fix leak of idpLogoutContext in test04_sso_then_slo_soap

	[Core] fix leak of provider->private_data->endpoints

	[XML] fix memleak in lasso_node_export_to_soap

	[XML] fix memleak of xmlSecKeyMngr when loading a key from a KeyInfo node

	[XML] fix memleak in get_xmlNode for LassoSamlp2LogoutRequest

	[XML] fix memleak in get_xmlNode for LassoSamlp2Response

	[SAMLv2] add missing stack variable initialization

	[SAMLv2] fix unused variable warning

	[SAMLv2] in profile.c fix uncovered enumeration value in switch

	[XML] fix unused variable warnings

	[XML] fix mem leak whene releasing CustomElement structures

	[Tests] fix mem leaks

	[SAMLv2] fix mem leaks

2010-09-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2 NID management] report signature error in response, do not check response signature if forbidden
	 - build_response_msg will report signature error in response status
	   code when called without an initialized response (without a call to
	   validate_request)
	 - process_response_msg now use
	   lasso_saml20_profile_check_signature_status to check the signature
	   status only if permitted.

2010-09-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] move check for signature status to lasso_saml20_build_response_msg
	And also handle the signature verification hint. If process_msg fails,
	you must just call build_response_msg directly.

	Only check the signature on the response if asked, most applications
	should not care.

2010-09-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[configure.ac] increment release version and libtool version info

	Add files to .gitignore

2010-09-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] apply the LassoProfileVerifySignatureHint when processing requests
	The check was missing for processing of logout requests, name id
	management request and assertion query responses.

	A new internal function lasso_saml20_profile_check_signature_status is
	added.

2010-09-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[ID-WSFv1&ID-WSFv2] separate better strings for ID-WSF from other strings
	Code in core source file which depend upon ID-WSF symbols have been
	conditionalized, and each id-wsf source file now include directly its
	need string header.

2010-09-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branches 'master' and 'release' of bdauvergne@xen3.lycope.priv:/var/git/lasso into release

2010-09-08  Frédéric Péters  <fpeters@entrouvert.com>

	News entry for 2.3.1 & 2.3.2 (combined)

2010-09-07  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'hotfixes-2.3.2' into develop

	Merge branch 'hotfixes-2.3.2'

	Increment revision in version

	Update files for release 2.3.2

	Fix lasso soname change
	If new interfaces are added, first and last number must be incremented.
	As new enumeration value have been added, this is the case.

	Merge commit 'origin/master'

	Merge branch 'hotfixes-2.3.1' into develop

	Merge branch 'hotfixes-2.3.1'

	Update files for release 2.3.1

	[SAMLv2] when no artifact message is present, still return a success status
	It is mandated by the specification.

2010-09-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Tests integration] fix configuration variable name

2010-09-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Merge branch 'develop' into hotfixes-2.3.1

	[Core] fix memory leak in lasso_endpoint_free

	[ID-FFv1.2&SAMLv2] add more warning for failure to load metadata file
	Report detailf of the failure through warning log.

	[SAMLv2] when failing to recreate the content for the ArtefactResponse set a lasso specific status code

2010-09-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] change the way content is stored and loaded for the HTTP-Artifact binding
	Previously content was stored as the result of lasso_node_dump method
	then reloaded, and then serialized again as part of the ArtifactResponse
	message. lasso_node_dump was ignoring all hint to sign node, but keeping
	the needed parameters around. That's not what must be done, the
	signature should happen at the generation of the artifact and the result
	must manipulated as is (i.e. XML content) and never moved back to the
	land of LassoNode objects.

	Now the content is:
	- first removed of any signature at the message level, because the
	  ArtifactResponse will take care of this, (any signature under this
	  level (like at the assertion) is kept),
	- serialized using lasso_node_export_to_xml,
	- reloaded using lasso_xml_parse_memory,
	- and put into the ArtifactResponse using a
	  lasso_misc_text_node_new_with_xml_node.

2010-09-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] make lasso_saml20_profile_generate_artifact a static function
	It is only used in lasso/saml-2.0/profile.c anyway.

2010-09-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Core] load signature parameters
	Generic signature parameters (attached as qdata to nodes) is now
	reloaded when initializing a node from XML for a node type with a
	signature snippet in its metadatas.

	It fixes the problematic usage of ciphered private keys with the
	HTTP-Artifact binding (which needs to keep a copy of the AuthnResponse
	around and to sign it later).

2010-09-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Core] add private function to read an integer attribute
	This function does integer parsing and range checks, it returns TRUE if
	all goes well.

	[Core] add LAST enum values to LassoSignatureMethod and LassoSignatureType enumerations
	It helps making range checks.

2010-09-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Strings] add string constant for the internal XML attributes used in dumps
	Add string constants for signature method, signature type, private key
	(file path or content), private key password and certificate (file path
	or content).

	Add cast for xmlChar constant strings definition in python bindings, it
	assumed all constant strings were char*.

2010-08-31  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[DOAP] fix typos
	Tags were badly formatted.

2010-08-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] mark Redirect binding as an invalid binding for return AuthnResponse
	This is really not supported by the SAMLv2 protocol.

	[SAMLv2] fix string in comment

	[SAMLv2] replace use of lasso_provider_get_default_name_id_format with direct use of lasso_provider_get_metadata_one_for_role
	The first is trying to use provider->role to know which kind of role
	descriptor to lookup, but for the server object this field is 0 and when
	building authn request we know that we want our default NameIDFormat for
	the SP sso descriptor.

2010-08-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] rebuild specialized LassoProvider methods upon new endpoints storage
	The new way of storing endpoints allows to keep ordering between
	endpoints with respect to the order of the index and isDefault field for
	indexed endpoint type, and to the XML node orders for other endpoints.

	It also simplifies the code.

2010-08-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Core] add destroy code for new private field endpoints
	The contained string must be disallocated if the object is destroyed.

	[Core] add structure to store endpoints type for metadata files
	This new C structure will allow to filter ID-FFv1.2 and SAMLv2 endpoints
	more easily.

	[XML] use strtol instead of atoi to parse XSchema integers
	This commit also reject negative integers from being parsed (all integers
	in SAMLv2 and ID-FFv1.2 schemas are positive integers).

	[SAMLv2] when AuthnRequest contains invalid attributes returns INVALID_REQUEST not NO_DEFAULT_ENDPOINT
	This is the right status to return.

2010-08-25  Frédéric Péters  <fpeters@entrouvert.com>

	Fixed underlining of title

2010-08-05  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Core] fix change of enumeration value
	This change broke the API, revert it.

2010-07-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Website] update download link on front page

	[Website] fix typos

	[Website] fix source and download links
	The source repository is now the git repository on dev.entrouvert.org.
	Latest source release is 2.3.0. And git browser is included in our
	redmine.

2010-07-27  Benjamin Dauvergne  <bdauvergne@lupin.entrouvert.com>

	[Website] change position of Download block in right bar

	[Website] in convert-to-static.py, work around errors in build logs
	If Build() constructor fails, keep going.

2010-07-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Website] fix wrong structure for the news file about release 2.3.0

	[Website] import convert-to-static.py modification from lupin

	[Website] add news file aboute release 2.3.0

2010-07-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Website] fix non escaped ampersand

2010-07-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Release] update libtool version

	[Website] update download links

	[Release] Update version number from 2.3 to 2.3.0

	[Release] update release date in NEWS file

	[Release] update ChangeLog

	[Release] Lasso 2.3
	 - update the NEWS file
	 - add abi-2.3 file
	 - update DOAP files
	 - update lasso website template
	 - add temporary message to download pages, as there are no download
	   links currently.

	[Core] add logos to EXTRA_DIST

	[Core] add HACKING to EXTRA_DIST

	[Documentation] add missing declaration to lasso-sections.txt

	[Tests] change the way tests data is distributed
	Instead of using a Makefile.am in each data directory, each data
	directoy has been added to the EXTRA_DIST for the parent directory
	Makefile.am.

	[Core] remove now useless .cvsignore files

	[Core] remove now useless .cvsignore files

	[Binding perl] move DISCLEANFILES and CLEANFILES outside of the condition clauses

	[Tests] move sourceid-2.0beta-data to data directory

	[Core] move format-suppressions.py to tools directory

	[Core] add README.JAVA and README.WIN32 files to EXTRA_DIST

	[Core] complete README.JAVA about later release of gcj

	[Core] add lasso.doap to EXTRA_DIST

	[Core] add errors.c to EXTRA_DIST

	[Core] remove unused build-strerror.pl

	[Doc] move style.css to the reference directory, and add it to EXTRA_DIST

	[Bindings] improve cleaning and distribution buiding

	[Tests java] remove Test.java
	Local test file wrongly commited.

	[Makefile] add abi to EXTRA_DIST

	[Binding perl] add DISTCLEANFILES for Makefile.perl.old file

	[Tests] remove debugging printf

	[Tests] change the way tests data is distributed
	Instead of using a Makefile.am in each data directory, each data
	directoy has been added to the EXTRA_DIST for the parent directory
	Makefile.am.

2010-07-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Tests] adapt java unit tests to new semantic for list fields
	GList fields now return an empty list, not null.

2010-07-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] simplify logic for handling AuthnResponse with binding HTTP-Post
	The logic is now simpler:
	 - first lasso_saml20_profile_process_any_response check the signature
	   on the message
	 - then lasso_saml20_login_process_response_status_and_assertion
	   traverse all the assertions:
	   - if the message is signed all assertion from the same issuer are
	     automatically accepted,
	   - if the message is not signed, or the signature validation failed,
	     or the assertion has a different issuer than the message, we check
	     the signature directly on the assertion. If any of the assertions
	     fails the signature check, the result will be
	     LASSO_PROFILE_ERROR_CANNOT_VERIFY_SIGNATURE.

	The public field profile->signature_status will contain only the message
	level signature status, each assertion signature status is not
	accessible. That will change when signature and key handling is
	reworked.

2010-07-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Binding perl] fix broken distclean-local target
	The TOCOPY files need to be cleaned only for out of source directory
	builds.

2010-07-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] comment on SessionIndex support hack

	[SAMLv2] remove empty files, wrongly committed

2010-07-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2/SSO] when processing AuthnResponse with binding HTTP-Post only the assertion need to be signed
	If the message is signed, the assertion is also covered, but if only the
	assertion is signed, there is no error to report. If the caller ask for
	forcing the validation of message signature, then we report an error.

	This commit also add checking for the binding used, if it is not
	HTTP-Post lasso_login_process_authn_response_msg will now report an
	error.

2010-07-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Binding java] return empty list for NULL GList value, not null

	[ID-FFv1.2] add missing namespace declarations

2010-07-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] add support for encrypted private keys
	 * support private key with new internal API in signature setting
	   methods

	Plug lasso_node_set_signature into
	lasso_profile_saml20_setup_message_signature and
	lasso_server_saml2_assertion_setup_signature.

	 * also use lasso_node_get_signature in has_signature

	 * add forgottent LASSO_PROFILE_SIGNATURE_VERIFY_HINT_FORCE in switch
	   cases

	For AuthnResponse checking the semantic is now that if HINT_FORCE is
	used we verify message signature *and* assertion signature. If
	HINT_MAYBE is used we check the assertion signature if its issuer
	differs from the message issuer.

2010-07-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[ID-FFv1.2] move all user of lasso_node_export_to_query to lasso_node_export_to_query_with_password

	[Core] Change lasso_apply_signature to use quark stored annotated signature parameters
	The node containing signature do not handle the private keys passwords.
	As the fields for signature parameters are part of the public ABI we
	cannot add the password field to the public structure for those nodes.
	Instead we use the new quark annotation accessed through
	lasso_node_get/set_signature, and if the sign_type parameter is non-NULL
	we use it instead of the parameters stored in the public structure.
	This is a gross hack :( but at least it is documented.

	[Core] add password parameter to lasso_sign_node

	[Code] add a lasso_node_export_to_query_with_password method

	[Core] add a password parameter to lasso_query_sign
	We force use of the password through a custom OpenSSL password callback.

	[Core] dump custom signature parameters in lasso dumps
	The signature parameters are serialized as global attributes from the
	http://lasso.entrouvert.org/lasso/namespaces/0.0 named:
	SignatureType
	SignatureMethod
	PrivateKey
	PrivateKeyPassword
	Certificate

	[Tests/python] add test case for WebSSO with providers using encrypted keys

	[Core] add lasso_node_set_signature and lasso_node_get_signature
	Those two methods allows to associate signature parameters to any node.
	They keep it inside the CustomElement quark. Using a private structure
	may be more performant.

2010-07-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Core] extract signature adding into base class method lasso_node_get_xmlNode
	In order to permit subclass to modify the base xmlNode created by
	lasso_node_impl_get_xmlNode we must defer the concrete to the virtual
	method wrapper, lasso_node_get_xmlNode.

	To do that it whas needed to make id_attribute another virtual field of
	LassoNode subclasses (it can be accessed through an offset registered in
	the class object).

	This commit solves signature validation error since the patch for
	managing more than one SessionIndex element in samlp2:LogoutRequest.

	It also factorize the creation of signatures in one place.

2010-07-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[SAMLv2] if service provider supports logout, add a SessionIndex from the assertion ID
	The standard mandate to provide a SessionIndex to service provider
	advertaising their support of the logout profile. We follow the
	convention of using the assertion ID as a SessionIndex.

	[Tests] add a sso then slo soap test

	[Core] lasso_check_version does not return a proper error code
	lasso_check_version returns 0, 1 or -1 and one is not a proper error
	code, so the original int return type is kept.

	[Bindings] make is_rc only check for lasso_error_t type

	[Bindings php5] simplify is_object in php_code.py

	[Core] change return type of all error returning methods
	The new return type is lasso_error_t, it should allow to pinpoint easily
	methods returning an error code in bindings.

	[Bindings java] use is_int instead of custom methods or code

	[Bindings perl] add lasso_errot_t to type to map to T_IV typemap (integer types)

	[Bindings] add lasso_error_t to return code types

	[Binding java] use is_rc to match error return type

	[Binding php5] use is_rc to match error return type

	[Core] add lasso_error_t to list of integer types

	[Core] add a lasso_error_t typedef
	This typedef will serve to mark error returning methods.
	The ctypes.h header piggyback on export.h to be included in all public
	headers.

2010-07-05  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Provider] Fix loading of provider without a public key
	This commit also emit propre warning when loading fails for a provider
	*with* a public key.

	[Python binding] do not throw lasso.Error for python exceptions

2010-06-29  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Perl binding] make include from $(srcdir) works in Perl binding

	[Bindings] accept simple string in string<->xmlNode converter
	Some use case ask for passing simple libxml content node (i.e just an
	UTF-8 string) when a method argument or a field of the xmlNode* type.
	This commit add a static method in bindings/utils.c named
	lasso_string_fragment_to_xmlnode which does this transform by trying to
	parse an XML document then by trying to parse a well balanced XML
	fragment of only one node (if there is more than one node such as in the
	string " xxx <tag/> yyy ", we free the node list and return NULL).

	[Core] add macro to release an xmlNodeList object

	[ID-WSF2] add idwsf2 test script to test suite
	Re-activate ID-WSF 2.0 test script. Fix problem with provider issuing
	assertion role. Need to be fixed more generally in the future.

	[Core] add macro to release GList of xmlNodeList

	[Core] add macros to manipulate xmlNodeList and GList of xmlNodeList
	The method to copy them is xmlCopyNodeList and not xmlCopyNode, so we
	need another set of macros.

	Merge branch 'issue-101'

	Merge branch 'issue-88'

	Merge branch 'issue-86'

2010-06-18  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[Tests/integration] add G_DEBUG=gc-friendly env. var to valgrind-wrapper
	It should improve valgrind ability to trace memory origin.

2010-06-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	[XML] in lasso_node_export_to_paos_request check return value of lasso_node_get_xmlNode

	[XML] in _lasso_node_export_to_base64 check return value of lasso_node_export_to_xml

	[XML] in _lasso_node_export_to_xml check return value of lasso_node_get_xmlNode

2010-06-15  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Comment out custom silent rules if automake < 1.11

	[Core] do not ignore keep_xmlnode flag inherited from parent classes
	We only looked to the keep_xmlnode flag in the node data of the top
	level class, but any parent class can set this flag and in this case we
	must honor it too.

2010-06-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Test: add non regression test for reloading a server dump with encrypted keys

2010-06-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: when reloading a dump, use the signing private key password for loading the encryption private key
	We currently do not store the encryption private key, instead on reload
	of a dump, we try to use the signing private key as the encryption
	private key. But we forgot to use the stored private key password.
	That's now fixed.

	Next step would be to keep the encryption private key around also.

2010-06-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Binding python: fix freeing of list return values for methods with the transfer full flag
	The output 'print' were missing, oups :(

2010-06-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Binding python: find a work around for random behaviour of PyImport_ImportModule
	 * it seems that PyImport_ImportModule is not deterministic. Sometimes it
	   returns True for modules which we know are present ('logging').
	   Importing 'sys' first seems to make 'logging' accessible (complete
	   cargo cult programming).

	Core: move logging function and macros to their own module, adapt perl binding

	Core: move lasso_strerror declaration to errors.h

	add .gitignore file

	Tools: add check-makefile.sh script to tools

	add abi file for 2.2.91

	Tests: add idp6-saml2 data

	Test: add python test for attribute requesting
	 * What's tested:
	  - request initialization
	  - adding attribute designators
	  - building the request message
	  - processing the request message
	  - accepting the request
	  - adding assertion with attributes
	  - signing the assertion
	  - building the response
	  - parsing the response

	SAMLv2: rename lasso_saml2_name_id_build_persistent to lasso_saml2_name_id_new_with_persistent_format
	 * keep the old one for compatibility
	 * new one will be picked by bindings as a constructor

	SAMLv2: when initializing signture on assertion, setup an ID if there is none
	 * without the ID lasso refuse to sign (it's mandatory)

	SAMLv2: in lasso_assertion_query_build_request_msg setup nameid
	 * lasso_profile_get_nameIdentifier does not return profile->nameIdentifier
	,
	   so we first try to use profile->nameIdentifier and if it is NULL we use
	   lasso_profile_get_nameIdentifier.

	Binding python: fix bad refcounting in get_logger and lasso_python_log

2010-06-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: update lasso_iso_8601_gmt_to_time_t to support milliseconds
	 * We now support the two possible formats for xsdtime XSchema datatype:
	    - dddd-dd-ddTdd:dd:ddZ
	    - dddd-dd-ddTdd:dd:dd.d*Z

	   Where d denotes a digit, and * is the kleene star.

	   XSD datetime also supports negative years, but as we cannot represent
	   them with time_t, we can reject it at the lexical level.

2010-06-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Documentation: add new AssertionQuery methods to documentation

	Tests: new python test for setEncryptionPrivateKeyWithPassword

	Fix long lines in lasso/id-ff/server.c

	Core: add method lasso_server_set_encryption_private_key_with_password
	 * fixes #91.

	SAMLv2: add new methods to class LassoAssertionQuery
	 * lasso_assertion_query_add_attribute_request:
	   helper to setup request attribute for AttributeQuery messages.
	 * lasso_assertion_query_get_request_type:
	   method to find the type of the last received query.
	 * fixes #90

	SAMLv2: fix initialization of subject in lasso_assertion_query_build_request_msg

	Import tools in utils.h

	Fix collision between defined symbols in tools.h and private.h

	Binding python: if lasso.logger exists use it for logging
	 * There is now two paths to get a logger in the python binding:
	   - first try to get an objet from lasso.logger
	   - if it doesn't exist or is None, the try logging.getLogger('lasso')

2010-06-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Change all logging to use message()

	Core: in xml error message handler, escape messages to fit on one line

	Core: remove arrow in log messages

	Binding python: call lasso_init() first in init_lasso()

	Binding python: add GLog handler to redirect logs to Python logger named "lasso"
	 * fixes #20

	Utils: add function to extract/create node in lists
	 * lasso_extract_gtype_from_list_or_new will help for method with create
	   or extend nodes in lists.

2010-06-09  Frederic Peters  <fpeters@entrouvert.com>

	Add new lasso_log_set_handler and lasso_log_remove_handler functions
	They are modeled around the g_log... functions of GLib, they just don't
	have a domain parameter.

2010-06-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Binding perl: fix test so that it does not raise on add_provider

	Bindings: keep retro compatibility for member field names
	 * Special kludge price go to PHP:
	   methods name are insensitive so nothing to do here, BUT, if you use
	   getters/setters then your objects fields can be case insensitive too
	   ;-) (DNS, dns, DnS, dNs all maps to get_dns ).

	Bindings: fix camelcasing of id fields

	SAMLv2: make role checking inactive for LassoServer
	 * LassoServer have no role defined, so checking breaks loading of
	   metadata for LassoServer.

	ID-FFv1.2: for idp initiated sso accept any nameIdPolicy
	 * IdP initiated SSO can be of any kind, no need to limit it.

2010-06-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0: add checks for proper loading of role descriptors
	 * remove warning for descriptors supporting non SAML 2.0 protocols
	 * checks that at least one descriptor was loaded and that it was for
	   our assigned role.

	SAMLv2: fix error in naming of function in the documentation

2010-05-31  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAMLv2: remove HTTP-Redirect as right binding for AssertionConsumer

	SAMLv2: fix bug giving UnuspportedProfile for SingleSignOn with HTTP-POST
	 * The string constant in lasso_saml20_provider_accept_http_method was
	   HTTP-Post instead of HTTP-POST.

	Core: fix extraction of relaystate when URLs contains only one kind of separators

	Integration test: adapt to new behaviour for federation termination

	SAMLv2: simplify lasso_saml20_provider_accept_http_method by only checking for remote provider support
	 * Whatever we do, with asyncrhonous bindings the remote provider can
	   return the response with any asynchronous binding.

	SAML 2.0: in lasso_login_build_assertion set conditions time limit, no SubjectConfirmationData limits

	SAML 2.0: in lasso_login_build_assertion do not conflate sessionNotOnOrAfter with assertion condition notOnOrAfter

2010-05-11  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Website: add quicklinks for download links

	Change VCS viewer link to point toward the redmine browser

	SAMLv2: conflate Responder and Requester when checking second level status code
	 * lasso/saml-2.0/login.c:
	   I'm not sure that most IdP really make the semantic distinction
	   between those two first level status codes, so just conflate them.

	SAMLv2: remove warning message for invalid signature on AuthnResponse messages
	 * lasso/saml-2.0/login.c:
	   we already return an error, no need to clutter the output with
	   warning messages.

2010-05-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Website: add a link to a tarball of the documentation extracted from the SVN

2010-05-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0 Helper: add lasso_saml2_assertion_set_one_time_use

	Fix bad initialization of an rc field from revision 4837

	Change <p> tags to <para>

	Add a lasso_profile_get_signature_status method

2010-04-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Initialize all uninitialized rc variables

	Test: only test custom namespace if ID-WSF is enabled

2010-04-28  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	in lasso_idwsf2_data_service_build_response_msg, allows SOAPFault as responses

	Fix uninitialized local variable

	in lasso_session_count_assertions, do not emit warning if session is not an object

	SAML 2.0: always restart initial request processing in lasso_logout_build_response_msg
	 * Does it also in process_response_msg if no more assertions are
	   present.
	 * Take into account that lasso_saml20_profile_process_any_response
	   already check for the status code, and so specify finer error code in
	   the cleanup code.

	SAML 2.0: fix lasso_saml20_provider_get_first_http_method
	 * LassoServer object can have many roles, use the default role of the
	   remote provider to decide on which to assume.

	SAML 2.0 Logout: in init_request, remove the assertion anyway
	 * lasso/saml-2.0/logout.c:
	   when initiating a logout, if no problem is found, remove the assertion.
	   you can always continue by changing profile->http_request_method to
	   SOAP for example and redo a build_request_msg.

	SAML 2.0: lasso_saml20_profile_process_any_response_msg, change status code checking

2010-04-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0: lasso_logout_build_response_msg, just verify there is saved data from a previous request before switching them
	 * lasso/saml-2.0/logout.c:
	   There is no need to check what the previous remote provider ID was,
	   just that initial_remote_providerID is not NULL in order to switch
	   request, response and remote_providerID.

	Fix wrong change g_free -> lasso_release inside example code

	Provider: fix problem when reusing the same lists nodes in Descriptors

	Improve safety by replacing all g_hash_table_destroy use by lasso_release_ghashtable

	Improve safety by replacing all g_list_free use by lasso_release_list

	Improve safety by replacing all g_string_free use by lasso_release_gstring

	Improve safety by replacing all g_free use by lasso_release

	Start an example listing for an IdP SingleSignOn endpoint

	Free xmlSecKey

	Fix potential SEGFAULT in _lasso_node_free_custom_element

	Utils: add lasso_assign_list

	Add lasso_release_gstring

	Utils: add lasso_release_ghashtable

	SAML 2.0 Profile: remove unused must_sign variable

	First try to check that objects are fully functionals before proceeding

	Fix potential SEGFAULT of an unknown provider

2010-04-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0: in lasso_saml20_process_federation, only handle the case of PERSISTENT format
	 * lasso/saml-2.0/login.c:
	   in lasso_saml20_process_federation:
	   - if no name id format can be found by the request, use the default from
	     the metadata file (first declared NameIDFormat)
	   - instead of checking if format is TRANSIENT, check if it is PERSISTENT,
	     and proceed with the federation, if not just return 0.
	   - return LASSO_PROFILE_ERROR_UNKNOWN_PROVIDER instead of
	     LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND.
	   - in any case, check for consent.

	SAML 2.0: in lasso_saml20_login_validate_request, do not check signature if not necessary

	SAML 2.0: find binding when only AssertionConsumerServiceURL is set, do not check signature on request if asked

	SAML 2.0: add internal method to retrieve the binding for an URL

	Login: add internal function _lasso_login_must_verify_*signature

2010-04-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Login: remove symbol markers in example code

	Fix documentation problems

2010-04-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Ameliorate support for lasso_profile_set_signature_verify_hint
	 * lasso/id-ff/profile.h:
	   - add end symbol for enum LassoProfileSignatureVerifyHint
	 * lasso/id-ff/profile.c:
	   - fix documentation of lasso_profile_set_signature_verify_hint
	   - do not allow to set or return invalid value for the
	     signature_verify_hint attribute.
	 * lasso/saml-2.0/login.c:
	   - handle new enum value
	 * lasso/saml-2.0/profile.c:
	   - handle new enum value
	   - fix missing catch of signature error reporting when
	     signature_verify_hint is IGNORE.
	 * docs/reference/lasso/lasso-sections.txt:
	   - export enums LassoProfileSignatureHint and
	     LassoProfileSignatureVerifyHint
	 * tests/metadata_tests.c:
	   - fix test of all Role enumerations

2010-04-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Revert "Core: add XML schemas for SAML 2.0"
	This reverts commit 5250c2c89e3983189a3c52cd85ad221ff7b6f64b.

	SAML 2.0: add Destination attribute to requests
	 * lasso/saml-2.0/profile.c:
	   this change make Lasso respect paragraphs 3.4.5.2 (HTTP-Redirect
	   binding securit considerations ) and 3.5.5.2 (the same for HTTP-Post)
	   of the saml-bindings-2.0-os.pdf document, and should allow our Authn
	   Requests to be accepted by shiboleth IdP.

	Tools: add usage statement to check-lasso-sections.py

	Docs: add/remove symbols from lasso-sections.txt

	ID-WSF 2.0 DST: make lasso_idwsf2_data_service_set_status_code works event if no response is initialized

	Tests: add tests for custom namespace functions

	ID-FF 1.2 & SAML 2.0: factorize access to role prefix

	Tests: make role descriptor loading test less verbose
	 * tests/metadata_tests.c:
	   remove printf, add checks

	Tests: show actual value in check_equals test macro

	XML: add custom namespace definition handling

	SAML 2.0: fix default assertion consumer handling when isDefault is missing
	 * if no default_assertion_consumer value is set after traversing the
	   list of endpoint, try to find the first one without isDefault="false"
	   and finally take the first one.

	SAML 2.0: fix default assertion consumer handling
	 * the default one is the first with the attribute isDefault not the
	   last.

	Binding python tests: update idwsf1 to explicitely register PP10 HREF

	Binding python: update idwsf2 test for method change dst.initResponse -> validateRequest

	XML: do not register any DST namespace by default

	XML: add a SNIPPET_COLLECT_NAMESPACES snippet to DstRefResultQuery

	ID-WSF 2.0 Data Service: new accessor, fix use of build_unique_id, change init_response to validate_request

	Core: add a SNIPPET_COLLECT_NAMESPACE snippet type
	 * lasso/xml/private.h lasso/xml/xml.c:
	   add a new primary XmlSnippet type for collecting all namespace
	   declaration, following parent relation on current node or one of the
	   child nodes.

	Binding python: fix use of raise_on_rc, simplift Node.__setstate__

	Revert "Make lasso_node_get_xmlNode return original_xmlnode if there is one"
	This reverts commit dfd8f21ab27d2b25a67a52aadd9d4cdce20ebda5.

	Binding python: for empty GList return empty tuples, not None

	Docs: remove from documentation comments characters outside ASCII for python bindings

	Fix return path in lasso_saml20_process_any_response for signatures checking

	fix documentation of lasso_node_debug

	Make lasso_node_get_xmlNode return original_xmlnode if there is one
	 * lasso/xml/xml.c:
	   this change allow session to contain exact copy of received assertion
	   (and not the one lacking signatures) and also to put those assertions
	   directly into message, for example as ID-WSF credentials.
	   But it could have side effect, so for now I will no merge it.

2010-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	update documentation of lasso_login_build_authn_response_msg

	update documentation of lasso_login_build_authn_request_msg

	improve documentation of lasso_login_build_artifact_msg

	use lasso_release_gobject in lasso_login_destroy

	update lasso_login_accept_sso documentation

	ID-FF&SAML2: complete documentation of lasso_login_build_assertion

	Make multiple include loading work in lasso/backward_comp.h
	 * lasso/backward_comp.h
	   add missing BACKWARD_COMP_H define.

	Binding python: fix test file

	SAML 2.0&ID-FF 1.2: simplify and complete metadata loading for multi-role support

	Core: add XML schemas for SAML 2.0

	Doc: add all missing methods to documentation section file
	 * add missing LASSO_EXPORT too for functions already present in the
	   documentation, but not exported previously.

	Tools: add script to check for missing functions in lasso-sections.txt

	XML: in lasso_node_build_xmlNode_from_snippets only set child name if SNIPPET is not of ANY type

	Core: add lasso_set_string_from_prop(char**,xmlNode*,..) function

	Core: add method to check whether we are IdP or SP of another provider
	 * lasso/id-ff/profile.{c,h}:
	   the method lasso_profile_sso_role_with, evaluate using the current
	   LassoIdentity content if we are in a relation of IdP or SP toward
	   another provider. This is based on the existence of a federation with
	   this provider.

	SAML 2.0: add attribute profiles strings

	SAML 2.0: add support for attribute, authentication and authorization authorities metadata
	 * server.c,serverprivate.h: add new private method
	   lasso_server_get_firs_providerID_by_role(server, role)w
	 * defederation.c: use new private method
	   lasso_server_get_first_providerID_by_role for find providerID
	   when the argument remote_providerID is null in
	   lasso_defederation_init_notification.
	 * lasso/id-ff/login.c (lasso_login_init_authn_request): use new private
	   method lasso_server_get_first_providerID_by_role.
	 * provider.h: add thre new provider role (authn,pdp,attribute) and
	    four new services (authn,assertionid,attribute,authz) and also
	    a ROLE_ANY value (-1) for catchall purpose and a ROLE_LAST for
	    array sizing.
	 * provider.h: add a LAST member to LassoMdProtocolType enum.
	  * providerprivate.h,provider.c:
	   - removes separate hashtable for descriptors depending on provider role,
	     use only one table named Descriptors.
	   - use the LAST members of enumerations to dimention static string arrays.
	  * provider.h: add a LAST member to the e

	XML: add support for setting attribute in any namespace using element tree syntax

	Support SignatureVerifyHint in SAML 2.0 SSO profile and common message handling

	Add signature_verify_hint accessor methods to LassoProfile
	 * lasso/id-ff/profile.{c,h}:
	   add a LassoProfileSignatureVerifyHint enumeration and two accessor
	   methods:
	    - lasso_profile_get_signature_verify_hint
	    - lasso_profile_set_signature_verify_hint
	 * lasso/id-ff/profileprivate.h:
	   add private field signature_verify_hint.

	Bindings: fix parsing of camelcased ident (Samlp2IDPList -> samlp2,idp,list)

	Binding python: fix problem of classes without an initializer

	Tests: add macros to test for string equality

	Tests: in SAML 2.0 tests, use more check_ macros

	Tests: add macros check_equals and check_not_equals

	Core: change GObjectAnnotation of lasso_node_export_to_query to state that private_key_file is optional

	SAML 2.0 XML: add header listing strings from XML schema

2010-03-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0: fix uninitialized variable

	ID-WSF 1.0: fix bad header name in all inclusive header lasso/id-wsf/id_wsf.h

2010-03-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Binding PHP5 tests: fix assertion dump test

	XML: move registry mapping into the *_get_type() functions
	 * lassoxml/disco_send_single_logout.c:
	 * lassoxml/id-wsf-2.0/sb2_user_interaction_header.c:
	 * lassoxml/id-wsf-2.0/subsref_app_data.c:
	 * lassoxml/lib_assertion.c:
	 * lassoxml/saml-2.0/saml2_condition_abstract.c:
	 * lassoxml/saml-2.0/saml2_encrypted_element.c:
	 * lassoxml/ws/wsa_attributed_uri.c:
	 * lassoxml/ws/wsa_endpoint_reference.c:
	   class_init is only called the first time an object of the given type
	   is created, registry mappings must exist before this time, so I moved
	   the registration code to the _get_type() functions.

	Core: add a level argument to lasso_node_debug

	ID-WSF 2.0: add lasso_soap_envelope_set_relates_to method

	Core: add macro to remove gobject from lists

2010-03-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: export lasso_build_unique_id into public API
	 * lasso/xml/tools.h:
	   add new header to export lasso_build_unique_id as a public API.

	 * lasso/xml/Makefile.am:
	   add tools.h to header list

	 * lasso/xml/tools.c:
	   add GObjectIntrospection annotations to exported functions.

2010-03-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0: change error code for empty ArtifactResolve response to LASSO_PROFILE_ERROR_MISSING_RESPONSE

	Bindings java: do not mask errors from the code generator

	Core: add an helper method to build a SOAP response in a LassoProfile object
	 * lasso/id-ff/profile.{c,h}:
	   add lasso_profile_add_soap_fault_response(char* code, char *string,
	   GList *details).
	 * lasso/id-wsf-2.0/profile.{c,h}:
	   change signature of lasso_idwsf2_profile_init_soap_fault_response.
	 * lasso/id-wsf-2.0/data_service.c:
	   use new function instead of manually intializing soap faults
	 * lasso/id-wsf-2.0/discovery.c:
	   init a soap fault when parsed request is of an unknown type, return
	   proper error.

	ID-WSF 2.0 python tests: finish tests for new ID-WSF 2.0 API
	 * bindings/python/tests/idwsf2_tests.py:
	   all Discovery service request types are tested, and Data Service
	   query is tested as well. Data Service testing and API should more
	   tested, especially failure cases.

	ID-WSF 2.0: add service type to response, parse response before using it

	Core: in xml_insure_namespace do not segfault if ns is NULL

	Binding python: accept a functio as setter, if it has only two arguments

	ID-WSF 2.0: in lasso_idwsf2_get_name_identifier, use lasso_saml2_assertion_decrypt_subject

	ID-WSF 2.0: in lasso_idwsf2_profile_check_security_mechanism, add common logic for SAML 2.0 secmech, check for presence of a server object,

	ID-WSF 2.0: fix MDAssociationQueryResponse handling
	 * lasso/id-wsf-2.0/discovery.c:
	    - in lasso_idwsf2_discovery_validate_request, use svcmdids to
	      intialize response to MSAssociationQuery requests.
	    - in lasso_idwsf2_discovery_process_response_msg, extract received
	      svcmdids; use lasso_check_good_rc when needed.

	ID-WSF 2.0: change signature of lasso_idwsf2_discovery_add_identity_to_epr
	 * lasso/id-wsf-2.0/discovery.c:
	   - in lasso_idwsf2_discovery_add_identity_to_epr, receive an Epr
	     instead of an EprMetadata node, and use
	     lasso_wsa_endpoint_reference_add_security_token to add the
	     assertion token instead of duplicating this logic.
	   - in lasso_idwsf2_discovery_build_epr change the call site.

	ID-WSF 2.0: fix documentation of lasso_idwsf2_data_service_build_request_msg

	SAML 2.0: in lasso_saml2_assertion_get_issuer_provider, check type of server argument

	Core: add do/while(0) around block of goto_cleanup_with_rc

	Core: add PROFILE errors around assertion validation
	 * lasso/errors.c lasso/errors.h:
	   - add errors concerning invalid assertion, assertion with invalid
	     conditions, unknown issuers, or when the issuer is not a provider
	     we marked as an IdP.
	   - add error for missing sender id in an ID-WSF message.

	Core: add a level argument to lasso_xmlnode_to_string and _lasso_node_export_to_xml

2010-02-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Binding perl: add support for out parameters
	 * bindings/perl/lang.py:
	   support GObject out parameters.

	SAML 2.0: LassoSaml2ConditionAbstract does not match its element name anymore, add a registry mapping
	 * lasso/xml/saml-2.0/saml2_condition_abstract.c:
	   last commit to this file changed the element name from
	   ConditionAbstract to Condition so the XML parser cannot find the
	   corresponding GObject class anymore.

	SAML 2.0: add more accessors for Conditions
	 * lasso/saml-2.0/saml2_helper.{c,h}:
	   distribute code from lasso_saml2_assertion_validate_conditions to
	   lasso_saml2_assertion_validate_time_checks and
	   lasso_saml2_assertion_validate_audience.
	   add lasso_saml2_assertion_allows_proxying and
	   lasso_saml2_assertion_allows_proxying_to, to respectively check for
	   proxying of the current assertion, and for proxying to a specific
	   provider (you must call both of them to test completely the proxying
	   status of an assertion).
	 * docs/reference/lasso/lasso-sections.txt:
	   reference new functions into documentation.

	Bindings python: use more accessors from utils.py
	 * binings/python/lang.py: remove direct access to type tuples in favor
	   of using accesors from utils.py.

	Bindings: make is_int more robust, and fix remove_modifiers

	Bindings php5: use accessort from bindings/utils.py
	 * bindings/php5/wrapper_source.py:
	   do not handle 'type/variable' tuple directly, use accessors.

	Binding python: add pickling support to LassoNode
	 * bindings/python/lang.py:
	   support pickling protocol methods __getstate__ and __setstate__
	   leveraging the lasso_node_dump and lasso_node_new_from_dump methods
	   from Lasso.

	Add lasso_string_to_xsd_integer, to parse xsd:integer values

	SAML 2.0: fix bad name of Condition element, keep xmlNode as it is abstract
	 * lasso/xml/saml-2.0/saml2_condition_abstract.c:
	   saml2:Condition is an element whose type is abstract, it must be used
	   as an extension point helped by the xsi:type field. As the content is
	   unknown before hand we must keep the original xmlNode for later
	   analysis.

	Bindings python tests: update idwsf2_tests.py

	Bindings: in utils.py, make clean_type handle None value

	ID-WSF 2.0: reorganize EPR minting, add a process_request method to disco service
	 * data_service.c:
	   remove dependency on discovery.h
	 * discovery.{c,h}:
	   - add a lasso_idwsf2_discovery_process_request_msg to extract request
	     data before validate request (SvcMDID, SvcMD or RequestService).
	   - store SvcMDID in a private field, add a setter for it.
	   - SvcMDID is now used for building response to MDAssociationQuery and
	     parsing request for MDQuery, MDDelete, MDAssociationAdd and
	     MDAssociationDelete.
	 * idwsf2_helper.{c,h}:
	   - change security mechanism argument of
	     lasso_wsa_endpoint_reference_add_security_token from a NULL
	     terminated string array to a GList.
	 * saml2_login.{c,h}:
	   - add a lasso_server_create_assertion_as_idwsf2_security_token for
	     minting assertion for ID-WSF 2.0 security, to be used in Discovery
	     bootstap EPR creation and EPR minting for Discovery service Query
	     responses.
	   - add a lasso_saml2_assertion_get_discovery_bootstrap_epr, and
	     rewirte lasso_login_idwsf2_get_discovery_bootstrap_epr to use it.
	   - make lasso_login_idwsf2_add_discovery_bootstrap_epr accept a list
	     of security mechanisms, not just one.
	 * tests/idwsf2_tests.c:
	   - adapt to new argument type of
	     lasso_login_idwsf2_add_discovery_bootstrap_epr.

	Core: add new example to LassoLogout for asynchronous response handling

	Support multiline error messages in build_strerror.py

	SAML 2.0: add lasso_saml2_encrypted_element_server_decrypt and lasso_saml2_assertion_decrypt_subject

	Fix idp5-saml2 metadatas
	 * tests/data/idp5-saml2/metadata.xml:
	   we do not have the private key for the encryption public key, so I
	   copied the signing public key.

	Fix lasso_extract_gobject_from_list

2010-02-21  Mikael Ates  <mates@entrouvert.com>

2010-02-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Documentation: add example to LassoLogout, fix bad markup in id-wsf-2.0/profile.c

	ID-WSF 2.0: also check sender match assertion in lasso_idwsf2_profile_check_security_mechanism
	 * lasso/id-wsf-2.0/profile.c:
	   for BEARER mechanism, also check that the SPNameQualifier of the
	   Subject match the Sender of the request.

	ID-WSF 2.0: add lasso_idwsf2_discovery_get_svcmdids to public API

	Tests integration: force C locale
	 * tests/integration/saml2/__init__.py:
	   authentic now use 'system locale' by default, so force C locale to
	   get english IHM string to make twill happy.

	SAML 2.0: if assertion possess a signed original_xmlnode return it instead of using get_xmlNode
	 * lasso/xml/saml-2.0/saml2_assertion.c:
	   assertion in lasso when read are not usable anymore because the
	   signature is lost, this commit allows to keep assertion unaltered
	   after reading them if they contained a top level signature (a
	   signature contained in the Assertion node).
	   This is useful for reusing assertion kept in a LassoSession object
	   and for using assertion as security token for ID-WSF.

	Core: use lasso_xmlnode_to_string in LassoNode export functions
	 * lasso/xml/xml.c:
	   remove duplicate codes and use lasso_xmlnode_to_string instead.

	Current state of ID-WSF 2.0 python test

	Binding php5: fix generation of list freeing
	 * bindings/php5/wrapper_source.py:
	   free_glist wants a GList** as first argument.

	Core: add a lasso_xmlnode_to_string function
	 * lasso/xml/tools.c lasso/xml/private.h:
	   lots of functions duplicate this code, so we factorized it there.
	   It has two parameters, the xmlnode and boolean deciding whether to
	   format the resulting content (good for reading but bad for
	   signatures).

	SAML 2.0: in lasso_saml20_profile_set_session_from_dump_decrypt, really decrypt
	 * lasso/saml-2.0/profile.c:
	   dump for already signed assertion containing an EncryptedID as
	   Subject does not work as before, the decrypted NameID is no more
	   included in it, so instead of trying to plug it in the NameID field
	   we resort to really deciphering the EncryptedID.
	   That could be a performance problem if the session object is stuffed
	   with a lot of assertions.

	Current state of idwsf2 tests

	ID-WSF 2.0: fix loading of LassoIdWsf2Discovery dumps

	Core: add error exit to lasso_node_new_from_xmlNode
	 * lasso/xml/xml.c:
	   if building of the node fails, we must keep the initialization of
	   custom nodename and namespace.

	Binding python: simplify special constructor, use cptrToPy

	ID-WSF 2.0: make lasso_idwsf2_profile_redirect_user_for_interaction add the transactionID to the URL
	 * lasso/id-wsf-2.0/profile.c:
	   simplify use of lasso_idwsf2_profile_redirect_user_for_interaction by
	   directly adding the ID of the SOAP response message to the URL.
	   Report an error if no MessageID can be found.

	ID-WSF 2.0: rewrite and document lasso_soap_envelope_sb2_get_redirect_request_url
	 * lasso/id-wsf-2.0/soap_binding.{c,h}:
	   fix error in conception of
	   lasso_soap_envelope_sb2_get_redirect_request_url, RedirectRequest is
	   part of a SOAP fault not the headers.
	   Explain in the documentation how to use the RedirectRequest URL.
	   Change the return type to a const string.

	ID-WSF 2.0: add a method to retrieve/create a SOAP Fault to SOAP binding module
	 * lasso/id-wsf-2.0/soap_binding.{c,h}:
	   add method lasso_soap_envelope_get_soap_fault which returns/create
	   the first SOAP fault inside the body of the SOAP envelope.

	Binding python tests: adapt test to use TOP_SRCDIR env var

	Binding python: factorize value freeing generation code
	 * lasso/python/lang.py:
	   extract value freeing generation code to method free_value,
	   add proper liberation of values at exit of wrapper functions, remove
	   g_free call from return_value generated code.

	Core: add missing return value owner semantic annotations to getters
	 * lasso/id-ff/provider.c:
	   fix lasso_provider_get_base64_succinct_id, it returned a libxml
	   string, copy it with g_strdup before releasing it to stay with GLib
	   allocated string in return values.

	Core: add annotation to getter function about return value owner semantic
	 * lasso/id-ff/identity.c lasso/id-ff/profile.c:
	   precise owner semantic of lasso_profile_get_identity,
	   lasso_profile_get_session, lasso_profile_get_server
	 * lasso/id-wsf-2.0/saml2_login.c tests/login_tests_saml2.c:
	   in the same vein add missing release of assertion returned by
	   lasso_login_get_assertion which return a caller owned object.

	ID-WSF 2.0: make lasso_idwsf2_profile_redirect_user_for_interaction choke on missing redirect property on UserInteraction header
	 * lasso/id-wsf-2.0/profile.c:
	   if redirect boolean property is false, refuse to return a redirect
	   request.
	   automatically create a SOAP fault to signal to the requester that it
	   needs to support interaction via redirect.

	ID-WSF 2.0: add error code signaling that the requester does not support redirect request
	 * lasso/errors.c lasso/errors.h:
	   add
	   LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST_UNSUPPORTED_BY_REQUESTER.

	ID-WSF 2.0: add a create arg to lasso_soap_envelope_get_sb2_user_interaction_header, add it to public API

	ID-WSF 2.0: fix lots of bad usage of g_strcmp0
	 * lasso/id-wsf-2.0/idwsf2_helper.c lasso/id-wsf-2.0/soap_binding.c
	   lasso/id-wsf/data_service.:
	   add missing check for the return value of strcmp, maybe we need a
	   macro like lasso_strequal.

	Tests: in login_tests_saml2.c, add test for lasso_saml2_assertion_validate_conditions

	in idwsf2_tests.py, merge test case for metadata registering, add test case for failure

	Bindings: parse defines refering to other defines
	 * bindings/bindings.py:
	   Allow to build constants using other constants (prefix string), the
	   constant type is retrieved from the prefix existing record.

	in tools.c, add defines to permit import of timegm

	SAML 2.0: make lasso_saml2_assertion_validate_conditions really work

	Core: fix lasso_iso_8601_gmt_to_time_t, use timegm instead of mktime
	 * lasso/xml/tools.c:
	   mktime convert works on local time, we need timegm to work with GMT
	   time.

	ID-WSF 2.0: add strings for Discovery service Actions

	ID-WSF 2.0: add serialization code for private properties of LassoIdWsf2Profile

	ID-WSF 2.0: fix missing initialization of request field in lasso_idwsf2_discovery_validate_md_register

	ID-WSF 2.0 Documentation: update lasso-sections.txt with LassoIdWsf2Profile methods

	ID-WSF 2.0: fix lasso_idwsf2_discovery_add_simple_service_metadata
	 * lasso/id-wsf-2.0/discovery.c:
	   options is a string list, and security_mech_ids too, so employ the
	   corresponding macros.

	Core: in utils.h, use a temporary to store reference to freed list

	ID-WSF 2.0: in lasso_idwsf2_discovery_status2rc, check second level status code too

	Website: add a link to the developement version documentation

2010-02-15  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Binding python: fix leak in string getters

	SAML 2.0: fix documentation of lasso_saml2_assertion_validate_conditions

	Add signature on EPR secur token

	Bindings python: udpate id-wsf 2.0 test file
	 * bindings/python/tests/idwsf2_tests.py:
	   Disco Service registering is working, it now needs a bootstrap epr in
	   all case (before registering could be done without signatures).

	ID-WSF 2.0: add signature to Disco produced EPR SAML 2.0 security tokens

	ID-WSF 2.0: in lasso_idwsf2_profile_build_request_msg, properly handle the security token
	 * lasso/id-wsf-2.0/profile.c:
	   security token is a signed assertion by an IdP or a discovery
	   service, we must keep as is, that is with the signature, in order to
	   do that we extract the original xmlNode from the assertion and embed
	   it in the new message using a LassoMiscTextNode.

	ID-WSF 2.0: in lasso_login_idwsf2_get_discovery_bootstrap_epr, better handle attribute content
	 * lasso/id-wsf-2.0/saml2_login.c:
	   LassoSaml2AttributeValue can contain many children, so traverse them
	   all to find the firs LassoWsAddrEndpointReference among them.

	ID-WSF 2.0: in lasso_login_idwsf2_add_discovery_bootstrap_epr, initialize ID and Issuer property on bootstrap assertion.
	 * lasso/id-wsf-2.0/saml2_login.c:
	   initialization of ID and Issuer properties was missing.

	Core: in lasso_verify_signature, fix conditional about single reference
	 * lasso/xml/toosl.c:
	   verify that reference is unique if NO_SINGLE_REFERENCE is disabled.

	SAML 2.0: in saml2_helper.c, better check issuer element and also test the LassoServer object for issuance, lasso_saml2_assertion_get_issuer_provider

	ID-WSF 2.0: in lasso_wsa_endpoint_reference_new_for_idwsf2_service, do not forget to add metadata to epr, fill usage property of token
	 * lasso/id-wsf-2.0/idwsf2_helper.c:
	   add missing initialization code.

	ID-WSF 2.0: fix bad type checking in lasso_wsa_endpoint_reference_get_idwsf2_security_context_for_security_mechanism
	 * lasso/id-wsf-2.0/idwsf2_helper.c:
	   SecurityMechID is a list of strings not LassoMiscTextNode.

	ID-WSF 2.0: fix bad conditionnal in lasso_idwsf2_discovery_process_metadata_register_response_msg
	 * lasso/id-wsf-2.0/discovery.c:
	   fix check in
	   lasso_idwsf2_discovery_process_metadata_register_response_msg
	   fix duplication of service metadatas inside private list of service
	   metadatas.

	in server.c, fix missing loading of public keys in constructors
	 * lasso/id-ff/server.c:
	   constructor for LassoProvider load public keys but they are not
	   called by LassoServer constructors, so we have to explicitely
	   duplicate calls to lasso_provider_load_public_keys.

	ID-WSF 2.0: moved strings to their own header

2010-02-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add saml2_strings.h to dist

	Bindings python: remove default argument if there is parameters without default argument following

	Use defined symbols instead of magic constants

	Add LASSO_SAML2_FIELD_ENCODING
	 * lasso/xml/saml-2.0/saml2_strings.h:
	   add another field name from SAML 2.0 specifications.

	Fix lasso_get_relaystate_from_query, support semi-colon and parameter at beginning
	* lasso/xml/tools.c:
	  getting first parameter was broken (query_string does not contain '?'
	  at the beginning) and semi-colon support was missing.

2010-02-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Documentation: fix typos in saml2_strings.h documentation, add new string symbols to lasso-sections.txt

	SAML 2.0: move SAML 2.0 strings to their own header, add documentation
	 * lasso/xml/strings.h:
	   remove SAML 2.0 strings
	 * lasso/xml/saml-2.0/saml2_strings.h:
	   move them here, document useful ones.

	Documentation: document LsasoSamlp2NameIDPolicy

	Documentation: complete non finished documentation comments
	 * too much warnings when generating doc, now we can concentrate on
	   undocumented symbols (in
	   lasso/docs/reference/lasso/lasso-undocumented.txt).

	Bindings perl: prevent unused functio warning for array_to_glist_gobject

	Tests perl: raise number of tests

	Docs: reorder sections in chapter "Lasso Architecture"

	SAML 2.0: separate lasso_saml20_login_process_response_status_and_assertion into multiple functions
	 * lasso/saml-2.0/login.c:
	   in lasso_saml20_login_process_response_status_and_assertion, extract assertion
	   decryption, and issuer checking into their own function.

	SAML 2.0: when verifying query signature, do not presume order of field and separator
	 * lasso/xml/tools.c:
	   in lasso_saml2_verify_query_signature, extract needed field and order
	   them appropriately before computing digest, expect ';' as well as '&'
	   as separator.
	 * tests/random_test.c:
	   add non-regression tests for query signature validation.
	 * tests/Makefile.am:
	   make tests link agains static version of liblasso, to get access to
	   private functions.

	SAML 2.0: complete list of field names for SAML 2.0

	Core: in tools.c, enhance urlencoded_to_string to support semu-colon separator

	SAML 2.0: add helper method lasso_saml2_assertion_get_in_response_to
	 * lasso/saml-2.0/saml2_helper.c lasso/saml-2.0/saml2_helper.h:
	   add a method to access easily the InResponseTo attribute.

	SAML 2.0: in lasso_saml20_login_process_authn_response_msg always report signatures errors
	 * lasso/saml-2.0/login.c:
	   - in lasso_saml20_login_process_authn_response_msg keep around all error
	     codes returned by intermediary steps. At the end report the first one.

	SAML 2.0: in lasso_saml20_profile_process_any_response do not stop on missing issuer
	 * lasso/saml-2.0/profile.c:
	   Issuer is not a mandatory element of SAML 2.0 response,
	   but if we do not remember which issuer we sent the request (of if
	   the response is spontaneous) then we will receive a provider not found
	   error when trying to check the message signature.

	Use new SAML2 strings instead of hardcoding query string field names

	Add documentation about runtime flags
	 * lasso/lasso.c:
	   add a table to Initialization documentation section about
	   general runtime flags.

	Remove follow-idwsf-stupid-semantic flag
	 * lasso/lasso.c:
	   this flag is useless, that's me that is stupid.

	Add internal methods to LassoServer to get the signature and encryption private keys
	 * lasso/id-ff/server.c lasso/id-ff/serverprivate.h:
	   add methods lasso_server_get_private_key and lasso_server_get_encryption_private_key.

	Add complete error code listing for lasso_login_process_response_msg
	 * lasso/id-ff/login.c:
	   list all error codes and their semantic with respect to this call.

	Update code example for LassoLogin
	 * lasso/id-ff/login.c:
	   add code for intializaing request for SAML 2.0, shows how to handler errors codes.

2010-02-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add error codes, update error codes documentation, reduce changes in errors.c by ordering error codes
	* lasso/errors.h lasso/errors.c
	- add to report non schema conforming XML trees, decyrption
	failure due to missing private keys and invalid signatures on assertions.
	- update documentation of LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND,
	LASSO_SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH,

	* lasso/build_strerror.py:
	before outputting switch cases, order error codes
	name lexically in order to reduce change lines
	when adding new error codes.

2010-02-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add strings for SAML2 field names for POST, Redirect and Artifact bindings

	Update documentation of the registry module

	Adapt LassoProvider methods to care for protocol profile version when verifying signature
	 * lasso/id-ff/provider.c:
	   there is now 2 methods to verify signatures, methods calling the old
	   one must now choose whether to call the liberty one of the SAML 2.0
	   one.

	Add a function to validate query signatures using SAML 2.0 semantic
	 * lasso/xml/tools.c:
	   this new function is a placeholder for the new SAML 2.0 semantic
	   following query signature validation function. It will start with the
	   old code of lasso_query_verify_signature.

	Propagate change of name for LASSO_PP_ defines

2010-02-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: in LassoServer constructors, test if private_key is loadable
	 * lasso/id-ff/server.c:
	   mark private_key as not mandatory as regression tests expect it to
	   not be mandatory.
	   test if loading of private key to encryption_private_key private
	   field worked, if not abort the constructor and return NULL.
	 * lasso/id-ff/server.h:
	   fix name of constructors argument to corresponds with comments
	   (binding generator use this correspondance to apply annotation from
	   comments to the model obtained by parsing the headers).

	in lasso_xmlsec_load_private_key_from_buffer, do not let xmlSecBase64Decode show warnings

2010-02-05  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	fix bad operation in bindings.py

2010-02-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: restore ID-WSF constants, improve python getters,
	 * bindings/bindings.py:
	   parse idwsf_strings.h to get ID-WSF constants.
	 * bindings/utils.py:
	   add an is_rc check function, to check for 'error code' return type.
	 * bindings/perl/lang.py:
	   only raise errors for 'int' or 'gint' return type
	 * bindings/python/lang.py:
	   - always create a normal function binding.
	   - for functions starting with 'get' try to create a corresponding
	     property, but if a corresponding member already exists, fails, and
	     print a warning about getter function/member field clash.
	   - make type dispatching on return_type more explicite.

	Core: Finish support for all XMLDsig key formats
	 * lasso/xml/tools.c:
	   xmlsec is not able to load a certificate public key without checking
	   it against trusted root certificate, so we must work around and load
	   the key by hand.
	   lasso_xmlsec_load_private_key_from_buffer is made more robust in the
	   same (loading of the key was extracted inside
	   _lasso_xmlsec_load_key_from_buffer) and now can load certificates and
	   keys directly embedded inside KeyValue nodes (in total opposition to
	   the XMLDsig specification but...), with or without PEM headers.
	 * tests/metadata/Makefile.am tests/metadata/metadata_06.xml
	   tests/metadata_tests.c:
	   add test case for RSAKeyValue public keys.

	Binding python: fix getter for non-object fields
	 * bindings/python/lang.py:
	   transition to bindings/utils.py methods broke getters.

	Core: in lasso_xmlsec_load_key_info add flag to let xmlSec load certificates
	 * lasso/xml/tools.c:
	   adding the flag XMLSEC_KEYINFO_FLAGS_X509DATA_DONT_VERIFY_CERTS make
	   xmlSec able to load certificate, the 'hand made' code to load
	   certificate is then useless.

	Tests: add more checking to dump generation code in login_tests.c

	Tests: adapt server constructor settings to recent changes

	Core: in lasso_profile_get_request_type_from_soap_msg use lasso_xml_parse_memory_with_error
	 * lasso/id-ff/profile.c: (lasso_profile_get_request_type_from_soap_msg)
	   use lasso_xml_parse_memory_with_error instead of xmlParseMemory, use
	   error code output argument to log error reports.

	Core: in provider.c, make lasso_provider_load_metadata_from_buffer the main metadata loading function
	 * (init_from_xml) fail initialization if we cannot load the metadatas,
	   and log a warning.
	 * extract _lasso_provider_load_metadata_from_buffer from
	   lasso_provider_load_metadata_from_buffer, which accept a length
	   parameter. use it inside lasso_provider_load_metadata, instead of
	   xmlParseFile.
	 * (lasso_provider_load_public_key) use lasso_xmlsec_load_key_info and
	   lasso_xmlsec_load_private_key to load the public keys.

	Core: use lasso_xml_parse_file to load affiliation file

	Binding java: Makefile.am has multiple target rules, it cannot support parallel builds

	Core: in tools.c, add function to load XML files and KeyInfo nodes
	 * tools.c:
	   add lasso_xml_parse_file, based on g_file_get_contents and
	   lasso_xml_parse_memory.
	   add lasso_xml_parse_memory_with_error which instead of logging
	   errors, can return the xmlError structure.
	   add lasso_xmlsec_load_key_info, which allows to load keys from
	   ds:KeyInfo XML nodes. It also support the "Lasso" bug of using
	   ds:KeyValue directly to store base64 encoded keys and certificates.

	SAML 2.0: in name_id_management.c, rework lasso_name_id_management_new_from_dump

	Core: add more memory tracing, add a tracing macro
	 * lasso/utils.h: add lasso_trace, which as a printf signature.
	 * xml/xml.c: add more trace to node initialization code.

	Tests: in valgrind suppressions file add more GLib suppressions

	Tests: in basic_tests.c, re-enable parsing of LassoWsuTimestamp objects

	Core: use lasso_node_new_from_dump to implement _new_from_dump methods
	 * provider.c:
	   add annotation for nullable arguments (necessary for bindings of
	   new_from_buffer).
	 * server.c: add annotations, allow to set encryption_private_key from
	   buffers

	Binding perl: add cleanup for temporary data of trampoline code
	 * bindings/perl/lang.py:
	   data type not common to Perl and C must be allocated for the duration
	   of the call (mainly GList and xmlNode), but after the call they must
	   be deallocated.

	SAML 2.0: in samlp2_response.c, simplify code path for assertion encryption

	Fix leaks
	 * lasso/id-wsf-2.0/profile.c: release private data object.
	 * lasso/saml-2.0/login.c: free NameID content after construction.
	 * lasso/xml/tools.c: free algorithm attribute content in
	   lasso_node_decrypt_xmlnode.
	 * lasso/xml/xml.c: release cutom_element->nodename in destructor.
	   remove useless finalize method.
	 * tests/basic_tests.c: release xmldoc after use.
	 * tests/random_tests.c: free resut of lasso_node_dump.

	Fix leaks, change signature of lasso_provider_get_sp_name_qualifier, make it return a const char*

	in lasso/xml/tools.c, remove leaks of xmlSecKey and xmlNode

	in lasso_xmlsec_load_private_key, do not leak the file buffer, in lasso_node_encrypt do not leak the keys manager

2010-02-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Binding perl: many improvements
	 * lang.py: use lasso_unref instead of g_object_unref.
	 * lang.py: handle 'optional' annotation for more types, needed by
	   ID-WSF bindings.
	 * lang.py, gobject_handling.c: check object type before making the C
	   call
	 * Makefile.am: improve silent rules, hide all normal output, show
	   errors, and with V=1 shows everything
	 * glist_handling.c, gobject_handling.c: make local functions static
	 * t/Lasso.t: add non regression test for method receiver type checking.
	 * glist_handlind.c; remove unused convertion functions.
	 * lang.py: clear the semi-assigned list and croak if all list elements
	   do not convert to non-NULL values.

	Bindings: re-add binding for lasso_session_get_assertions for perl, special case formatting function for WsAddressing namespace
	 * bindings/utils.py:
	   type have LassoWsAddr prefix but function have the lasso_wsa_ prefix,
	   so we have to adjust generated prefix.

	Bindings: use lasso_return_xxx macros instead of GLib ones

	ID-WSF: remove useless new_from_message methods

	Core: in utils.h, add macros to replace verbose g_return_val_if_fail

	Core: document return values of lasso_login_validate_request_msg

	Utils: lasso_unref, a safe g_object_unref, and add some document about existing family of macros

	Core: do not emit messages inside lasso_check_version

	Bindings: os.path.relpath is only present since python 2.6, add a local implementation for older python versions

	Add a dist-hook to remove .svn directories before taring the dist

	Bindings: make binding generation more silent
	 * bindings/java/Makefile.am bindings/perl/Makefile.am
	   bindings/php5/Makefile.am bindings/python/Makefile.am:
	   use AM_V_GEN, or similar variable for all steps of binding
	   generation, normal output can be activated with the V=1 argument to
	   the 'make' command.

	Binding java: use eager evalutation to get list of sources files
	 * bindings/java/Makefile.am:
	   use := to provoke eager evaluation so that java-list mode is not
	   called many times.

2010-01-29  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: use 'absolute' header paths to produces bindings
	 * bindings/bindings.py:
	   if files from bindings are using absolute instead of relatives header
	   paths they can be independant of the lasso source.

	Bindings perl: simplify Makefile.PL
	 * bindings/perl/Makefile.PL:
	   remove as much special casing as possible so that it could eventually
	   become a CPAN module.
	   use pkg-config to find lasso libs if no explicit LIBS command line
	   argument is used.
	 * bindings/perl/Makefile.am:
	   pass parameters using command line argument instead of environment
	   variable, which needed a special Makefile.PL.

	Binding perl: special case for lasso_check_version
	 * bindings/perl/lang.py:
	   special case lasso_check_version for not raising an error when it
	   returns 1.
	 * bindings/perl/t/Lasso.t:
	   add a non regression test.

	Binding perl: remove warning when passing Null to croak
	 * bindings/perl/gobject_handling.c:
	   croak is aliased to Perl_croak_nocontext which has a gcc attribute
	   'notnull'. We use Perl_croak and an explicit perl context object, to
	   work around this warning.

	in bindings.py, change header paths

	Update files for a 2.2.91 release

	update changelog

	Binding python: make a better use of default value annotation for creating method declarations

	Binding perl: many improvements
	 * handle GHashTable of strings and objects.
	 * report errors with 'croak' as a Lasso::Error object.
	 * add more basic tests.
	 * for string arguments, convert undef to NULL, and croak if function
	   does not accept NULL.
	 * fix library paths in Makefile.PL.

	Bindings: in bindings.py, fix regexp and annotation parsing for optional arguments and their default values

	SAML 2.0: fix annotations, documentation and signatures

2010-01-28  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings python ID-WSF 1.0 tests: update PP HREF symbol

	Bindings php5: string hashtable methods are only used by ID-WSF bindings, mark them unused by default
	 * bindings/php5/wrapper_source_top.c:
	   only id-wsf has field of type GHashtTable<char*,char*> so when
	   compiling without --enable-wsf, it give 'unused symbols' errors.
	   Lets mark de the concerned functions as unused.

	ID-WSF 1.0: make LassoServer.services private with respect to the bindings

	Bindings java: use utils.py methods, make set_hash_of_objects more robust

	Tests: export sp2-la do dist file for dist with id-wsf enabled

	Bindings: add time_t to integer types, add unpointerize method

	Binding python ID-WSF 2.0 tests: update some tests

	Binding Python ID-WSF 2.0: comment out test

	ID-WSF: change name of Personal Profile namespace symbols, add symbols for ID-SIS PP 1.1

	Bindings: java, php5, python simplify logic in binding generator
	 * use utils.h macros to manipulate fields.
	 * use utils.py function to filter variables, argument and return types.
	 * finish support of hashtables of strings for php5 and python.

	Bindings: better parse oftype annotation for hashtable, allow to skip structures
	 * bindings/bindings.py:
	   add possibility to skip generating bindings for structures to
	   overrides.xml.
	   parse element-type annotation /* of XXX */ for hashtable objects.
	   output to stderr warning about skipped objects.
	   parse idwsf_strings.h
	 * bindings/overrides.xml:
	   skip more ID-WSF 1.0 functions in java and perl.
	   skip structure LassoAuthentication.

	Core: fix gtk-doc annotations

	Core: add new macros to lasso/utils.h, fix lasso_assign_new_list_of_gobjects
	 * lasso/utils.h:
	   add:
	    - lasso_assign_new_xml_node
	    - lasso_assign_new_list_of_strings
	    - lasso_assign_new_list_of_xml_node
	   fix lasso_assign_new_list_of_gobjects, bad naming of release macro.

	XML: add missing element-type annotations

	Bindings: in bindings/utils.py, augment robustness of matching functions to work with type alone or triples

	Binding perl: update to binding
	 * change extension of typemap files because if conflicts with existing
	 *  support constant list of strings and gobjects, add input rule for
	    list of gobjects
	 * fix setter for GList fields

2010-01-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-WSF 1.0 & 2.0: complete lasso-sections.txt, add internal API to access SOAP headers, complete WS-Addressing support
	 * docs/reference/lasso/lasso-sections.txt: complete documentation of
	   LassoSoapEnvelope and LassoSoapFault with ID-WSF additions.

	 * lasso/id-wsf-2.0/profile.c lasso/id-wsf-2.0/soap_binding.c
	   lasso/id-wsf-2.0/soap_binding.h:
	   add internal function _get_node and _get_header to simplify
	   implementation of accessors for headers.
	   change signature of lasso_soap_envelope_get_message_id and add new
	   function lasso_soap_envelope_get_relates_to.
	   update call points.
	   add a message id when building a SOAP message.

	 * lasso/xml/idwsf_strings.h:
	   add element name for MessageID and RelatesTo WS-Addressing elements.

	 * lasso/id-wsf/authentication.c lasso/id-wsf/data_service.c
	   lasso/id-wsf/discovery.c lasso/id-wsf/wsf_profile.c
	   lasso/id-wsf-2.0/saml2_login.c lasso/xml/disco_description.c:
	   fix path name of header lasso/id-wsf/wsf_utils.h. make all internal
	   include path relatives.

2010-01-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core XML: make lasso_node_set_custom_namespace/nodename take const string
	 * lasso/xml/xml.c lasso/xml/xml.h:
	   mark argument of lasso_node_set_custom_namespace and
	   lasso_node_set_custom_nodename as const char* strings.

	Core XML: add function to get the namespace of a LassoNode
	 * lasso/xml/xml.c lasso/xml/xml.h:
	   if a custome namespace is set, return it, otherwise return the class
	   namespace (klass->node_data->ns->href).

	Binding perl: fix include paths in the makefile, again

	in bindings/perl/Makefile.PL, add include path for normal builds

	in configure.ac, activate the Perl binding in normal builds

	Core: in configure.ac, activate warning when debugging, not in normal build
	 * configure.ac:
	   remove -Wxxx flag from AM_CFLAGS, add them if --enable-debugging
	   is used.

	in lasso/saml-2.0/logout.c, fix missing declaration

	Core: update errors.c file

	in bindings/perl/Makefile.am, change permission to make distcheck works

	in bindings/perl/Makefile.am, add files to EXTRA_DIST

2010-01-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: add a new perl binding using the new binding infrastructure
	 * XS files is autogenerated using bindings/binding.py model of the
	   Lasso API. All constants are in the Lasso::Constants package, the
	   LASSO_ prefix is removed.
	   All classes are now Lasso::ClassName, field accessor also serves as
	   setters, i.e you can do this:
	   $name_id = Lasso::Saml2NameID::new();
	   $name_id->content('coin');
	   print $name_id->content;

	   Is still missing:
	    - a lot of test files,
	    - support for hashtables,
	    - and throwing exceptions when return code is non-zero.

2010-01-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: in utils.py, fix is_glist and is_hashtable, make arg_type accept simple string as input instead of triples

	in lasso/xml/saml_attribute_value.h, fix typo in content type annotation

	in lasso/xml/sa_sasl_response.h, add GList content type annotation to field 'any'

	Bindings PHP5: use is_cstring to match string types

	Bindings: remove all SWIG bindings and SWIG related files

	Add new macro lasso_list_add_new_xml_node
	 * lasso/utils.h:
	   fix lasso_list_add_xml_node, it must copy the node before assigning
	   it.
	   add lasso_list_add_new_xml_node for keeping the old behaviour.
	 * lasso/xml/xml.c:
	   fix use of lasso_list_add_xml_node, because copying the node before
	   assigning it is a leak now.

2010-01-25  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	in bindings/ghashtable.h, Add missing unused argument hints

	SAML 2.0 Logout: when in an SP initiated logout, lasso_logout_build_response_msg is the finishing call
	 * lasso/saml-2.0/logout.c:
	   when calling lasso_logout_build_response_msg(), if we known that we
	   are in the middle of an SP initiated logout, i.e. if
	   initial_remote_providerID is not NULL, then we can restore the intial
	   response.

	Fix name of LASSO_WSSEC_BAD_PASSWORD
	 * lasso/errors.c lasso/errors.h:
	   LASSO_WSSE_BAD_PASSWORD -> LASSO_WSSEC_ERROR_BAD_PASSWORD
	 * lasso/xml/ws/wsse_username_token.c:
	   update client code.

	Bindings java: cast return value of special constructors
	 * bindings/java/lang.py:
	   in the JAVA API special constructors are made to return their real
	   type, but usual GObject constructors return their base type (here
	   LassoNode) so we have to cast it.

	Export more assertion access API for LassoSession
	 * lasso/id-ff/session.c lasso/id-ff/session.h
	   lasso/id-ff/sessionprivate.h:
	   export lasso_session_get_assertion(), lasso_session_add_assertion()
	   and lasso_session_remove_assertion().
	   remove them from private header.
	 * docs/reference/lasso/lasso-sections.txt:
	   update documentation

2010-01-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: remove useless overrides
	 * bindings/overrides.xml:
	   It is no more needed to force return type of constructors to their
	   real types, the bindings check the type dynamically anyway.

	Fix GHashTable backward compatibility header
	 * lasso/ghashtable.h:
	   g_hash_table_remove_all_nodes is not a public function, use
	   g_hash_table_foreach_remove instead.

2010-01-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	in saml2_name_id.c, include utils.h to benefit from replacement for g_strcmp0

	Fix LASSO_WSSEC_BAD_PASSWORD error, reformat wsse_username_token.c
	 * lasso/errors.h:
	   change error id and error name for LASSO_WSSEC_BAD_PASSWORD
	 * lasso/xml/ws/wsse_username_token.c:
	   update reference to LASSO_WSSEC_BAD_PASSWORD.
	   reformat line longer than 100 characters.

2010-01-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-WSF 2.0: add some annotations

	Core: in backward_comp.h, include string.h if g_strcmp0 is used
	 * lasso/backward_comp.h:
	   implementation of g_strcmp0 depends upon string.h.

	WS-Security: fix typo in name of string symbols
	 * lasso/xml/idwsf_strings.h:
	   uppercase define for WS-Securities SOAP faults.

	WS: complete support for wsse:UsernameToken
	 * docs/reference/lasso/lasso-sections.txt:
	   add new functions and change type name in documentation.
	 * lasso/errors.h lasso/errors.c:
	   add an error to report password verification failure
	 * lasso/xml/ws/wsse_username_token.h
	   lasso/xml/ws/wsse_username_token.c:
	   update support for wsse:UsernameToken up to version 1.1, implement
	   digest and derived keys computations.
	 * lasso/xml/idwsf_strings.h:
	   add strings for Username WS-Security Token profile

	XML SAML-2.0: AuthnContext content is a xdf:choice so make content optional
	 - lasso/xml/saml-2.0/saml2_authn_context.c:
	   <AuthnContext/> can contain at least one node among:
	    - <AuthnContextClassRef/>
	    - <AuthnContextDeclRef/>
	    - <AuthnContextDecl/>
	   to approximate this possibility, we need to make any of them
	   optional.
	   <AuthenticatingAuthority/> should be a list but we cannot change it
	   without breaking the ABI, so we will wait for this.

	make an explicit copy of lasso.doap to website/web/doap.rdf

	Reduce news message to fit the news column

2010-01-18  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	updat download link

	ID-WSF 2.0: Add saml2_login.h to list of headers

	Documentation: wsse_security.xml is now wsse_security_header.xml

	By default make autogen.sh to enable gtk doc

	Bindings PHP5: rewire php5 tests to the makefiles, make them pass distcheck

	in autogen.sh, move libtoolize and gtkdocize before aclocal

	fix typo

	Merge EXTRA_DIST declarations in tests/Makefile.am

	fix bad commit

	tag release 2.2.90

	Update changelog

	Change again date of release 2.2.90

	Add tests/valgrind to dist tarballs

	Add autogen.sh and tools to EXTRA_DIST in top Makefile.am

	Documentation: distribute stylesheet, fix documentation comments, compelte lasso-sections.txt

	Documentation: add empty lasso-overrides.txt, it seems to be necessary

	ID-WSF: mark API as Private not Internal

	Core: complete documentation on LassoSession

	Core: complete documentation on LassoProfile

	Core: complete documentation on LassoLogin

	fix typo (transfer-none) -> (transfer none)

	ID-WSF 1.0: change name of utils.{c,h} file for documentation parsing
	 * utils.h:
	   this header has the same name as an other header which is not parsed
	   by the documentation (lasso/utils.h) and the documentation process
	   just match by filename, so we rename it.

	Website: add news about 2.2.90

2010-01-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add bindings/python/examples to dist file

	remove empty directory

	remove empty directory

2010-01-15  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Documentation: update lasso-sections.txt

	Update doap file

	FIX ABI breakage between 2.2.1 and 2.2.2 in LassoSamlAdvice
	 * lasso/xml/saml_advice.c lasso/xml/saml_advice.h:
	   restore fields AssertionIDReference and Assertion, remove field any
	   to restore state from 2.2.1
	 * lasso/id-ff/session.c:
	   use xmlNode stored inside LassoSamlAssertion objects instead of
	   accessing the 'any' list of xmlNode that was inserted in
	   LassoSamlAdvice.

2010-01-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	FIX ABI breakage when addning new field to struct LassoSaml2AttributeValue

	Fix ABI breakage due to change of constant name from LASSO_SOAP_FAULT_REDIRECT_REQUEST to LASSO_SOAP_ERROR_REDIRECT_REQUEST_FAULT

	Fix ABI breakage with respect to 2.2.1

	Documentation: add lasso_profile_set/get_signature_hint to lasso-sections.txt

	Add files listings the ABI of Lasso

	Tools: add script to generate a listing of Lasso ABI
	 * tools/api.py:
	   use parser from the binding generator to output a list of symbols
	 * bindings/bindings.py;
	   add private flags to not clobber 'private' fields of structures or
	   methods not exported in bindings like _get_type.

	ID-WSF: separate ID-WSF strings into their own header

	start NEWS file for 2.2.90

	Tests integration: remove save_html hooks, after fed termination logout button should still be there

	Bindings python: use is_cstring for matching GList element type

2010-01-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0 Logout: undo some change to when the assertion is removed
	 * lasso/saml-2.0/logout.c:
	   - do not remove the assertion in init_request, as before only if all
	     fails (event REDIRECT is unsupported).
	   - in process_response_msg remove the assertion if we are the IdP or
	     if there is no error.
	   - in validate_request, remove the assertion if there is no error.

	   I think that there will be more updates to this in the future.

2010-01-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: make is_cstring usable with tuple and with direct type

	Core: remove warning emiting macros from lasso_session_remove_assertion
	 * lasso/id-ff/session.c:
	   we already return error code, no need to log more warnings.

	SAML 2.0: report missing request when creating artifact resolve response, fix typo in lasso_saml20_profile_build_post_response_msg

	SAML 2.0: Fix typo in lasso_saml20_login_build_authn_response_msg

	ID-FF&SAML2: if use is not defined on a key descriptor use the key for any use
	 * lasso/id-ff/provider.c lasso/saml-2.0/provider.c: if the "use"
	   attribute is not set on a KeyDescriptor, use the key for signing and
	   encryption.

2010-01-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Tests SAML2: use & test encryption

	SAML 2.0: add saml2_helper.h to include files to install

	Tests: fix inclusion of id-wsf 2.0 tests

	Core: add new SAML 2.0 public header to top level header lasso.h

	ID-WSF 2.0: remote saml2_login_private.h from Makefile.am

	Bindings: add support for time_t to bindings, add support for 'string' type for list in java binding

	in saml2_helper.{c,h}, remote const modifier from time_t type

	in saml-2.0/name_id_management.c: handle NewEncryptedID, only encrypt if needed

	in saml-2.0/logout.c: remove commented code, only encrypt if needed, intialize local variables

	in lasso_saml20_login_init_idp_initiated_auhtn_request, do not use init_authn_request, manually create the request.

	in lasso_saml20_login_init_authn_request,  use saml-2.0/profile.c functions to reduce code size

	in saml-2.0/profile.c, in lasso_saml20_build_response_msg, when no url is given, only stop for bindings needing one

	in saml-2.0/profile.c, in lasso_saml20_profile_init_response make direct access

	in saml-2.0/profile.c, in lasso_saml20_init_request better check for supported bindings,  do not check for identity or session, report SESSION_NOT_FOUND only if first_in_session is used, do not stop on missing name_id.

	in saml2_helper.c, remove dead code

	SAML 2.0: in lasso_saml20_provider_accept_http_method, add HTTP-Artifact-POST case, better check for bad inputs, and handle special SingleSignOn case

	Core Profile: remove need for identity in lasso_profile_get_nameIdentifier

	Core Server: make default to load signing private key also as encryption private key

	Commit to delete

	Core: rewrite lasso_assertion_encrypt using lasso_xmlsect_load_key and add recipient argument

	Core: add simple function to load key from any format

	Core Node: add args to lasso_node_encrypt to set recipient of an encrypted element

	Binding python: provide old binding name for set_encryptionMode

	SAML 2.0: overhaul for ubuquitous binding support, still need work for HTTP-Artefact

	Core: in profile.c, profile.h, profileprivate.h, add a new attribute to express signature needs

	Core: in identity.c, do not emit trace when lasso_identity_get_federation fails

	XML Core: in xml.c, private.h, add a lasso_node_remove_signature function

	XML: fill node_data->{certificate,private_key}_file_offset for nodes with signatures

	Core: in xml/private.h, add new field to LassoNodeClassData for private_key and certificate handling

	Core: in provider.h, add LASSO_PROVIDER_ROLE_BOTH

	Core: in profile.c, make lasso_profile_get_nameIdentifier work for transient federations
	 * lasso/id-ff/profile.c:
	   if no LassoIdentity is accessible try to get a name identifier
	   through the assertion in the LassoSession object. This allows the
	   logout profile to work without an identity object (which is normal
	   since logout does not modify the federation status).

	Core: in provider.h, add new SAML 2.0 HTTP-Method, PAOS

	SAML 2.0: add new function to factorize adding signature to a message

	Fix mitm attack using the AssertionConsumerURL property on requests
	 * lasso/saml-2.0/login.c: check that the URL is know before using it
	 * lasso/saml-2.0/provider.c lasso/saml-2.0/providerprivate.h:
	   add a function to check that an URL corresponds to a know
	   AssertionConsumer of the given provider.

	ID-WSF 2.0: fix in documentation

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: simplify GList handling

	XML: add element type annotation to all GList fields

	Bindings: in bindings/python/Makefile.am, precise generated files dependencies

	XML: move SOAP API to its own sub directory

	Bindings: in overrides.xml, remove noew useless directives

	Python binding: update test scripts to new ID-WSF API

	Binding ID-WSF 2.0: do not bind lasso_wsa_endpoint_reference_get_*_token methods

	Tests: add idwsf2_tests.c, call from tests.c, update Makefile.am

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-WSF 2.0: in profile.{c,h}, discovery.{c,h}, data_service.{c,h}, overhaul all profiles.
	 * lasso/id-wsf-2.0/profile.c lasso/id-wsf-2.0/profile.h:
	   - lasso_idwsf2_profile_get_name_identifier returns the NameID found
	     in an assertion used as a WS-Security token when security mechanism
	     Bearer or SAML are used.
	   - complete the function lasso_id_wsf2_profile_build_soap_envelope
	     with construction of the Sender element which is used to transmit
	     the providerID of the message sender by the SOAP binding ID-WSF 2.0
	     specification.
	   - remove useless instance_init function in profile object
	   - reset some profile fields in process_soap_request_msg (response,
	     body, nameIdentifier).  use
	     lasso_saml20_profile_name_identifier_decryption for handling NameID
	     from WS-Security mechanism assertion.
	   - add private_data
	   - change signature of lasso_idwsf2_profile_init_soap_request to use
	     and EPR and a security mechanism specifier when building the SOAP
	     request.
	   - change signature of lasso_idwsf2_profile_process_soap_request to
	     verify security_mech_id of received messages.
	 * docs/reference/lasso/lasso-sections.txt:
	   add the function to the documentation.

	 * lasso/id-wsf-2.0/discovery.{c,h}:
	   - use utils.h macros instead of g_return_val_if_fail because it
	     removes useless warning, since it returns an error code.  release
	     acquired resources.
	   - in lasso_idwsf2_discovery_metadata_register_self, return error code
	     instead of identifier string for the new service, use an out
	     parmeter to return the identifier, use utils.h macros.
	   - in lasso_idwsf2_discovery_init_metadata_register, use utils.h
	     macros, check return code of lasso_idwsf2_profile_init_soap_request.
	   - change signature of lasso_idwsf2_discovery_init_metadata_register
	     to support security_mech_id, try to get URL from an existing
	     Discovery service EPR (from Session object).
	   - change signature of
	       lasso_idwsf2_discovery_process_metadata_register_msg,
	       lasso_idwsf2_discovery_init_metadata_association_add,
	       lasso_idwsf2_discovery_process_metadata_association_add_msg,
	       lasso_idwsf2_discovery_init_query,
	       lasso_idwsf2_discovery_process_query_msg, to support security
	       mechanism.
	   - improve lasso_idwsf2_discovery_build_query_response_eprs.
	   - add lasso_idwsf2_discovery_get_nth_data_service to acces returned
	     services.
	 * lasso/id-wsf-2.0/data_service.{c,h}:
	   - redo all the API

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-WSF 2.0: in session.c, fix memory handling errors

	ID-WSF 2.0&ID-WSF: in profile.c, wsf_profile.c, errors.c, errors.h, and  in lasso-sections.txt change LASSO_SOAP_FAULT_REDIRECT_REQUEST to LASSO_SOAP_ERROR_REDIRECT_REQUEST_FAULT

	ID-WSF 2.0 Errors: in errors.{c,h}, add new errors code for ID-WSF 2.0
	 - add LASSO_DST_ERROR_EMPTY_REQUEST
	 - add LASSO_WSF_PROFILE_ERROR_SECURITY_MECHANISM_CHECK_FAILED
	 - add new errors codes for generic profiles and disco service

	ID-WSF 2.0 XML: in strings.h, add identifiers from ID-WSF 2.0 standards
	 - add status code for ID-WSF 2.0 DST
	 - add token usage identifiers
	 - conform security mechanism identifiers to ID-WSF 2.0 Liberty Sech
	   Mech specification
	 - add Discovery Service status codes
	 - add Soap Binding status codes
	 - add disco result type and user interaction hint strings

	ID-WSF 2.0 XML: in sec_token.c, remove extra SNIPPET_ANY

	ID-WSF 2.0 XML: in util_response.{c,h}, add helper functions to idwsf2_util_status

	ID-WSF 2.0: in server.c, change annotation of lasso_server_get_svc_metadatas_with_id_and_type.

	ID-WSF 2.0: in saml2_login.c, change API
	 * lasso/id-wsf-2.0/saml2_login.c:
	   - change private lasso_saml20_login_assertion_add_discovery to public
	     lasso_login_idwsf2_add_discovery_bootstrap_epr.
	   - remove lasso_saml20_login_copy_assertion_epr, add
	     lasso_login_idwsf2_get_discovery_bootstrap_epr.
	 * docs/reference/lasso/lasso-docs.sgml:
	   - add sections id_wsf_2_0_login
	 * docs/reference/lasso/lasso-sections.txt:
	   - add new functions to section id_wsf_2_0_login

	ID-WSF 2.0: in idwsf2_helper.c, add new functions, fix old things
	 - add lasso_wsa_endpoint_reference_get_service,
	   lasso_wsa_endpoint_reference_associate_service_type_uri,

	ID-WSF 2.0: create idwsf2_helper.{c,h}, new module for manipulating EPR elements
	 * lasso/id-wsf-2.0/idwsf2_helper.c lasso/id-wsf-2.0/idwsf2_helper.h:
	   add new functions
	   lasso_wsa_endpoint_reference_get_idwsf2_service_type,
	   lasso_wsa_endpoint_reference_get_idwsf2_provider_id,
	   lasso_wsa_endpoint_reference_get_idwsf2_security_context_for_security_mechanism,
	   lasso_wsa_endpoint_reference_get_token_by_usage,
	   lasso_wsa_endpoint_reference_get_security_token,lasso_wsa_endpoint_reference_get_target_identity_token,
	   lasso_wsa_endpoint_reference_new_for_idwsf2_service,
	   and lasso_wsa_endpoint_reference_add_security_token.
	 * lasso/id-wsf-2.0/idwsf2_helper.h:
	   declare new functions.
	 * lasso/id-wsf-2.0/Makefile.am:
	   add new files to source list

	ID-WSF 2.0: in soap_binding.{c,h}, add new functions

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-WSF 2.0: add files soap_binding.c, soap_binding.h
	 * lasso/id-wsf-2.0/Makefile.am
	   - reference new source files in Makefile.am
	 * lasso/id-wsf-2.0/soap_binding.c
	 * lasso/id-wsf-2.0/soap_binding.h:
	   - add extraction functions lasso_soap_envelope_sb2_get_provider_id,
	     lasso_soap_envelope_sb2_get_redirect_request_url,
	     lasso_soap_envelope_sb2_get_target_identity_header,
	   lasso_soap_envelope_add_action and lasso_soap_envelope_get_action.
	   - add SOAP security headers accessors
	   - add lasso_soap_envelope_get_saml2_security_token which simplify
	     retrieving a SAML 2.0 assertion used as a WS-Security token.
	     complete documentation of other functions.
	 * docs/reference/lasso/lasso-sections.txt:
	   - reference the new functions in a new section soap_binding2
	 * docs/reference/lasso/lasso-docs.sgml:
	   - add new section soap_binding2

	ID-WSF 2.0: in soap_binding.{c,h}: add function

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-WSF: in id_ff_extensions.c, add SECTION gtk-doc declaration

	ID-WSF: in interaction_profile_service.{c,h}, make initialization of a redirect request, part of LassoWsfProfile methods.

	ID-WSF: in discovery.c:lasso_discovery_init_resource_offering, add doc annotations, use assignment macros to set output argument

	ID-WSF: in discovery.c, update documentation annotations
	 * lasso/id-wsf/discovery.c:
	   - add annotations to lasso_discovery_init_query,
	     lasso_discovery_init_modify, lasso_discovery_process_request_msg.
	   - initialize response in lasso_discovery_process_query_mesg and
	     lasso_discovery_process_modify_msg, so that modifications of the
	     response can be done between _process_ and _build_ calls.

	ID-WSF: in data_service.c:lasso_data_service_init_query check absent resource offering, support security_mech_id argument
	 * lasso/id-wsf/data_service.c lasso/id-wsf/data_service.h:
	   - in lasso_data_service_apply_modifications, dst_modification
	     initialization is missing.
	   - remove lasso_data_service_get_redirect_request_url
	   - change LASSO_DATA_SERVICE_CANNOT_ADD_ITEM to
	     LASSO_DATA_SERVICE_ERROR_CANNOT_ADD_ITEM
	   - in lasso_data_service_init_query, complete documentation, fix mem
	     leak
	   - factorize code between lasso_data_service_build_modify_response_msg
	     and lasso_data_service_build_query_response_msg, create
	     lasso_data_service_build_response_msg
	   - in lasso_data_service_get_answer, add out annotation to output
	     parameter
	   - simplify API, simplify code path for query and modification
	     processing
	   - add lasso_data_service_process_request_msg,
	     lasso_data_service_build_modify_response_msg,
	     lasso_data_service_validate_request.
	   - remove lasso_data_service_process_query_msg and
	     lasso_data_service_process_modify_msg from public API.
	   - in lasso_data_service_process_query_msg and
	     lasso_data_service_process_modify_msg add arg checks, make them
	     static and move preprocessing of the request in
	     lasso_data_service_process_request_msg.
	   - in lasso_data_service_get_answer, fix request/response mismatch.
	   - add accessors lasso_data_service_set_resource_data and
	     lasso_data_service_get_resource_data.
	   - add securit_mech_id arg to data_service_init_modify, export
	     resource_data accessor methods
	   - remove lasso_data_service_get_redirect_request_url
	   - fix missing intializations and leaks

	ID-WSF: in wsf_profile.c, fix mem leaks

	ID-WSF XML: in dst_modification.c, add SNIPPET_BOOLEAN to overrideAllowed attribute snippet

	ID-WSF XML: in dst_modify.{c,h}, remove extra argument to the constructor of LassoDstModify
	 * lasso/xml/dst_modify.c:
	 * lasso/xml/dst_modify.h:
	   remove parameters of the default constructor.

	Tests: in tests/login_tests.c, change path of header utils.h

	Tests: in basic_tests.c, fix, do not overwrite known elements mappings
	 * tests/basic_tests.c:
	   when testing functionality of lasso registries which map namespace
	   elements to lasso objects, do not use liberty namespace because it
	   interacts with other tests -- deserialization of lib:Assertion node
	   was broken by this test -- when running them in CK_FORK=no mode.
	   Changed namespace LASSO_LIB_HREF, for "coin" which is less dangerous.

	WS XML: change signature of lasso_wsa_attributed_uri_new_with_string, add mappings
	 * wsa_attributed_uri.c:
	   - constify first argument of
	     lasso_wsa_attributed_uri_new_with_string.
	   - add add direct mappings from wsa:Action,wsa:To to
	     LassoWsAddrAttributedURI and from wsa:From,wsa:ReplyTo,wsa:FaultTo
	     to LassoWsAddrEndpointReference

	SAML 2.0: in login.c, use lasso_server_saml2_assertion_setup_signature

	XML: in private.h, remove duplicate declaration of lasso_xml_parse_memory

	ID-FF XML: in lib_assertion.c, add registry mapping for lib:AssertionType
	 * xml/lib_assertion.c:
	   this object is really a container for lib:AssertionType, so register
	   it.

	Core: in provider.c, add lasso_provider_verify_single_node_signature
	 * lasso/id-ff/provider.c lasso/id-ff/provider.h:
	   add a new function to check an enclosed single signature on a
	   LassoNode, given that the LassoNode retained its original xml node
	   content.

	SAML 2.0: in login.c, fix memleaks
	 * lasso/saml-2.0/login.c:
	   return value from lasso_provider_get_sp_name_qualifier must be freed.

	SAML 2.0: in login.c, remove discovery bootstrap handling

	Core Login: in login.c, add assertion accessor
	 * docs/reference/lasso/lasso-sections.txt:
	   declare new function
	 * lasso/id-ff/login.c lasso/id-ff/login.h:
	   add new function lasso_login_get_assertion.
	 * lasso/saml-2.0/login.c:
	   store created assertions
	 * lasso/id-ff/login.h:
	   make assertion field private for bindings.

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0: in saml2_helper.c, add new methods to manipulate SAML2 assertions
	 * lasso/saml-2.0/saml2_helper.c lasso/saml-2.0/saml2_helper.h:
	   - add lasso_server_saml2_assertion_setup_signature, to help in
	     defining signature upon saml2:Assertion nodes.
	   - add new symbols LASSO_DURATION_MINUTE, LASSO_DURATION_HOUR,
	     LASSO_DURATION_DAY, LASSO_DURATION_WEEK.
	   - add method lasso_saml2_assertion_add_attribute_with_node

	 * docs/reference/lasso/lasso-sections.txt:
	   declare new functions in saml2_helper section.

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Tests: in basic_tests.c, check LassoSaml2EncryptedElement handling

	SAML 2.0 XML: map EncryptedID, EncryptedAssertion, EncryptedAttribute and NewEncryptedID element to saml2:EncryptedElement
	 * lasso/xml/saml-2.0/saml2_encrypted_element.c:
	   add registry mapping from EncryptedID, EncryptedAssertion,
	   EncryptedAttribute and NewEncryptedID element to
	   saml2:EncryptedElement

	SAML 2.0 XML: in strings.h, add the identifier for the holder of key subject confirmation method

	SAML 2.0: in provider.c, add node encryption function and reference it in doc
	 * lasso/saml-2.0/Makefile.am:
	   add new header provider.h
	 * lasso/saml-2.0/provider.c lasso/saml-2.0/provider.h:
	   add new function lasso_provider_saml2_node_encrypt to encrypt nodes
	   and encapslutate the XML Enc datas in a LassoSaml2EncryptedElement
	   node.
	 * docs/reference/lasso/lasso-sections.txt:
	   add function to saml2_utils section

	WS XML: add forgotten include file to wsa_attributed_uri.c and wsa_endpoint_reference.c

	WS Errors: in errors.h errors.c, add new error section for WS-Security handling

	Core: in server.c, change signature of lasso_server_get_provider, add anottations on return value
	 * lasso/id-ff/server.h lasso/id-ff/server.c:
	   - constify first argument of lasso_server_get_provider
	   - add annotation about caller owned return value

	Core: in tools.c, complete documentation of lasso_verify_signature

	Core: in provider.c, add accessors for encryption informations
	 * lasso/id-ff/provider.c:
	   add getters for encryption_sym_key_type and encryption_public_key.
	 * lasso/id-ff/providerprivate.h:
	   declare new accessors.

	Core XML: in xml.{c,h}, add new function lasso_node_get_name to get the element name for an object

	Core XML: make first argument of lasso_misc_text_node_new_with_string const
	 * lasso/xml/misc_text_node.h lasso/xml/misc_text_node.c:
	   change signature of lasso_misc_text_node_new_with_string, string
	   argument is const.

	Core XML: in xml/tools.c, add conversion method from iso8601 to time_t
	 * lasso/xml/tools.c:
	   add function lasso_iso_8601_gmt_to_time_t
	 * lasso/xml/private.h:
	   declare new function.

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core XML: in xml.c, keep original node names, handle xsi:type attribute better
	 * lasso/xml/xml.c lasso/xml/xml.h:
	   - fix signature of lasso_node_set_original_xmlnode, fix signature in
	     documentation of lasso_node_set_original_xmlnode;
	   - add a new API lasso_node_set_custom_nodename to specify the exact
	     element name to use when serializing a LassoNode to XML.
	   - rename internal structure _CustomNamespace to _CustomElement, add a
	     nodename field to it.
	   - rework internal functions around _CustomElement to be aware of an
	     existing attached _CustomElement and re-use if needed.
	   - move application of _CustomElement hints after the serialization of
	     the node, so that the normal behaviour of the serialization is kept
	     -- i.e. do not play with the list of parent classes.

	   - use the full xsi:type content to find a LassoNode subclass when
	     de-serializaing XML content, factorize QName->GObject class mapping
	     for the three executions paths inside
	     _type_name_from_href_and_nodename:
	      - element QName,
	      - xsi:type QName,
	      - element name with xsi:type namespace
	   - add a long comment expliciting the way the mapping is done.
	   - remove direct mapping of EncryptedAssertion element, the registry
	     declaration on the class LassoSaml2EncryptedElement shoud be
	     enough.

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core XML: in xml.c, parse attributes with namespace checking
	 * lasso/xml/xml.c:
	   - use snippet->ns_uri and snippet->ns_name to parse attributes
	     outside of the parent node namespace.

	Core XML: in xml/tools.c, improve lasso_eval_xpath_expression, do not fail when nodeset is empty
	 * lasso/xml/tools.c:
	   only check that the query returned a nodeset object, do not check its
	   content size.

	Core: in utils.h, add a macros, fix existing
	 * lasso/utils.h:
	   - add macro lasso_ref(object), if object is not null, call
	     g_object_ref on it, and return the value, otherwise do nothing and
	     return NULL.
	   - make a better reporting of bad object release
	   - change format type for __LINE__ and dest arguments in
	     lasso_release_gobject warning display.
	   - add a lasso_check_non_empty_string macro
	   - add new macro to extract a specific node type from a list of
	     GObject objects.
	   - use xmlStrdup not g_strdup for lasso_assign_xml_string
	   - add lasso_list_add_gstrv and lasso_check_good_rc
	   - add macro lasso_list_get_first_child
	   - add inline function to test empty string
	   - change macro lasso_check_non_empty_string to use the new inline
	     function and go to cleanup
	   - fix lasso_check_non_empty_string macro
	 * lasso/utils.c:
	   - add lasso_gobject_is_of_type returns 0 if first parameters is a
	     gobject whose GType is equal to the second parameter, and 1
	     otherwise.

	Core: add new errors LASSO_PROFILE_ERROR_INVALID_RESPONSE, LASSO_PROFILE_ERROR_INVALID_REQUEST.

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: in bindings.py, parse '(in)' gobject-introspection annotation, in utils.py, use it to reverse default annotation for pointer of pointers
	Bindings: in bindings.py, improve regular expression for declarations

	Bindings: parse gobject-introspection annotation in return value
	documentation, add cast to C calls when parameter type is const in java
	binding, problem arise with const char ** arrays

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: do not stop on failing to parse a declaration, but skip the function and print a warning

	Python binding: add a pyobject->time_t conversion function

	Bindings python: in wrapper_top.c, mark internal function as potentially unused

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: make the binding infrastructure understand GObject-introspections annotations
	 * bindings/bindings.py
	 * bindings/utils.py:
	   add convenience function to treat arguments tuple:
	   (type,name,{annotations}).
	   introduce new argument options, fix that arguments are 3-tuple of the
	   form (type,name,annotations), where annotations is a dictionary.
	   Key of this dictionnary can be:
	    - optional, wheter the argument is necessary, it means it has a
	      default value.
	    - out, means that the pointer is a pointer of pointer, for bindings
	      that can return exceptions, it will be returned instead of the
	      integer error code, the only way to access error codes will be
	      exceptions.
	    - element-type, contained type of a list or an array,
	    - key-type, value-type, type of respectively the key and value of a
	      GHashTable.
	    - transfer, wheter a the callee(for arguments)/caller(for return
	      values) owns the values passed, it can be none,container(if the
	      callee/caller only owns the container not the contained value) or
	      full.
	    doc.parameters is now a 3-tuple of (attribute-name,
	    attribute-description, attribute-annotations) where
	    attribute-annotations is a string of the form '(option1)(option2
	    option-arguments) etc.'.
	   - add predicates for xml, list and time_t values. improve predicates
	     for cstring and const modifier.

	*  bindings/overrides.xml:
	    'out' arguments are not well supported for java, so skip functions
	    using them.

	 *  bindings/java/lang.py bindings/php5/php_code.py
	    bindings/php5/wrapper_source.py bindings/python/lang.py:
	    - update language specifig binding generators for handling new
	      annotations.
	    - improve python method declaration, handle optional arguments with
	      default values, factorize this chode in two methods,
	      get_python_arg_decl and defval_to_python_value.

	 *  bindings/python/tests/Makefile.am
	    bindings/python/tests/idwsf1_tests.py
	    bindings/python/tests/idwsf2_tests.py:
	    make test work with out of source build dir.

2010-01-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Documentation: in lasso-docs.sgml, add glossary to the index, add book part delimitations
	 * docs/reference/lasso/lasso-docs.sgml:
	   add the glossary to the index.

	Core: in registry.c, change type cast to compile on amd64 platform
	 * registry.c:
	   use ptrdiff_t to cast to integer big enough to receive a pointer,
	   then apply integer operations, then cast to the pointer type expected
	   by g_direct_hash.

2009-12-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: in utils.h, change __STRING(x) for #x
	 * lasso/utils.h:
	   __STRING(x) does not seem more portable than #x so change, problem
	   with AIX.

2009-12-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Downgrade version 2.2.90 to make a pre-release

2009-12-08  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	in tests/tests.h, Add checks for true and false conditions

	Remove beginning of a PHP4 binding

	Upgrade version number

	Add missing headers to makefile, to pass make distcheck
	 * lasso/xml/id-wsf-2.0/Makefile.am:
	   make xml_idwsf2.h appear in the distribution file
	 * lasso/xml/ws/Makefile.am:
	   make xml_ws.h appear in the distribution file

2009-12-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	in lasso_saml20_profile_export_to_query, checks return values
	 * lasso/saml-2.0/profile.c:
	   in lasso_saml20_profile_export_to_query, check return value of of
	   lasso_node_build_query and lasso_query_sign.

2009-12-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add SP initiated logout test to SAML 2.0 regression tests
	 * tests/login_tests_saml2.c:
	   add logout to first SAML 2.0 login regression test.
	 * tests/tests.h:
	   add macros to simplify checking of return value with check macros
	   (encapsulate fail_unless macro to check for NULL/non-NULL values and
	   good rc value (0) or expected bad value).

2009-11-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Restore ancient semantic of lasso_profile_is_session_dirty
	 * lasso/id-ff/profile.c:
	   lasso_is_session_dirty must return FALSE if session is NULL.

	Fix double g_object_unref
	 * lasso/id-ff/login.c:
	   status is already freed by lasso_assign_gobject, do not free it first
	   with lasso_node_destroy.

	Restore call to autoheader in autogen.sh
	 * autogen.sh:
	   call to autoheader was removed during simplification of the
	   autogen.sh script.

	Remove message level signature on redirect messages
	 * lasso/saml-2.0/profile.c:
	   remove message level signatures before building query strings.

	Add more check to remove_signature
	 * lasso/saml-2.0/profile.c:
	   check for NULL when accessing klass datas.

2009-11-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Augment query string limit for relaystate extraction to 8192 bytes
	 * lasso/xml/tools.c:
	   some application transfer relaystate longer thant the specification
	   advised 80 bytes, try to cater for their needs.

	Add documentation for lasso_get_relaystate_from_query
	 * lasso/xml/tools.c:
	   add documentation on the internal function
	   lasso_get_relaystate_from_query

2009-10-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add C defines for SAML 2 'unspecified' authncontext class
	  * lasso/xml/strings.h:
	    add C defines for AuhtnContextClassRef,
	    urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified.

	Fix bad macro choice, precise error for bad formatted NIDM request
	 * saml-2.0/name_id_management.c:
	   use specialized lasso_saml20_profile_set_response_status
	   set 'MissingNameID' second level error with requester first level
	   error code when request is missing a name id.

	Fix reporting of error in message parsing
	 * lasso/xml/xml.c:
	   do not mix the return code from xmlSecBase64Decode and the return
	   code for lasso_node_init_from_message_with_format.
	   It fixes a segmentation fault in
	   lasso_login_process_authn_request_msg.

2009-10-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: factorize code to obtain a SPNameQualifier
	 * lasso/id-ff/provider.c lasso/id-ff/provider.h:
	   add a method giving the SPNameQualifier for a provider (its entity id
	   or its affiliation id).

	 * lasso/id-ff/profile.c:
	 * lasso/saml-2.0/login.c:
	   update use sites.

2009-10-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Make php4 and perl binding disabled by default
	 * configure.ac:
	   make default for --enable-perl and --enable-php4 to "no". Those
	   binding will not be maintained in the future.

	SAML2 Logout: initialize SessionIndex from the assertion
	 * lasso/saml-2.0/logout.c:
	   when creating a logout request message initialize the SessionIndex
	   element with the correponding content in the stored assertion for
	   this session.

	Tests: fix __FILE__ -> __file__
	 * tests/integration/saml2/__init__.py:
	   path to the current python file is __file__ not __FILE__.

	SAML2: change lasso_saml20_profile_set_response_status signature
	 * lasso/saml-2.0/profile.c:
	 * lasso/saml-2.0/profileprivate.h:
	   make lasso_saml20_profile_set_response_status2 the new implementation
	   of lasso_saml20_profile_set_response_status.
	   add helper macros to set success, responder and requester first level
	   status code.
	 * saml-2.0/assertion_query.c:
	 * saml-2.0/login.c:
	 * saml-2.0/logout.c:
	 * saml-2.0/name_id_management.c:
	   adapt consumers to the new signature.

	ID-FF: add a partial_logout flag to LassoLogout private_data
	 * lasso/id-ff/logout.c:
	 * lasso/id-ff/logout.h:
	   add a flag to store the status of a partial logout

	SAML2: add an equals operator to the NameID class
	 * lasso/xml/saml-2.0/saml2_name_id.c:
	 * lasso/xml/saml-2.0/saml2_name_id.h:
	   add a lasso_saml2_name_id_equals method which return TRUE if two
	   NameId are equal.

	SAML2: use the static get_provider helper method in generic profile methods
	 * lasso/saml-2.0/profile.c:
	   instead of accessing directly profile->server use the helper method
	   get_provider.

	SAML2: in logout_build_response_msg do not fail on missing remote_providerID
	 * lasso/saml-2.0/logout.c:
	   remote_providerId is verified in build_redirect_simple and is not
	   necessary for SOAP response with a failure and profile->response
	   cannot be null (we just created a response if it was missing).
	   So this error case is now unnecessary.

	ID-FF1.2 and SAML2: remove direct access to profile->server->providers
	 * client of LassoServer should use lasso_server_get_provider.
	 * LASSO_PROFILE_ERRROR_UNKNOWN_PROVIDER was a mistake, it is
	   superfluous, use LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND.

	Core: in profile, use lasso_server_get_provider
	 - lasso/id-ff/profile.c:
	   replace direct access to server->provider by
	   lasso_server_get_provider.

2009-09-29  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Tests: add a test of NameIDFormat extraction
	 - tests/basic_test.c:
	   add test11_get_default_name_id_format which parse a metadata file and
	   try to extract the default name id format.
	 - tests/data/sp5-saml2/metadata.xml:
	   add NameIDFormat node for testing.

	Core: add const modifier to return value of lasso_provider_get_metadata_list
	 - lasso/id-ff/provider.c lasso/id-ff/provider.h:
	   change return type of lasso_provider_get_metadata_list from GList* to
	   const GList*.
	 - lasso/id-ff/logout.c lasso/saml-2.0/logout.c
	   lasso/saml-2.0/provider.c:
	   change consumers of the API

	Core: Add const modifiers to LassoProvider methods
	 * lasso/id-ff/provider.c lasso/id-ff/provider.h
	   lasso/saml-2.0/provider.c lasso/saml-2.0/provider.h:
	   add const modifier where they could be added.

	Do not use g_new, use g_new0
	 * lasso/id-ff/federation.c:
	 * lasso/id-ff/logout.c:
	 * lasso/id-ff/profile.c:
	 * lasso/id-ff/provider.c:
	 * lasso/id-ff/server.c:
	 * lasso/id-ff/session.c:
	 * lasso/id-wsf/authentication.c:
	 * lasso/saml-2.0/ecp.c:
	 * lasso/xml/xml.c:
	   even for private datas, use g_new0, it is safer.

	Change setting of default NameIDFormat for SAML 2.0 login
	 * saml-2.0/login.c:
	   in lasso_saml20_login_init_authn_request,
	   lasso_saml20_login_init_idp_initiated_authn_request, if the service
	   provider provided a list of supported name id formats, use the first
	   one as default for new AuthnRequest.
	 * id-ff/login.c:
	   modify documentation to report the new way of choosing a default.

	Add method to Provider to retrieve default NameIDFormat
	 * lasso/id-ff/provider.c lasso/id-ff/provider.h:
	   add lasso_provider_get_default_name_id_format, which returns the firs
	   listed NameIDFormat from the SAML 2.0 metadatas of the provider.

	Complete documentation of lasso_login_init_authn_request concerning the NameIDFormat
	 * lasso/id-ff/login.c:
	   in lasso_login_init_authn_request, add docbook formatting, add
	   remarks about the different NameIDFormat for ID-FF 1.2 and SAML 2.0.

2009-09-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix bugs found via coverity (thanks to Bhaskar Jain)
	 * lasso/id-wsf-2.0/data_service.c: fix uninitialized res variable in
	   lasso_idwsf2_data_service_process_query_response_soap_fault_msg.
	 * lasso/xml/saml-2.0/saml2_assertion.c: fix uninitialized rc variable
	   in get_xmlNode.
	 * lasso/saml-2.0/login.c:
	   in lasso_saml20_login_accept_sso check for ni and ni->Format
	   null-ness before dereferencing, remove idp_ni which is not used
	   anymore.
	   remote all use of federation->remote_nameIdentifier, SAML 2.0 only
	   need one NameID, and it will be local_nameIdentifier.
	 * lasso/xml/xml.c:
	   in lasso_node_traversal, check null-ness of node before dereferencing
	   it, add check for class null-ness also.
	 * lasso/id-ff/provider.c:
	   in lasso_provider_get_first_http_method, remove useless check for t2
	   null-ness -- if found is TRUE, t1 and t2 cannot be null.
	 * lasso/xml/tools.c:
	   in lasso_sign_node, add documentation, check for private_key_file and
	   xmlnode null-ness.
	   in lasso_get_public_key_from_private_key_file, add a cleanup phase,
	   check for cert variabl null-ness befor appending, count the number of
	   certificates added.
	   in lasso_query_verify_signature, check that URL unescaping and base64
	   decoding are succesfull before using the decoded strings.
	 * lasso/saml-2.0/name_id_management.c:
	   in lasso_name_id_management_validate_request, fix mis-handling of
	   federation, if federation does not match request name_id, return
	   UNKNOWN_PRINCIPAL.

	ID-WSF: finish unsealing field « is_dirty » of LassoSession
	 * lasso/id-wsf-2.0/session.c:
	   remove direct acces to LassoSession private field.

2009-09-11  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: unseal LassoSession public field
	 * lasso/id-ff/session.c:
	 * lasso/id-ff/session.h:
	 * lasso/id-ff/sessionprivate.h:
	   unseal session->is_dirty and session->assertions, remove the mirror
	   version in the private data structure, and restore direct acces by
	   methods.
	   move the "private" comment before those two fields to hide them in
	   the gtk-doc reference manual, normal access should be done by
	   get_assertion and is_dirty methods.

2009-09-11  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	XML ID-WSF: Fix parsing of most ID-WSF elements
	 * lasso/xml/disco_send_single_logout.c:
	 * lasso/xml/id-wsf-2.0/sb2_user_interaction_header.c:
	 * lasso/xml/id-wsf-2.0/subsref_app_data.c:
	 * lasso/xml/xml.c:
	   lots of ID-WSF 1.0/2.0 classes were not passing the new
	   non-regression test on serialization/deserialization.
	   The main reason was the absence of mapping for their namespace in the
	   prefix_from_href_and_nodename function. The other reason is that some
	   class name does not correspond 1-to-1 to the element name
	   (SendSingleLogOut vs. SendSingleLogout, notice the capitalised 'O').

	   The last problem was that mapping from nodes to GObject classes was
	   done after default mapping ("Lasso<prefix><node_name>"), now it's
	   done before, to reflect the fact that it is a more specialized
	   mapping.

2009-09-11  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: remove warning when lasso_registry_get_direct_mapping fails
	 * lasso/registry.c (lasso_registry_get_direct_mapping):
	  g_return_val_if_fail output a warning when condition fails, use a
	  simple if instead.

	Tests: add more assertion to random test
	 * tests/random_tests.c:
	   add more assertion testing for various return values or field values.

	XML: Fix seg-fault bug introduced in commit 4108
	 * lasso/xml/xml.c:
	   lasso_node_get_xmlnode_for_any_type is broken, if no original_xmlnode
	   is present, return just cur. Also add all missing cases for the state
	   of the pair (cur, orignal_xmlnode).
	 * tests/basic_tests.c:
	   add a non-regression test, testing all dump/restore functions.

	Core: add new macros to traverse lists
	 * lasso/utils.h:
	   lasso_foreach_full_begin(_type, _data, _iter, _list)
	   traverse GList* _list, using _iter as iteration variable
	   extract data field to variable _data of type _type.

	Test: fix Makefile.am to work with 'out of source' build directory
	 * tests/Makefile.am:
	   rpath must refer to the build directory, not the source directory.

	Core: fix extract_symbols regular expression
	 * lasso/extract_symbols.py:
	   the regular expression was not matching declaration over multiple lines,
	   and would catch argument starting with lasso_. Fixed.

	XML: add all inclusive header files for id-wsf2, ws, id-wsf XML elements
	 * lasso/xml/wsf/xml_ws.h:
	 * lasso/xml/id-wsf-2.0/xml_idwsf2.h:
	 * lasso/xml/xml_idwsf.h:
	   new files.

	ID-WSF 2.0: add set_request/set_response method to Profile object
	 * lasso/id-wsf-2.0/profile.c:
	 * lasso/id-wsf-2.0/profile.h:
	   add two methods that set the response object and replace the content
	   of the SOAP message with this object.

	XML SOAP: add new soap fault constructor
	 * lasso/xml/soap_fault.c:
	 * lasso/xml/soap_fault.h:
	   add a full constructor allowing to set faultcode and faultstring in
	   one call.

	XML ID-WSF 2.0: make non simple constructor of MiscTextNode return real type
	 * lasso/xml/misc_text_node.c:
	   non simple constructor must return the real object type because Java
	   binding does not work without it.

	XML SAML 1.1: fix schema figure for samlp:Request

	Docs: remove old lasso-sections.txt file

	ID-WSF 2.0: add accessor for field of LassoIdWsf2Profile
	 * lasso/id-wsf-2.0/profile.c lasso/id-wsf-2.0/profile.c:
	   add two accessor to get to soap_response and soap_request object,
	   next step is to make those two fields really private.

	ID-WSF: fix duplication of namespace string declaration, add fault codes for WS-Security
	 * lasso/xml/strings.h:
	   namespace of WS-Security 1.0 was duplicated,
	   add specified fault code linked to WS-Security.

	ID-WSF: remove LassoWsseSecurity in favor of LasoWsSec1SecurityHeader
	 * xml/Makefile.am:
	   remove the file from the source list
	 * xml/wsse_security.c:
	 * xml/wsse_security.h:
	   remove the files
	 * xml/xml.c:
	   use LassoWsSec1SecurityHeader for LASSO_WSSE_HREF namespace also.

	ID-WSF 1.0: use the common wsse:Security object
	 * lasso/id-wsf/wsf_profile.c:
	   use the common LassoWsSec1SecurityHeader object instead of the
	   specific LassoWsseSecurity, and set the needed namespace using
	   lasso_node_set_custom_namespace.
	   add implementation comments.

	WS: register LassoWsSec1SecurityHeader for all namespace associated to WS-Security
	 * lasso/xml/ws/wsse_security_header.c:
	   register all namespace that contains a Security header object.

	XML: add an API to set namespace on a single instance of a LassoNode
	 * lasso/xml/xml.h lasso/xml/xml.c:
	   add a new public API lasso_node_set_custom_namespace(node, prefix,
	   href). It allows to set the precise namespace of a single object, all
	   other instance of the same class continue to use the default
	   namespace for the class.
	   It should be used for difficult consumer of certain nodes (like
	   wsse:Security) which only know certain namespace or do not use the
	   namespace going with the specified version of a specification (like
	   MSP not following ID-WSF 1.0 specification and using
	   http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd
	   instead of
	   http://schemas.xmlsoap.org/ws/2003/06/secext.
	   It also allows to share implementation of schema objects common to
	   many version of the same specification (wsse:Security between ID-WSF
	   1.0 and ID-WSF 2.0), without creating too many child classes.

	ID-WSF 2.0: remove obsolete FIXME in discovery.h

	Core: remove a use of lasso_node_destroy in LassoSession

	Bindings: add support for guchar
	 * bindings/java/lang.py:
	 * bindings/python/lang.py:
	   add guchar to list of C types everywhere.

	XML: add support for free xml content to LassoMiscTextNode
	 * lasso/xml/misc_text_node.c:
	 * lasso/xml/misc_text_node.h:
	   it is often necessary to be able to put completely determined content
	   inside lasso generated request (for example when copying an assertion
	   for a Bearer authentication method). In this case you can use
	   lasso_node_get_original_xml_node to get at the original content and
	   lasso_misc_text_node_new_with_xml_node to get a LassNode with the
	   same content.
	   There are two additional function to acces this xml payload:
	   lasso_misc_text_node_get_xml_content and
	   lasso_misc_text_node_set_xml_content.

2009-08-28  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: fix commit 4313, restore support for --enable-wsf
	 * configure.ac:
	   I throwed the baby with the bathwater..

	Core: fix make dist with --enable-wsf
	 * lasso/id-wsf-2.0/Makefile.am:
	 * lasso/xml/Makefile.am:
	   some files were missing from the dist files, add them.

	Core: remove SWIG ID-WSF warning from configure.ac
	 * configure.ac:
	   as ID-WSF support in SWIG in not maintained anymore we can remove the
	   warning about using pre-generated SWIG files with a different setting
	   for the --enable-wsf flag.

	Binding: skip lasso_data_service_get_query_item
	 * bindings/overrides.xml:
	   bindings do not support out arguments, so skip generating bindings
	   for lasso_data_service_get_query_item for the moment.

	Core: set tar-pax as dist file format
	 * configure.ac:
	   we could have more than 99 characters long path in the dist files,
	   the pax format for tar archives support it.

	ID-WSF 1.0: Fixed missing or deprecated functions in public headers
	Some new functions were missing from the headers, others were deprecated
	some time ago and as the API is not considered stable for ID-WSF, I
	removed them definitely.

2009-08-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Bindings: Skip lasso_data_service_get_answers
	 * bindings/overrides.xml: skip unsupported function.

	Tests: add configuration file loading to integration test
	 * tests/integration/README:
	 * tests/integration/saml2/__init__.py:
	   If ~/.config/lasso_integration.conf exists, load it to find path to
	   authentic and lcs.
	   Add support for three environement variables:
	    - LASSO_BUILDDIR, to specify an out of source build directory to
	      test,
	    - NO_SILENT, to allow authentic and lcs outputs,
	    - VALGRIND, to check memory leaks using valgrind.

2009-08-26  Frederic Peters  <fpeters@entrouvert.com>

	Call gtkdocize before automake

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: errors.c is a generated file, when generating it place it in $(srcdir) not build directory
	 * lasso/Makefile.am:
	   the place for errors.c is in the source directory, not the build
	   directory.

	SAML 2.0: Fix bug introduced in commit 4235
	 * lasso/saml-2.0/login.c:
	   profile->msg_url is released before being used ;( Restore the code
	   copying the URL before passing it to
	   lasso_saml20_profile_build_http_redirect, to free it after.

	Core: Fix errors.c generation

	XML SAML2: remove typedef of LassoSaml2Assertion in saml2_advice.h and saml2_evidence.h
	 * xml/saml-2.0/saml2_advice.h xml/saml-2.0/saml2_evidence.h:
	   the declaration of LassoSaml2Assertion for supposedly preventing
	   recursive include is useless now.

	Core: fix spurious semi-colon inserted in commit 4093
	 * lasso/errors.h:
	   remove useless semi-colon

	Core: add assertion query to exported profiles
	 * lasso/lasso.h:
	   include lasso/saml-2.0/assertion_query.h

	XML: Add all including header fil for saml2, id-ff and id-wsf
	 * lasso/xml/xml_idff.h:
	   this header file reference all id-ff 1.2 elements
	 * lasso/xml/xml_idwsf.h:
	   this header file reference all id-wsf 1.0 elements
	 * lasso/xml/saml-2.0/xml_saml2.h:
	   this header file reference all saml-2.0 elements

	Core: Remove include of lasso.h in registry.h
	 * lasso/registry.h:
	   include of lasso.h is useless, replace by including directly export.h
	 * lasso/registry.c:
	   directly include errors.h

	ID-WSF: remove OFTYPE usage from header

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Docs: change the doc production and lot of other fixes
	 * lasso/Makefile.am:
	   distribute extract_sections.py
	 * docs/references/lasso/lasso.types.in: add missing class (mainly SAML2
	   and ID-WSF 1.0/2.0) from docs/references/lasso.types.in

	 * lasso/xml/strings.h:
	   add lots of documentation, or at least documentation template to
	   strings constants.
	 * id-ff/login.h:
	 * saml-2.0/assertion_query.h:
	 * xml/xml.h:
	   document undocumented enumerations.
	 * lasso/errors.h:
	   add proper documentation about error codes.
	 * lasso/errors.c:
	   new version of the lasso_strerror function
	 * lasso/build_strerror.py:
	   update the script that generater lasso_strerror from the
	   documentation comments.

	   Remove usage of OFTYPE

	 * lasso/id-ff/session.c:
	 * lasso/id-ff/session.h:
	   remove usage of oftype, prefer gtk-introspection annotations instead.
	 * lasso/id-wsf/data_service.h:
	 * lasso/id-wsf/data_service.c:
	   do the same.

	   Add a script to build lasso-sections.txt

	 * lasso/extract_sections.py:
	   this script parses header files and generated lasso-sections.txt
	   content for GObject class descriptions.

	   Add a template file for the lasso-section.txt file

	 * docs/references/lasso-sections.txt.in:
	   this file serves as a base for the generation of lasso-sections.txt

	   Update docs/references/Makefile.am for generating lasso-sections.txt

	 * docs/references/Makefile.am:
	   always rebuild template, using out of source build directory is too
	   weird without it.
	   call new script extract_sections.py to regenerate lasso-sections.txt
	   if header files changed.

	   Update lasso.sgml file with all missing sections

	 * docs/reference/lasso.sgml:
	   add all missing sections, mainly objects from XML schemas.

	 * docs/reference/lasso-sections.txt: update it

	 * *.c: add section documentation to some files.
	 * lasso/xml/strings.h: fix bad usage or docbook markup

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: fix makefile for generating errors.h in out of source dir build
	 * lasso/Makefile.am:
	   errors.h is expected to be in srcdir not builddir.

	Bindings: for functions that must be totally skiped do it during parsing
	 * bindings/bindings.py:
	   parsing of argument type is still not advanced enough, so in order to
	   remove spurious warnings, skip function directly during parsing just
	   before the treatment of function signature.

	Tests: in integration test do not set the PYTHONPATH
	 * tests/integration/saml2/__init__.py:
	   to permit using build directory different from the src directory, do
	   not force the PYTHONPATH to be relative to src dir to find lasso
	   python module.

	Tests: do not hardcode PYTHONPATH in the valgrind wrapper
	 * tests/integration/valgrind-wrapper.sh: remove PYTHONPATH setting.

	Tests: distribute integration tests
	 * tests/Makefile.am:
	   add integration directory to the distdir.

	Core: Use automake-1.11 when possible
	 * Makefile.am:
	   use new automake-1.11 silent rules if possible
	   move macros to m4 directory
	 * m4/gtk-doc.m4:
	   add gtk-doc macros.
	 * lasso/Makefile.am:
	   add missing -f flag to rm, to unbreak make distcheck
	 * docs/references/Makefile.am:
	   fix problem between libtool and gtk-doc
	 * autogen.sh:
	   update to autogen.sh from gtk-doc, add support for automake-1.11

	Tests: Add data files to EXTRA_DIST
	 * tests/data/Makefile.am:
	   data file for tests2 were missing (to pass distcheck).

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	XML: remove all useless instance_init functions
	 * Use Coccinelle semantic patch tool (http://coccinelle.lip6.fr/) to
	   remove useless instance_init functions, the first patch applied was:
	@@
	type T,V;
	identifier I, J;
	parameter list P;
	expression E1;
	@@

	V instance_init(T node)
	{
	<...
	(
	-  E1 = 0;
	|
	-  E1 = NULL;
	|
	-  E1 = FALSE;
	)
	...>
	}
	   It removes useless initialization to 0 (GObject already zeroes
	   allocated objects).
	   The second one is:
	@ rule1 @
	type T;
	identifier node,fn;
	@@

	- static void fn(T *node) { }

	@ rule2 extends rule1 @
	typedef GType, GInstanceInitFunc;
	identifier type_constructor;
	@@
	GType type_constructor()
	{
	<...
	- (GInstanceInitFunc)fn
	+ NULL
	...>
	}
	   It removes empty instance_init functions.

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	sb2:TargetIdentity can have a content
	 * lasso/xml/id-wsf-2.0/sb2_target_identity.c:
	 * lasso/xml/id-wsf-2.0/sb2_target_identity.h:
	   add support for any content.

	All: Rework include files handling, separated ID-WSF code from SAML2/ID-FF code
	 * nearly all C files: change includes for relative paths.
	 * lasso/id-wsf/id_wsf.h, lasso/id-wsf-2.0/id_wsf_2.h: add top level
	   public include files for ID-WSF 1.0 and ID-WSF 2.0.
	 * lasso/id-ff/server.*, lasso/id-ff/session.*, lasso/id-ff/identity.*:
	   remove most of the code related to ID-WSF and push into
	   lasso/id-wsf/id_ff_extensions.* and lasso/id-wsf-2.0/identity.c,
	   lasso/id-wsf-2.0/server.c, lasso/id-wsf-2.0/session.c.
	 * lasso/id-wsf-2.0/saml2_login.c,
	   lasso/id-wsf-2.0/saml2_login_private.h: same change but for ID-WSF
	   2.0 support in SAML2 SSO profile.

	Bindings: skip ID-WSF methods with unsupported signatures
	 * bindings/overrides.xml:
	   some functions have output parameters (pointer on pointers) that are
	   currently not supported by our binding generator, so we skip them.

	SWIG: unplug id-wsf support in SWIG
	 * swig/Lasso.i:
	   force LASSO_WSF_ENABLED to be undefined.

	Tests: allow tests2 to pass distcheck
	 * tests/Makefile.am
	   add an SRCDIR symbol.
	   remove unused include paths.
	 * tests/tests2.c:
	   use SRCDIR to find data files.

	Tests: remove internal content from data files
	 * tests/data/response-3:
	   this dump of a SAML message contains elements and attribute outside
	   the SAML schema, implementation detail from Lasso. They broke
	   execution of tests/tests2.

	XML&SAML 2.0: add missing include files
	 * lasso/xml/saml-2.0/saml2_encrypted_element.h:
	   xmlSecKey is present in a function signature, so include
	   xmlsec/xmlsec.h.

	SWIG: implement change to LassoSession in the SWIG interface file
	 * swig/Lasso.i:
	   remove LassoSession::is_dirty attribute and rewrite the
	   getProviderIds function.

	XML: only recurse into xml/id-wsf subdirs if --enable-wsf is true
	 * lasso/xml/Makefile.am:
	   put id-wsf and id-wsf2 subdirs under a conditionnal.

	ID-WSF 1.0: remove absent header file from the Makefile.am
	 * lasso/id-wsf/Makefile.am:
	   remove data_service_private.h from header file list.

	Core: SOAP is also used by SAML bindings
	 * extract_symbols.py, extract_types.py:
	   export SOAP types whatever the value of the flag --enable-wsf.
	   It still worked because constructor for GObject calls get_type, but
	   there is a race condition: if you receive a SOAP message before
	   sending one, it fails. Only soap_binding types must be removed.

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-FF&Core: Seal public field of LassoSession
	 * id-ff/session.h: seal public fields.

	 * id-ff/session.c, id-ff/sessionprivate.h: add accessors for reading
	   the is_dirty flag and counting store assertions.

	 * id-ff/logout.c, id-ff/login.c, saml-2.0/login.c, saml-2.0/logout.c,
	   saml-2.0/profile.c: use the new accessors.

	 * id-ff/profile.c: include the private header file, use the new
	   accessors, and remove unnecessary setting of is_dirty to FALSE (it
	   should be false at instanciation).

	 * utils.h: add a macro to access private content, prepare for using
	   G_TYPE_INSTANCE_GET_PRIVATE and the GObject infrastructure for
	   private structures eventually.

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-WSF 2.0: remove unused variable
	 - lasso/id-wsf-2.0/discovery.c: remove unused variable in discovery.c

	Core: fix bad name of lasso_unlink_and_release_node
	 * lasso/utils.h:
	   - rename lasso_unlink_and_release_node to
	     lasso_release_list_of_xml_node.
	   - add a GList iteration macro: lasso_foreach.

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-WSF: Lots of modifications
	 Migrate lots of code to use new utility macros. Try to simplify most
	 code paths or to factorize with LassoWsfProfile.

	 * lasso/id-wsf/wsf_profile.c:
	   Add API:
	    - lasso_wsf_profile_build_soap_response_msg to build SOAP fault for
	      Lasso errors,
	    - lasso_wsf_profile_set_msg_url_from_description, to set the
	      destination URL using the chosen LassoDiscoDescription (with
	      respect to the security mechanism),
	    - lasso_wsf_profile_init_soap_response to initialize a response to
	      the current request, to use in sub classes,
	    - lasso_wsf_profile_get_remote_provider_id, retrieve the SOAP
	      binding corresponding information,
	    - lasso_wsf_profile_get_remote_provider, simplification of
	      lasso_wsf_profile_get_remote_provider_id,
	    - lasso_wsf_profile_get_soap_fault, retrieve the last setted SOAP
	      fault, used by sub classes,
	    - lasso_wsf_profile_set_soap_fault, set a SOAP fault, to be returned
	      by the next call by lasso_wsf_profile_build_soap_response_msg, to
	      use in sub classes,
	    - lasso_wsf_profile_set/get_status_code, set/get the stored status
	      code, to use in the next lasso_xxx_build_response_message, to use
	      in sub classes.
	   Change name lasso_wsf_profile_get_description_autos to
	   lasso_wsf_profile_get_description_auto.
	   Do not access directly the session is_dirty field (it has been
	   sealed).

	 * lasso/id-wsf/wsf_profile.h:
	   Add helper macro lasso_wsf_profile_helper_set_status to set status
	   code of an ID-WSF response message containing a Status element using
	   the stored status code.
	 * lasso/id-wsf/wsf_profile_private.h:
	   Add new fields (moved public fields).
	   Add lasso_wsf_profile_set_msg_url_from_description,
	   lasso_wsf_profile_build_soap_fault_response_msg.
	 * lasso/id-wsf/data_service_private.h:
	   Remove file.
	 * lasso/id-wsf/data_service.h: Remove all public fields.
	 * lasso/id-wsf/data_service.c:
	   Remove private structure. Use the equivalents LassoWsfProfile private
	   fields. Update documentation. Use LassoWsfProfile generic functions
	   for initializing requests. Add API lasso_data_service_get_query_item,
	   lasso_data_service_get_answers, lasso_data_service_get_answer,
	   lasso_data_service_get_answers_by_select,
	   lasso_data_service_get_answer_for_item_id,
	   lasso_data_service_add_modification.
	   Remove lasso_data_service_need_redirect_user use equivalent function
	   lasso_interaction_profile_service_build_redirect_response_msg. Remove
	   lasso_data_service_get_resource_offering,
	   lasso_data_service_set_offering.
	 * lasso/id-wsf/discovery.c:
	   Add documentation. Change some signatures. Remove
	   lasso_discovery_get_description_auto. Change name of
	   lasso_discovery_init_insert to lasso_discovery_init_modify. Add a
	   generic lasso_discovery_process_request_msg.
	   Add internal function lasso_discovery_init_offering, to get
	   automatically an offering if possible. Remove useless init_from_xml.
	   Rework lasso_discovery_build_credential implementation.
	   overloading. Remove lasso_discovery_destroy.
	 * lasso/id-wsf/discovery.h:
	   Remove lasso_discovery_destroy.
	 * lasso/id-wsf/interaction_profile_service.c:
	   Add lasso_interaction_profile_service_build_redirect_response_msg.
	 * lasso/id-wsf/personal_profile_service.c:
	   Update lasso_personal_profile_service_get_email to use
	   lasso_data_service_get_answers_by_select.
	 * lasso/xml/dst_modify.c:
	   make modification parameter optional to the constructor.

2009-08-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: Add new error types
	 * lasso/errors.h lasso/errors.c:
	   add error types: LASSO_ERROR_CAST_FAILED,
	   LASSO_DATA_SERVICE_CANNOT_ADD_ITEM,
	   LASSO_WSF_PROFILE_ERROR_INVALID_OR_MISSING_REFERENCE_TO_MESSAGE_ID,
	   LASSO_DST_ERROR_QUERY_NOT_FOUND, LASSO_DST_ERROR_NO_DATA,
	   LASSO_DST_ERROR_MALFORMED_QUERY.

	XML: Add time formatting function for ISO 8601 format
	 * xml/private.h:
	 * xml/tools.c:
	   add util function to format time_t values in the ISO 8601 format.

	XML: Add any attribute parsing to Saml2AttributeValue
	 * xml/saml-2.0/saml2_attribute_value.h:
	   add new public field GHashTable *attributes;
	 * xml/saml-2.0/saml2_attribute_value.c:
	   add parsing instructions to populate attributes field.

	XML: add documentation for lasso_eval_xpath_expression
	* lasso/xml/tools.c: add documentation for xpath helper evaluation
	  function lasso_eval_xpath_expression.

	XML: add string constant for client soap errors
	* lasso/xml/strings.h: add new string constant
	  LASSO_SOAP_FAULT_CODE_CLIENT.

	XML: add documentation for lasso_idwsf2_disco_svc_md_register_new_full
	* lasso/xml/id-wsf-2.0/disco_svc_md_register.c: add documentation
	  for constructor function lasso_idwsf2_disco_svc_md_register_new_full.

	ID-WSF 1.0: Add new error to signal unknown entry
	* lasso/errors.{c,h}: add a new error for the ID-WSF 1.0 module, to
	  signal unknown entry in discovery responses.

	SWIG Binding: reflect changes in the signature of struct LassoIdWsfDiscovery
	 * swig/Lasso-wsf2.i (LassoIdWsfDiscovery):
	   add new fields metadatas and svcMDIDS, remove old ones (metadata
	   and svcMDID).

	ID-WSF 1.0: fix off-by one ref counting error in lasso_wsf_profile_init_soap_request
	 * lasso/id-wsf/wsf_profile.c (lasso_wsf_profile_init_soap_request):
	   envelope is an argument, increment its ref count
	   before storing it.

	ID-WSF 1.0: improve error recovery in lasso_wsf_profile_comply_with_saml_authentication
	 * lasso/id-wsf/wsf_profile.c
	   (lasso_wsf_profile_comply_with_saml_authentication):
	   reuse existing wsse-security element if present,
	   remove useless comments, move core code after argument type checks,
	   return error if enveloppe or header is missing,
	   fail if any referenced assertion is missing,
	   correctly handle reference count of wsse_security depending on
	   the situation (new or reused).

	ID-WSF 1.0: fix memory leak
	 * lasso/id-wsf/discovery.c (lasso_discovery_add_insert_entry):
	   the rule is that callee is responsible for becoming owner of a resource,
	   so no g_object_ref before a call on an argument.

	ID-WSF 2.0: publicize lasso_idwsf2_profile_build_soap_envelope
	 * lasso/id-wsf-2.0/profile.c, lasso/id-wsf-2.0/profile.h
	   (lasso_idwsf2_profile_build_soap_envelope):
	   as for ID-WSF 1.0 export this function to allow easier implementation
	   of external ID-WSF 2.0 services. remove FIXME comment and fill
	   equivalent bugzilla reports.

	ID-WSF 2.0: review lasso_idwsf2_discovery_process_metadata_register_response_msg
	 * lasso/id-wsf-2.0/discovery.c
	   (lasso_idwsf2_discovery_process_metadata_register_response_msg):
	   change return code variable to rc, move argument casting after argument
	   type check, copy all the service metadata ids,

	ID-WSF 2.0: review lasso_idwsf2_discovery_process_metadata_register_msg
	 * lasso/id-wsf-2.0/discovery.c
	   (lasso_idwsf2_discovery_init_metadata_register):
	   add documentation comment, move argument casting after type checking,
	   change return code name to rc to comply with standardisation,
	   use lasso_build_unique_id instead of duplicating the code,
	   add iteration over all the registered service, add iteration
	   to return all the generated service metadata ids, use new assignment
	   macros.
	 * lasso/id-wsf-2.0/discovery.h (struct _LassoIdWsf2Discovery):
	   change field LassoIdWsf2DiscoSvcMetadata metadata to GList* metadatas
	   and gchar *svcMDID to GList *svcMDIDs in order to support multiple
	   services in requests.

	ID-WSF 2.0: review lasso_idwsf2_discovery_metadata_register_self
	 * lasso/id-wsf-2.0/discovery.c
	   (lasso_idwsf2_discovery_metadata_register_self):
	   Add documentation, add code for getting the service URL.

	ID-WSF 2.0: add documentation to lasso_idwsf2_discovery_register_self
	 * lasso/id-wsf-2.0/discovery.c (lasso_idwsf2_discovery_register_self)
	   move casting after argument type check, simplify code by using
	   lasso_build_unique_id, remove useless comments

	ID-WSF 2.0: simplify gobject boilerplate
	 * lasso/id-wsf-2.0/discovery.c: (get_xmlNode, instance_init, class_init)
	   remove useless method get_xmlNode, remove useless NULLing or
	   instance fields.

	ID-WSF 2.0: use new macros
	 * lasso/id-wsf-2.0/data_service.c (lasso_idwsf2_data_service_init_query,
	   lasso_idwsf2_data_service_parse_query_items,
	   lasso_idwsf2_data_service_init_modify,
	   lasso_idwsf2_data_service_parse_one_modify_item,
	   lasso_idwsf2_data_service_parse_modify_items):
	   add cast, change macros for stealing version, fix name of macro
	 * lasso/id-wsf-2.0/profile.c: (lasso_idwsf2_profile_init_soap_request)
	   use list handling macro, add missing casts
	 * lasso/id-wsf-2.0/discovery.c:
	   (lasso_idwsf2_discovery_process_metadata_association_add_msg,
	    lasso_idwsf2_discovery_init_query) add missing casts

	ID-WSF 2.0: add a new constructor for UtilStatus
	 - lasso/xml/id-wsf-2.0/utils_status.h (lasso_idwsf2_util_status_new_with_code):
	   this constructor allow to construct and fill a UtilStatus node with
	   one line. It has two arguments to construct nested two level
	   status objects (with two status codes). If you omit the second
	   argument you get a one level status object.

	ID-WSF 2.0: add initialization of local variables

	ID-WSF 2.0: Use new XPath API in DST
	 - lasso/id-wsf-2.0/data_service.c:
	   - lasso_idwsf2_data_service_parse_query_items: use the new API to
	   remove error outputs from libxml, and generate an additional status
	   code containing newly returned libxml error code.
	   - lasso_idwsf2_data_service_parse_one_modify_item: use the new API.

	XML: add API to simplify evaluation of XPath expressions
	* lasso/xml/tools.c,lasso/xml/private.h:
	  - lasso_eval_xpath_expression(xmlXPathContextPtr xpathCtx,
	    const char *expression, xmlXPathObjectPtr *xpathObjectPtr,
	    int *xpathErrorCode) is a boolean returning function handling call
	    to libxml API to evaluate en XPath expression in the xpathCtx
	    context. It eventually save the returned nodeset in the variable
	    pointed by xpathObjectPtr if it is not-NULL
	    (and eventually deallocate previous value)
	    and if an error happend it copy its code into the variable
	    pointed to by xpathErrorCode if it is not NULL.

	Tests: Add a fourth data loading test
	 * tests/data/response-4: test content
	 * tests/tests2.c: add loading of the new file.

2009-07-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Only recurse into id-wsf if it is enabled
	 * lasso/Makefile.am:
	   only add id-wsf and id-wsf-2.0 to SUBDIRS if wsf is enabled.

	Fix: backward_comp.h is missing from tarballs.
	 * lasso/Makefile.am:
	   add backward_comp.h to EXTRA_DIST

2009-06-15  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Python Binding: fix bug of uninitialized ppos argument to PyDict_Next
	 * bindings/pyhton/wrapper_top.c (set_hashtable_of_pygobject):
	   second argument (int*ppos) of PyDict_Next must be reinitialized to
	   zero before each traversal (see Python C API
	   http://docs.python.org/c-api/dict.html).

	   Patch from Iban Rodríguez of the Desarrollo de Producto Electrónico,
	   Spain.

2009-06-15  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Update doap file

	Do not remove signatures on assertion when using HTTP Redirect
	 * lasso/saml-2.0/profile.c:
	   HTTP Redirect binding mandate to remove signature at the SAML message
	   level, but signatures at the assertion, especially if the SP asked for
	   it, must be preserved.

2009-05-07  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix bug in lasso_registry_destroy / shutdown
	 * lasso/registry.c:
	   if not initialized, do not free. do not segfault on NULL argument.

	Do not respect default semantic of dst:Query
	 * lasso/id-wsf-2.0/data_service.c:
	   the specification for data service template indicat that the query
	   must fail at the first failing query, we think this is a stupid
	   behaviour so I set the default to keep running query until the last
	   one and returning a partial result if at least one failed and a
	   failed result if absolutely no query matched.
	 * lasso/id-wsf-2.0/private.h:
	   declare the lasso_flag_follow_id_wsf_supid_semantic flag.
	 * lasso.c:
	   declare the lasso_flag_follow_id_wsf_supid_semantic flag, it's
	   conditionned by the LASSO_WSF_ENABLED preprocessor symbol.

2009-04-30  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add valgrind support to integration tests
	 * tests/integration/saml2/__init__.py:
	   if /usr/bin/valgrind exist, use script valgrind-wrapper.sh to launch
	   tests, it stores log files in {authentic,lcs}_$ISODATE_pid$PID.log.

	Fix leak in python binding
	 * bindings/python/wrapper_top.c:
	   keep a pointer on beginning of list to free it.

	Fix leak of mapping registry
	 * lasso/lasso.c:
	 * lasso/registry-private.h:
	 * lasso/registry.c:
	   make the registry be freed in lasso_shutdown.

	ID-FF 1.2: Fix leaks, reduce code
	 * id-ff/login.c:
	 * id-ff/logout.c:
	 * id-ff/profile.c:
	 * id-ff/provider.c:
	 * id-ff/server.c:
	   fix leaks by using field setting macros which frees previous values,
	   it also reduce code length sometimes.

	Export the new flag
	 * lasso/debug.h:
	   export new flag lasso_flag_sign_messages.

	Fix leaks in tests
	 * basic_tests.c:
	 * login_tests.c:
	 * login_tests_saml2.c:
	 * random_tests.c:
	   free replaced string, unref used nodes, initialize local variables
	   when necessary, free newly allocated strings.

	Add a script to format suppression file
	 * tests/format-suppressions.py:
	   this is the script used to generate valgrind/lasso.supp and
	   valgrind/glib.supp.

	Add a stress test for serializing/deserializing code
	 * Makefile.am:
	   add targets
	 * tests2.c:
	   this simple makes lots of serializing, deserializing.
	 * data/response-1:
	 * data/response-2:
	 * data/response-3:
	   data test files

	SAML 2.0: Fix many leaks
	 * lasso/saml-2.0/login.c:
	 * lasso/saml-2.0/logout.c:
	 * lasso/saml-2.0/name_id_management.c:
	 * lasso/saml-2.0/profile.c:
	 * lasso/saml-2.0/provider.c:
	   do not mix g_malloc strings with libxml strings, use the
	   string/gobject handling macros as much as possible, be a good memory
	   citizen, don't put your elbows on the table.

	LassoNode: Fix leaks
	 * lasso/xml/xml.c:
	   fix more and more leaks.

	Add debugging code to lasso_node_impl_init_from_xml
	 * lasso/xml/xml.c:
	   add more debugging code for the memory-debug flag.

	Add debugging code to lasso_set_orginal_xmlnode
	 * lasso/xml/xml.c:
	   add code to trace allocation and deallocation of original xmlnode
	   associated to LassoNodes.

	Remove useless code
	 * lasso/xml/lib_authentication_statement.c:
	 * lasso/xml/saml-2.0/samlp2_name_id_policy.c:
	 * lasso/xml/saml_name_identifier.c:
	   remove useless initialization code.

	Fix leak in lasso_url_add_parameters
	 * lasso/xml/tools.c:
	   in lasso_url_add_parameters free intermediate strings.

	Fix debug echo on stdout
	 * lasso/utils.h:
	   make lasso_mem_debug output on stderr and not stdout

	Add new valgrind memleak suppression files
	 * tests/valgrind/glib.supp:
	   suppress all "static" allocation by glib, usually for the type
	   system.
	 * tests/valgrind/lasso.supp:
	   suppress allocations from lasso that we cannot actually remove, they
	   are all from "called only once" code, so it should not really be a
	   problem for embedded codes.

2009-04-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	More work on signature validation for SAML 2.0
	 * lasso/saml-2.0/profile.c:
	   in lasso_saml20_profile_process_any_request and
	   lasso_saml20_profile_process_any_response do not make signature
	   validation failure as call failure, just store the result in
	   profile->signature_status and let the upper level functions handle
	   what to do with it. also add documentation about those two functions.

	 * lasso/saml-2.0/logout.c:
	 * lasso/saml-2.0/name_id_management.c:
	   handle new signature_status semantic.

	 * lasso/saml-2.0/login.c:
	   add internal documentation for
	   lasso_saml20_login_process_authn_response_msg.

2009-04-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Update signature_status when checking signature on assertions
	 * lasso/saml-2.0/login.c:
	   if signature_status is SIGNATURE_NOT_FOUND, check one on the
	   assertion and keep the result in signature_status.

	Increase wait time for integration test
	 * tests/integration/saml2/__init__.py:
	   wait 5 seconds for dameons to start.

	review later

	FIX: verify assertion signature for SAML 2.0 when response is not signed
	 * lasso/saml-2.0/login.c:
	   if response was not signed, check the signature on the assertion.

	new function lasso_saml20_login_check_assertion_signature()
	 * lasso/saml-2.0/login.c:
	   lasso_saml20_login_check_assertion_signature() find the issuer of an
	   assertion, look it up in the server object and try to validate its
	   signature. It returns an error code if any of this step fails.

	Test: Remove spurious debugging printf
	 * tests/login_tests_saml2.c:
	   remove debug code.

	Add keep_xmlnode flag to SAML 2.0 req, resp and assertions
	 * lasso/xml/saml-2.0/saml2_assertion.c:
	 * lasso/xml/saml-2.0/samlp2_request_abstract.c:
	 * lasso/xml/saml-2.0/samlp2_response.c:
	 * lasso/xml/saml-2.0/samlp2_status_response.c:
	   set keep_xmlnode flag to 1 in class_init.

	new function lasso_profile_get_server()
	 * lasso/id-ff/profile.c:
	 * lasso/id-ff/profile.h:
	   in a move to try to remove direct access to object content, add a
	   function to retrieve the LassoServer object of a LassoProfile.
	 * bindings/overrides.xml:
	   it conflicts with direct access to the public field server, so we do
	   not export it in the binding for now.

	fix: in lasso_verify_signature() only look for the first direct child Signature element
	 * lasso/xml/tools.c:
	   in SAML message signatures are usually envelopped signatures, so just
	   lookup for the first direct child which is a Signature node.

	fix: handle non-LHS argument for lasso_extract_node_or_fail()
	 * lasso/utils.h:
	   create a temporary varaible to store result of second argument
	   evaluation to prevent spurious side effects.

	lasso_saml20_profile_init_artifact_resolve(): check http_method
	 * lasso/saml-2.0/profile.c:
	   check the given http_method it must one in
	   - LASSO_HTTP_METHOD_ARTIFACT_POST,
	   - LASSO_HTTP_METHOD_ARTIFACT_GET.

	lasso_login_init_request(): change error code for invalid artifacts
	 * lasso/id-ff/login.c:
	   if artifact is invalid return LASSO_PROFILE_ERROR_INVALID_ARTIFACT as
	   in lasso_saml20_profile_init_artifact_resolve().

	Complete documentation of lasso_login_init_request
	 * lasso/id-ff/login.c:
	   add precision on usage. add all possible return codes with meanings.

	lasso_login_init_authn_request: complete doc
	 * lasso/id-ff/login.c:
	   add all possible return codes and their meaning.

	lasso_login_init_authn_request: change error code for missing remote provider ID
	 * lasso/id-ff/login.c:
	   change the return code for when no remote provider ID could be
	   defined (because the argument is NULL and the server object contains
	   no providers) so that we can distingish the case where the given
	   provider is unknown or if there is no providers configured.

	Add a deprecated tag to lasso_login_destroy doc
	 * lasso/id-ff/login.c:
	   all destroy functions are deprecated, g_object_unref() should be used
	   instead.

	Complete documentation of lasso_login_byuld_response_msg
	 * lasso/id-ff/login.c:
	   add all possible return codes with meaning.

	Complete documentation of lasso_login_build_request_msg
	 * lasso/id-ff/login.c:
	   add all possible return codes with meaning.

	Complet documentation for lasso_login_build_authn_response_msg
	 * lasso/id-ff/login.c:
	   add all possible return codes with meaning.

	Complete documentation of lasso_login_build_authn_request
	 * lasso/id-ff/login.c:
	   add all possible return codes with meaning.

	Complete documentation for lasso_login_build_artifact_msg
	 * lasso/id-ff/login.c:
	   add all possible return codes with meaning.

	Complet documentation of lasso_login_accept_sso
	 * lasso/id-ff/login.c:
	   add all possible return codes.

	Complete doc for static function lasso_login_musk_ask_for_consent
	 * lasso/id-ff/login.c:
	   precise return value meaning.

	Complete document of lasso_login_build_assertion
	 * lasso/id-ff/login.c:
	   add possible return codes.

	Complete doc of lasso_logout_validate_request
	 * lasso/id-ff/logout.c:
	   add description of all possible return codes.

2009-04-23  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Rework cleanup handling
	 * lasso/utils.h:
	   change 'goto exit' for 'goto cleanup'. rename all goto_exit macros to
	   goto_cleanup_.  rename goto_cleanup_if_fail to
	   goto_cleanup_if_fail_with_rc and add a
	   goto_cleanup_if_fail for function which do not return an integer
	   value. add documentation for goto_cleanup macro family.
	 * lasso/id-ff/login.c:
	 * lasso/id-ff/provider.c:
	 * lasso/id-ff/server.c:
	 * lasso/id-ff/session.c:
	 * lasso/id-wsf/discovery.c:
	 * lasso/id-wsf/wsf_profile.c:
	 * lasso/saml-2.0/profile.c:
	 * lasso/utils.h:
	 * lasso/xml/lib_logout_request.c:
	 * lasso/xml/tools.c:
	 * lasso/xml/xml.c:
	   update name of goto_exit_if_fail macros. rename 'exit' labels to
	   'cleanup'.

	XML: Fix prefix clobbering by xsi:type handling
	 * lasso/xml/xml.c:
	   if xsi:type is not able to find a GObject typename for the current
	   node, then do not erase the actual prefix value. change prefix type
	   to const char.

	SAML 2.0: Use new API lasso_url_add_parameter
	 * lasso/saml-2.0/profile.c:
	   use new API lasso_url_add_parameter to handle RelayState parameter
	   creation.

	SAML 2.0: Check http_method in build_artifact_msg
	 * lasso/saml-2.0/login.c:
	   if http_method is not among ARTIFACT_GET and ARTIFACT_POST, return an
	   INVALID_HTTP_METHOD error.

	Tests: Add test parsing a Ping Federate assertion.
	 * tests/basic_tests.c:
	   load data/response-1 and try to parse it.

	Add a new internal API for parameters building
	 * xml/tools.c:
	   add lasso_url_add_parameter that concat the string &key=value to an
	   existing URL where key and value are url-encoded.
	 * xml/private.h:
	   declare lasso_url_add_parameter.

	Tests: Add a SAML2 login test
	 * tests/login_tests_saml2.c:
	   add a C login test for SAML 2.
	 * tests/Makefile.am:
	   add the new test to dependencies.

2009-04-21  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	If no typename could be determined, stop parsing.
	 * lasso/xml/xml.c:
	   in lasso_node_new_from_xmlNode if no typename is found for the given
	   xmlNode, return NULL.

2009-04-17  Jerome Schneider  <jschneider@entrouvert.com>

	Fix python 2.4 binding build

2009-04-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: Add cast to first argument of isalnum
	 * lasso/xml/xml.c:
	 * lasso/xml/tools.c:
	   isalnum takes a int as first arg.

	Core: add an header file for backward compatibility
	 * lasso/backward_comp.h:
	   this header will contain substitue function, defines or types for
	   compatibility with older versions of dependencies.
	 * lasso/utils.h:
	   remove declaration of g_strcmp0
	 * lasso.c:
	 * tests/login_tests.c:
	   use backward_comp.h

2009-04-09  Jerome Schneider  <jschneider@entrouvert.com>

	Fix build issues on amd64 / gcc 4.3
	* bindings/java/lang.py:
	  fix cast issue
	* bindings/python/wrapper_top.c
	  fix type issue
	* lasso/registry.c
	  fix cast issue

2009-04-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Tests&Core: add g_strcmp0 if glib is old
	 * lasso/utils.h:
	   if glib is older than 2.16, export g_strcmp0 as part of internal
	   headers, in order to use it in login_tests.c
	 * tests/login_tests.c:
	   include utils.h

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Update website download page
	 * website/web/download/index.xml:
	   update link for last release download
	 * website/web/news/13-release-2.2.2.xml:
	   add news about release 2.2.2

	Update lasso version to 2.2.2
	 * configure.ac:
	 * fedora/lasso.spec:
	 * lasso.doap:
	   update lasso version to 2.2.2, this commit will be the reference for
	   the 2.2.2 release.

	Makefile: change dependencies to pass distcheck
	 * lasso/Makefile.am:
	   source dependencies must refer to $(srcdir) in order to pass
	   distcheck, I forgot to do it in types.c and symbols.sym target
	   changes.

	ID-FF 1.2: if logout request parsing fails, take a shortcut
	 * lasso/xml/lib_logout_request.c:
	   immediately return from init_from_query if overloaded parent method
	   fails.

	SAML 2.0: Update generic relaystate handling
	 * lasso/saml-2.0/profile.c:
	   in lasso_saml20_profile_build_redirect_request_msg and
	   lasso_saml20_profile_build_redirect_response, use new function
	   lasso_saml20_profile_build_http_redirect.

	Core: add a add-signature flag
	 * lasso/debug.h:
	 * lasso/lasso.c:
	   add a lasso_flag_add_signature flag variable (default to TRUE),
	   and parsing code to change it from LASSO_FLAG environment variable.
	   ("env LASSO_FLAG=no-add-signature test").

	ID-FF 1.2: Only verify InResponseTo if strict checking is on
	 * lasso/id-ff/login.c:
	   add condition upon checking of the InResponseTo field: checks only if
	   strict checking is activated as it could stop old code using Lasso
	   from working.

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: Add a flag for enabling more strict checking
	 * lasso/debug.h:
	   declare lasso_flag_strict_checking global boolean variable.

	 * lasso/lasso.c:
	   add parsing for new option called 'strict-checking'.

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	XML: use macro for assignment
	 * lasso/xml/xml.c: use standardized assignment macros (it takes care of
	   releasing previous valuesm and other peculiarities associated with
	   safe pointer usage).

	ID-FF 1.2: Add trace in dispose for LassoProfile
	 * lasso/id-ff/profile.c: add tracing code activaged by
	   LASSO_FLAG=memory-debug to print release of field values.
	   Complement the existing code in generic deallocation procedure in
	   LassoNode.

	Core: debug.h need export.h
	 * lasso/debug.h:
	   export.h is needed for the LASSO_EXPORT macro.

	Core: Macros to print deallocation messages
	 * lasso/utils.h:
	   lasso_mem_debug print deallocation message with respect to class and
	   field.

	Core: remove type check equality on gobject macros
	 * lasso/utils.h:
	   assignment to the temporary variable allow to check for the typing,
	   do not use lasso_check_type_equality.

	Core: add macros to handle xmlSecKey
	 * lasso/utils.h:
	   macros to assign and release xmlSecKey(s).

	XML: fix memory leaks
	 * lasso/xml/tools.c:
	 * lasso/xml/xml.c:
	   release xmlDoc, properly steal nodes by using xmlSetTreeDoc(xmlnode, NULL);

	ID-FF 1.2: fix style fault
	 * lasso/id-ff/defederation.c:
	 * lasso/id-ff/logout.c:
	 * lasso/id-ff/profile.c:
	 * lasso/id-ff/provider.c:
	 * lasso/id-ff/server.c:
	   add missings casts, remove useless wrappers
	 * lasso/id-ff/logout.c:
	   In lasso_logout_process_request_msg change sequence of "if" for a
	   "switch".

	ID-FF 1.2: fix some real and potential memory leaks
	 * lasso/id-ff/provider.c:
	 * lasso/id-ff/server.c:
	 * lasso/id-ff/session.c:
	   use macros to release previous value when necessary,
	   release object used as parameters to constructors,
	   free the encryption key associated with a provider,
	   release the key manager created for a saml signature
	   verification.

	Test: add missing release of objects and memory
	 * tests/basic_tests.c:
	 * tests/login_tests.c:
	 * tests/metadata_tests.c:
	 * tests/random_tests.c:
	 * tests/tests.c:
	   add missing g_free and g_object_unref calls.

	Bindings: skip DEPRECATED variables
	 * bindings/bindings.py: when parsing headers, skipped deprecated struct
	   fields.

	ID-FF 1.2: Add handling of relaystate for logout requests
	 * lasso/id-ff/logout.c (lasso_logout_process_request_msg,
	 lasso_logout_validate_request): transfer relaystate from request
	 message to profile field.

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-FF 1.2: Use new macros in logout, defederation and lecp
	* lasso/id-ff/logout.c:
	 - (lasso_logout_build_response_msg, lasso_logout_init_request,
	    lasso_logout_process_request_msg, lasso_logout_process_response_msg,
	    lasso_logout_validate_request) use lasso_assign_new_object,
	   lasso_assign_string, lasso_release and lasso_assign_new_string when
	   possible.
	 - (lasso_logout_process_response_msg) move the tranfer of the relaystate
	   from XML object to profile object.

	* lasso/id-ff/defederation.c:
	 - (lasso_defederation_build_notification_msg,
	    lasso_defederation_init_notification,
	    lasso_defederation_process_notification_msg,
	    lasso_defederation_validate_notification): idem

	* lasso/id-ff/lecp.c:
	 - (lasso_lecp_build_authn_request_envelope_msg,
	    lasso_lecp_build_authn_request_msg,lasso_lecp_build_authn_response_msg,
	    lasso_lecp_build_authn_response_envelope_msg) idem

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Autoconf: Do not include optimisation flags in AM_CFLAGS
	* configure.ac: when --enable-debugging set CFLAGS,
	  do not modify AM_CFLAGS.

	ID-FF 1.2 Tests: Add test for relaystate
	* tests/login_tests.c:
	 - (test02_serviceProviderLogin) add assertion concerning the relaying
	   of the RelayState parameter during an SP initiated SSO.

	ID-FF 1.2 Login: Use allocation macros
	* lasso/id-ff/login.c: (lasso_login_init_authn_request) again a passing by
	  correction, use lasso_assign_string for copying information from
	  the request to the profile object.

	ID-FF 1.2: Handle RelayState inside LassoLogin
	 * lasso/id-ff/login.c:
	   - (lasso_login_init_request) catch RelayState in the query_fields and
	     copy it to msg_relayState
	   - (lasso_login_process_authn_request_msg) copy RelayState from the
	     request object to the profile object.

	XML ID-FF 1.2 & SAML 2.0: Handle signature failure
	 * lasso/xml/saml_assertion.c:
	 * lasso/xml/samlp_response_abstract.c:
	 * lasso/xml/samlp_request_abstract.c:
	 * lasso/xml/saml-2.0/samlp2_request_abstract.c:
	 * lasso/xml/saml-2.0/saml2_assertion.c:
	 * lasso/xml/saml-2.0/samlp2_status_response.c:
	   if a failure occur in the signing process, free the xmlnode, return
	   NULL and print a warning.

	XML SAML 2.0: Delete parent_class static variable
	* lasso/xml/saml-2.0/samlp2_manage_name_id_request.c,
	  lasso/xml/saml-2.0/samlp2_manage_name_id_response.c,
	  lasso/xml/saml-2.0/samlp2_name_id_mapping_request.c,
	  lasso/xml/saml-2.0/samlp2_name_id_mapping_response.c.
	  lasso/xml/saml-2.0/samlp2_subject_query_abstract.c:
	  - remove static variable parent_class
	  - (class_init) remove intialization of parent_class

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	XML SAML 2.0: Mark RelayState field from SAML 2.0 deprecated
	 * lasso/xml/saml-2.0/samlp2_authn_request.c,
	   lasso/xml/saml-2.0/samlp2_logout_request.c,
	   - (instance_init) remove initialization of relayState field

	 * lasso/xml/saml-2.0/samlp2_logout_response.c:
	   - (instance_init) remove empty function, since it
	     only initialized relayState.
	   - (lasso_samlp2_logout_reponse_get_type) remove instance_init
	     from the type initialization structure.

	 * lasso/xml/saml-2.0/samlp2_authn_request.h,
	   lasso/xml/saml-2.0/samlp2_logout_request.h,
	   lasso/xml/saml-2.0/samlp2_logout_response.h:
	   - (struct _LassoSamlp2*) mark relaystate field as deprecated.

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	XML SAML 2.0: Clean query string parsing/building
	 * lasso/xml/saml-2.0/samlp2_status_response.c:
	   - (init_from_query) remove useless stub code for parsing RelayState

	 * lasso/xml/saml-2.0/samlp2_response.c,
	   lasso/xml/saml-2.0/samlp2_name_id_mapping_response.c,
	   lasso/xml/saml-2.0/samlp2_logout_response.c,
	   lasso/xml/saml-2.0/samlp2_manage_name_id_response.c, :
	   - (class_init) remove overloading of init_from_query, use version
	     from samlp2_status_response instead.
	   - (init_from_query) Useless so deleted.

	 * lasso/xml/saml-2.0/samlp2_request_abstract.c:
	   - (class_init) add overloaded method for init_from_query virtual
	     method.
	   - (init_from_query) generic implementation for SAML 2.0 requests

	 * lasso/xml/saml-2.0/samlp2_subject_query_abstract.c,
	   lasso/xml/saml-2.0/samlp2_authn_request.c,
	   lasso/xml/saml-2.0/samlp2_logout_request.c,
	   lasso/xml/saml-2.0/samlp2_manage_name_id_request.c,
	   lasso/xml/saml-2.0/samlp2_name_id_mapping_request.c,
	   lasso/xml/saml-2.0/samlp2_assertion_id_request.c:
	   - (class_init) remove overloading of init_from_query, use version
	     from samlp2_request_abstract instead.
	   - (init_from_query) Useless so deleted.

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	XML: Remove useless parsing of RelayState in lasso_node_init_from_saml2_query_fields
	* lasso/xml/xml.c: (lasso_node_init_from_saml2_query_fields) Since parsing
	    of the relayState is now done inside each "_process_*msg" method of
	    each SAML2 profile, it is not needed anymore in this function.

	XML: Use memory macros inside lasso_node_export_to_query
	 * lasso/xml/xml.c (lasso_node_export_to_query): use lasso own memory
	   handling macros.

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-FF 1.2: review HTTP-Redirect binding parsing/building
	 * lasso/xml/lib_authn_request.c, lasso/xml/lib_logout_request.c,
	   lasso/xml/lib_register_name_identifier_request.c,
	   lasso/xml/lib_status_resposne.c:
	   - build_query: remove build_query overloaded virtual method, use
	     LassoNode new generic implementation.
	   - init_from_query:
	     - change direct call to lasso_node_init_from_query_fields to use of
	       base implementation from LassoNode.
	     - make use of utils.h memory handling macros like
	       lasso_release_gobject and lasso_assign_string.

	 * lasso/xml/lib_federation_termination_notification.c:
	   - init_from_query: remove parsing of RelayState parameter

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-FF 1.2: Defederation, changes includes for relative paths
	 * lasso/id-ff/defederation.c: header path should be relative to the
	   implementation, I will try to do it to most files.

	ID-FF 1.2: Defederatopm HTTP-Redirect binding, handle relaystate
	 * lasso/id-ff/defederation.c: get relaystate directly from the query
	   string using lasso_get_relaystate_from_query.

	SAML 2.0: In login change includes for relative paths
	 * lasso/id-ff/login.c: changes headers for relatives paths

	Core: Remove ending blanks from erros.c.in
	 * lasso/errors.c.in: errors.c template contains blanks at end of lines.

	SAML 2.0: add direct treatment of relaystate for HTTP-Redirect binding
	* lasso/saml-2.0/login.c: In
	  lasso_saml20_login_process_authn_request_msg change handling of
	  relayState do not rely upon parsing by the node object, but extract
	  directly from the query string. Use new function
	  lasso_get_relaystate_from_query.
	* lasso/saml-2.0/logout.c: In lasso_saml20_logout_process_request_msg
	  change handling of relayState do not rely upon parsing by the node
	  object, but extract directly from the query string.
	* lasso/saml-2.0/profile.c: In
	  lasso_saml20_profile_init_artifact_resolve, add handling of the
	  relayState transmitted to the assertion consumer URL.
	* lasso/saml-2.0/name_id_management.c: In
	  lasso_name_id_management_process_request_msg change handling of
	  relayState do not rely upon parsing by the node
	  object, but extract directly from the query string.

	SAML 2.0: simplify redirect binding code path
	 * lasso/saml-2.0/login.c, lasso/saml-2.0/logout.c,
	   lasso/saml-2.0/name_id_management.c: simplify code path associated
	   with generation of the url for the HTTP-Redirect binding using the
	   rencently introduced function
	   lasso_saml20_profile_build_http_redirect.

	SAML 2.0: remove TODO comment about RelayState
	 * lasso/xml/saml-2.0/samlp2_status_response.c: do it:)

	XML SAML2: Remove unnecessary overloading of build_query in request/respons objects
	 * lasso/xml/saml-2.0/samlp2_assertion_id_request.c,
	   lasso/xml/saml-2.0/samlp2_authn_request.c,
	   lasso/xml/saml-2.0/samlp2_logout_request.c,
	   lasso/xml/saml-2.0/samlp2_logout_response.c,
	   lasso/xml/saml-2.0/samlp2_manage_name_id_request.c,
	   lasso/xml/saml-2.0/samlp2_manage_name_id_response.c,
	   lasso/xml/saml-2.0/samlp2_name_id_mapping_request.c,
	   lasso/xml/saml-2.0/samlp2_name_id_mapping_response.c,
	   lasso/xml/saml-2.0/samlp2_response.c,
	   lasso/xml/saml-2.0/samlp2_subject_query_abstract.c: remove useless
	   overloading of build_query virtual method, revert to implementations
	   in LassoSamlp2RequestAbstract and LassoSamlp2StatusResponse.

	XML SAML 2.0: add a build query to request base class
	 * lasso/xml/saml-2.0/samlp2_request_abstract.c: add a build query
	   overloaded function to LassoSamlp2RequestAbstract class, the base
	   class of all saml 2.0 request nodes.

	SAML 2.0: Add helper function to implement the HTTP-Redirect binding
	 * lasso/saml-2.0/profile.c, lasso/saml-2.0/profileprivate.h:
	   - remove_all_signature traverse a tree of LassoNode objects to unset
	     all signature_type field in on nodes supporting signature
	     generation.
	   - lasso_saml20_profile_export_to_query does the job of generateing
	     the url containing the message content and the relaystate, then
	     sign it using lasso_query_sign.
	   - lasso_saml20_profile_build_http_redirect use those two functions
	     and the metadatas to build the signed redirect url.

	XML: Add const modifiers to lasso_concat_url_query arguments
	 * lasso/xml/private.h, lasso/xml/tools.c: add const modifier to
	   lasso_concat_url_query arguments.

	XML: Remove static modifier on lasso_node_build_query
	 * lasso/xml/private.h, lasso/xml/xml.c: remove static modifier to
	   lasso_node_build_query and export it for use in id-ff profiles.

	XML: Tool function to extract relaystate from query
	 * lasso/xml/tools.c, lasso/xml/private.h: new function
	   lasso_get_relaystate_from_query to help in relaystate handling.

	Core: rename lasso_release_xmlchar to lasso_release_xml_string
	 * lasso/id-wsf/wsf_profile.c, lasso/utils.h, lasso/xml/xml.c: rename
	   lasso_release_xmlchar to lasso_release_xml_string.

	Core: Fix double instantiation of macro parameters
	* lasso/utils.h:
	 - (lasso_assign_new_string,lasso_assign_gobject) if source parameter
	   is a function call it could be called two times and have unexpected
	   side effects. Copy the returned value to a temp variable and use it
	   instead.

	Core: Fix corner case in deallocation macros
	 * lasso/utils.h: When setting strings using lasso_assing_string or
	   lasso_assign_new_string, verify that new string is different than the
	   target value string before deallocating the target.

	Add missing intializations
	 * initialize local variables.

	Core: replace direct use of xmlSecSoap function by wrapper
	 * lasso/xml/xml.c:
	   In lasso_node_init_from_message_with_format remove direct use of
	   xmlSecSoap* functions because they emit too much warning by lasso
	   reimplementations.

	Core: remove use of XPath
	 * lasso/xml/xml.c:
	   in lasso_node_new_from_soap, instead of using XPath use function
	   lasso_xml_get_soap_content.

	Core: fix comment for lasso_node_init_from_message
	 * lasso/xml/xml.c:
	   state the return code type.

	Core: remove lasso_node_decrypt implementation
	 * lasso/xml/xml.c:
	   remove code for lasso_node_decrypt.

	Core: make comment agree with the code
	 * lasso/xml/xml.c:
	   change comment about xsi:type handling, we try to honor every
	   xsi:type.

	Core: remove commented code
	 * lasso/xml/xml.c:
	   remove commented code to handle a specific lasso extension.

	Core: use lasso_xml_parse_memory instead of xmlParseDoc
	 * lasso/id-ff/provider.c:
	   use internal wrapper instead of direct call to libxml for parsing.

	Core: move parse xml wrapper from xml.c to tools.c
	 * lasso/xml/xml.c:
	   remove lasso_xml_parse_memory.
	 * lasso/xml/tools.c:
	   add lasso_xml_parse_memory to wrap xmlParseDocument.
	 * lasso/saml-2.0/name_id_management.c:
	   use lasso_xml_parse_memory

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0 NameIDManagement: use new generic methods
	 * lasso/saml-2.0/name_id_management.c:
	   use new generic methods in lasso_name_id_management_init_request,
	   lasso_name_id_management_build_request_msg,
	   lasso_name_id_management_process_request_msg,
	   lasso_name_id_management_validate_request,
	   lasso_name_id_management_build_response_msg,
	   lasso_name_id_management_process_response_msg.
	   Remove useless boilerplate code.

	 * lasso/id-ff/server.c:
	 * lasso/id-ff/serverprivate.h:
	   last user of lasso_server_nameid_decrypt removed, so remove the code.

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0 Logout: use generic methods
	 * lasso/saml-2.0/logout.c:
	   use new generic methods in
	   lasso_saml20_logout_process_request_msg, and
	   lasso_saml20_logout_process_response_msg.

	SAML 2.0 Login: use generic methods
	 * lasso/saml-2.0/login.c:
	   use new generic profile methods for saml 2.0 in
	   lasso_saml20_login_process_paos_response_msg,
	   lasso_saml20_login_process_authn_response_msg,
	   lasso_saml20_login_process_response_status_and_assertion.

	SAML 2.0: add name id include to login.c
	 * lasso/saml-2.0/login.c:
	   add include saml2_name_id.h

	XML SAML 2.0: add a decrypt function to Saml2EncryptedElement
	 * lasso/xml/saml-2.0/saml2_encrypted_element.c:
	   using new function lasso_node_decrypt_xmlnode implement the new
	   method, int lasso_saml2_encrypted_element_decrypt(
	     LassoSaml2EncryptedElement* encrypted_element,
	     xmlSecKey *encryption_private_key, LassoNode **decrypted_node).
	   This function is currently not exported by bindings because of the
	   last ouput argument which is not supported by the binding generator.

	SAML 2.0: replace lasso_node_decrypt by lasso_node_decrypt_xmlnode
	 * lasso/xml/private.h:
	 * lasso/xml/tools.c:
	   replace implementation of lasso_node_decrypt by a new one called
	   lasso_node_decrypt_xmlnode, and use it where old one was used.

	SAML 2.0: reduce code in lasso_assertion_query_process_request
	 * lasso/saml-2.0/assertion_query.c:
	   use new code in SAML 2.0 profile.c to parse requests and decrypt
	   nameid, chains calls so that error are kept but all actions are
	   accomplished anyway (if first call fails, keep the error but continue
	   the processing, then at end return the first returned error).

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0: add internal generic implementation
	 * lasso/saml-2.0/profile.c:
	 * lasso/saml-2.0/profileprivate.h:
	   the current effort is to simplify implementation code in saml-2.0 and
	   much of the other frameworks. Those new methods:
	        lasso_saml20_init_request
	        lasso_saml20_profile_process_name_identifier_decryption
	        lasso_saml20_profile_process_soap_request
	        lasso_saml20_profile_process_soap_response
	        lasso_saml20_profile_process_any_request
	        lasso_saml20_profile_process_any_response
	        lasso_saml20_profile_setup_request_signing
	        lasso_saml20_profile_build_request_msg
	        lasso_saml20_profile_build_response
	        lasso_saml20_profile_init_response
	   should help reduce code in login.c, logout.c, name_id_management.c
	   and assertion_query.c. They should also permit to make all profiles
	   at the same level of binding support
	   (GET,REDIRECT,POST,ARTIFACT_GET,ARTIFACT_POST).

	   Those function centralize error code handling, initialization of
	   commong class (LassoSamlp2StatusResponse and
	   LassoSamlp2RequestAbstract) and also the handling of NameID
	   decryption.

2009-03-27  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: add new internal macro lasso_extract_node_or_fail
	 * lasso/utils.h:
	   this new macro try to extract a field from a structre (or any
	   left-hand-side value), try to typecheck it using 'LASSO_IS_XXX',
	   if succesfull, the value is assigned to the variable given as first
	   argument or we jump to the 'cleanup' goto label, setting the 4th
	   argument as the current error code (value of variable 'rc').

	ID-WSF 2.0: make it work with --enabe-debugging
	 * lasso/id-wsf-2.0/data_service.c:
	 * lasso/id-wsf-2.0/discovery.c:
	 * lasso/id-wsf-2.0/profile.c:
	 * lasso/id-wsf/data_service.c:
	 * lasso/id-wsf/discovery.c:
	 * lasso/id-wsf/wsf_profile.c:
	   when --enable-debugging is activated much more type checking is done
	   by internal macros, and code do not pass compile anymore.
	 * bindings/python/tests/idwsf2_tests.py: nameIdentifier packing in SOAP
	   ID-WSF calls headers is no longer supported, do not test it.

	Core: add argument checking to lasso_server_get_provider
	 * lasso/id-ff/server.c:
	   In lasso_server_get_provider, return NULL if provider server is not
	   one, provider is null or 0-length.

	Core: add new internal API lasso_provider_verify_query_signature
	 * lasso/id-ff/provider.c:
	   try to keep some homgeneity between lasso_verify_signature and
	   lasso_verify_query_signature functions, by having mirror methods
	   inside the LassoProvider class. this new methods comes with complete
	   documentation.
	 * lasso/xml/tools.c:
	   add a xmlDoc argument to lasso_verify_signature, in order to
	   reuse an already built message context, and possible problems with
	   interned string in parsed xml documents.

	Core: add xmlDoc parameter to lasso_provider_verify_saml_signature
	 * lasso/id-ff/provider.c:
	   add an xmlDoc parameter to lasso_provider_verify_saml_signature,
	   reflecting change in lasso_verify_signature.
	   fix memory leaks of an xmlSecKeysMngr.
	   complete arguments checking.
	 * lasso/id-ff/login.c:
	   update use of lasso_provider_verify_signature in LassoLogin

	Core: add a terminating value to enum LassoHttpMethod
	 * lasso/id-ff/provider.h:
	   add LASSO_HTTP_METHOD_LAST to enum LassoHttpMethod.

	ID-FF 1.2: rework lasso_login_process_status_and_assertion
	 * lasso/id-ff/login.c:
	   reword lasso_login_process_status_and_assertion,
	   remove wrong NameID decryption code (it cannot work),
	   adapt to new signature of lasso_provider_verify_saml_signature,

	Core: new init method with format limit and xmlDoc output argument
	 * lasso/xml/private.h:
	 * lasso/xml/xml.c:
	   lasso_node_init_from_message_with_format permit to initialize a node
	   and to keep the corresponding xml document, in order for example to
	   validate a signature.
	 * lasso/xml/tools.c:
	   lasso_xml_parse_message is able to parse a message of any type, or of
	   a given type. If a message of another than the one specified is
	   found, the call fails, and a LASSO_MESSAGE_FORMAT_ERROR is returned.

	Core: add function to extract SOAP message content
	 * lasso/xml/tools.c:
	   add lasso_xml_is_soap, to verify that a message is SOAP.
	   add lasso_xml_get_soap_content, to retrieve the first child of the
	   SOAP body, whatever the SOAP content version.

	SAML 2.0: API for Saml2EncryptedElement decrypt
	 * lasso/xml/xml_enc.h:
	   remove old functions
	 * lasso/xml/private.h:
	   remove lasso_node_(de/en)crypt from public headers API, they were not
	   exported anyway. move them to internal header.
	 * lasso/xml/saml-2.0/saml2_encrypted_element.{c,h}:
	   add a new decrypt function to convert a EncryptedElement to the
	   contained encrypted node objects.
	 * bindings/overrrides.xml:
	   do not export the new method, wait for implementation of output
	   arguments.
	 * lasso/id-ff/server.c:
	   remove lasso_decrypt_nameid from lasso/id-ff/server.c

	Bindings php5: add support for xmlNode arguments
	 * bindings/php5/php_code.py:
	 * bindings/php5/wrapper_source.py:
	   complete error reporting about on documentation treatment.
	   treat xmlNode* arguments (convert string to xmlNode, give as
	   argument, then frees it).

	Bindings: fix documentation parsing
	 * bindings/bindings.py:
	   fix regex to match documentation (remove condition terminating on
	   '**/')
	   print error messages to stderr.
	 * bindings/java/lang.py: remove commented debugging code

	Docs: add declaration of missing LassoNode public methods
	 * docs/reference/lasso-sections.txt:
	   add missing lasso_node_*() functions.

	Docs: fix doc on Attribute related classes
	 * xml/saml-2.0/saml2_attribute_value.c:
	 * xml/saml-2.0/samlp2_extensions.c:
	 * xml/saml_attribute_value.c:
	   add documentation about the special way of setting those classes
	   content, that is using lasso_node_set_original_xmlnode.
	 * docs/reference/lasso-sections.txt:
	 * docs/reference/lasso.sgml:
	   add missing declarations for documentation of LassoSamlAttribute,
	   LassoSamlAttributeValue, LassoSamlAttributeDesignator,
	   LassoSamlStatement and LassoSaml2AttributeValue.

	Fix bug #94: permit any content for AttributeValue
	 * lasso/xml/private.h:
	 * lasso/xml/xml.h
	 * lassoi/xml/xml.c:
	   add an implementation helper for the AttributeValue objects
	   implementation of get_xmlNode.
	   make lasso_node_set_original_xmlnode public API.
	 * lasso/xml/saml-2.0/samlp2_extensions.c:
	 * lasso/xml/saml-2.0/saml2_attribute_value.c:
	 * lasso/xml/saml_attribute_value.c:
	   implement get_xmlNode for the AttributeValue and Extensions objects.
	   If the any field is empty, use the original_xmlnode value.  In order
	   to support free-style content, you must use the method
	   lasso_node_set_original_xmlnode, properties and children are
	   extracted from the given node and added to the node created by the
	   generic get_xmlNode virtual method.

	XML Core: add new snippet type SNIPPET_KEEP_XMLNODE
	 * private.h:
	   add the new constant to the enum type
	 * xml.c:
	   fix lasso_node_traversal, add support for the new contanst in
	   lasso_node_imp_init_from_xmlNode.

	Core: add error codes, fix error strings
	 * lasso/errors.c, lasso/errors.h:
	   remove useless error code LASSO_SERVER_ERROR_INVALID_XML,
	   fix string for LASSO_PROFILE_ERROR_INVALID_ISSUER,
	   add errors codes LASSO_PROFILE_ERROR_CANNOT_VERIFY_SIGNATURE,
	   LASSO_PROFILE_ERROR_CANNOT_FIND_A_PROVIDER and
	   LASSO_PROVIDER_ERROR_MISSING_PUBLIC_KEY.

	Makefile: missing dependencies for built sources
	 * lasso/Makefile.am:
	   remove .PHONY declaration on built sources and set appropriate
	   dependencies.
	 * lasso/extract_types.py: with new dependencies well defined in
	   Makefile no need to verify change in the content of the file, just
	   overwrite it.

	Core: Fix argument checking in init_from_xml
	 * lasso/xml/xml.c:
	   In lasso_node_impl_init_from_xml if xmlnode is null, return an error
	   but if no node_data specification is present, do not fail but print a
	   warning. It is not an error for a class to not have a node_data
	   private field.
	   add a comment to fix return code later.

	Core: handle g_io_channel creation failure
	 * lasso/xml/tools.c:
	   in lasso_load_certs_from_pem_certs_chain_file if
	   g_io_channel_new_file fails return NULL and print a warning.
	   If path is NULL or 0-length also returns NULL.

	Core: do not mix public and private headers
	 * lots of files:
	   explicitely load the internal header xml/private.h where needed.

2009-03-23  Frederic Peters  <fpeters@entrouvert.com>

	tentative NEWS file

2009-03-09  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Doc: Update index sgml file to cope with gtkdoc 1.11
	 * docs/references/lasso.sgml:
	   change entity path for LassoSamlp2AssertionIDRequest.

	SAML 2.0: Fix #90, simplify NameID decryption for NameIdManagement
	 * lasso/saml-2.0/name_id_management.c:
	   (lasso_saml2_name_id_management_process_request)
	   simplify code, remove explicit decryption of nameid and handling of
	   error cases, delegate to lasso_decrypt_nameid (from xml/tools.c).

	Core: add a method to decrypt nameid, handling error cases
	 * lasso/id-dff/serverprivate.h:
	 * lasso/id-ff/server.c:
	   lasso_server_decrypt_nameid handle error case of NameID decryption,
	   and update passed field pointers.
	 * lasso/errors.h:
	   add new error codes:
	   LASSO_DS_ERROR_DECRYPTION_FAILED -118
	    -  Decryption of an encrypted node failed
	   LASSO_PROFILE_ERROR_MISSING_SERVER -438
	    - No server object set in the profile

	XML SAML 1.0: fix bug 85
	 * lasso/xml/lib_logout_request.c: do not break parsing when
	   NameIdentifier->Format attribute is NULL.

2009-03-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	SAML 2.0: remove NotBefore attribute when not answering an AuthnRequest
	 * lasso/saml-2.0/login.c:
	   In specification saml-profile-2.0-os.pdf, in paragraph 4.1.4.3, it is
	   said that the SubjectConfirmationData node MUST NOT contain a
	   NotBefore attribute if it contains an InReponseTo attribute,
	   understanding that the response cannot (it the ID of the request is
	   sufficiently random) arrive before the request and be valid with
	   respect to the InResponseTo attribute.

	Test: Add test for testing new InResponseTo checking code
	 * tests/login_tests.c:
	   after first test of parsing the soap response message in the login
	   test, try to parse it a second time, after modifying the InResponseTo
	   id of the assertion and disabling signature checking.

	ID-FF 1.2 & SAML 2.0: fix "fix bug 173" match assertion and not the response with authn request id
	 * lasso/id-ff/login.c:
	 * lasso/saml-2.0/login.c:
	   Serialize/Unserialize request_id private field in LassoLogin dumps.
	   Match InResponseTo assertion attribute (ID-FF 1.2) or
	   SubjectConfirmationData attribute (SAML 2.0) to original request id
	   if it is present.

	Core: rename LOGIN_ERROR_REFER_TO_UNKNOWN_REQUEST
	 * lasso/errors.h:
	 * lasso/errors.c:
	   rename LASSO_LOGIN_ERROR_REFER_TO_UNKNOWN_REQUEST to
	   LASSO_LOGIN_ERROR_ASSERTION_DOES_NOT_MATCH_REQUEST_ID.

	Core: fix handling of xsi:type
	 * lasso/xml/xml.c:
	   xsi:type handling is broken since commit 3982, restore it.
	   move prefix/nodename matching in static helper functions, and reuse
	   them inside xsi:type code path.

	Core: enforce flag verify-signature in function lasso_verify_signature
	 * lasso/xml/tools.c: in lasso_verify_signature always return success if
	   lasso_flag_verify_signature is FALSE.
	 * lasso/xml/private.h: change return type to int.

2009-03-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix BSD compatibility bug in configure.ac
	 * configure.ac: remove GNUism, use -eq and = instead of == with test
	   tool. (Patch from Emmanuel Dreyfus)

2009-02-17  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	ID-FF 1.2 & SAML 2.0: Fix #173, check InReponseTo in authn responses
	 * id-ff/login.h:
	   add a string field named request_id in the private part of LassoLogin
	   to store request id from the original AuthnRequest.
	 * id-ff/login.c:
	   if request_id field is not null check the InResponseTo attribute of
	   the samlp:Response.
	 * saml-2.0/login.c:
	   if request_id field is not null check the InResponseTo attribute of
	   the samlp:Response.

2009-02-06  Damien Laniel  <dlaniel@entrouvert.com>

	fixed binding generation

	removed trailing whitespace

2009-02-05  Damien Laniel  <dlaniel@entrouvert.com>

	fixed parsing of OFTYPE

2009-01-26  Damien Laniel  <dlaniel@entrouvert.com>

	added all string constants to the API doc

	reorganised string constants definitions

	added an index to quickly find symbols

	fixed some functions name

	documentation-related fixes

	added documentation for id-wsf 2.0 functions

	added lasso_data_service_new_full and removed lasso_idwsf2_discovery_destroy in api doc

2009-01-24  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Core: if OFTYPE is already defined, skip

	Core: add decorator on GList return value in LassoSession header
	* lasso/id-ff/session.h: add the OFTYPE decorator to the return type of
	  lasso_session_get_assertions.

	Java: add assertions
	* bindings/java/tests/LoginTest.java: add assertion for the return code
	  of lasso_logout_process_request_msg.

	ID-FF 1.2: review of logout validate request
	 * lasso/id-ff/logout.c (lasso_logout_validate_request): use new macros.

	ID-FF 1.2: review logout_process_request_msg
	 * lasso/id-ff/logout.c (lasso_logout_process_request_msg): use the
	   new allocation macros, add checking of the parsed object type, add
	   validation of some schema constraints before processing, like
	   presence of the name identifier.

	Core: make caller owner of the list, fix refcount leak

	Autoconf: new macro AS_COMPILER_FLAGS to check flag support
	 * macros/as-compiler-flags.m4 configure.ac: add a new files of autoconf macro
	   to check support of warning flags, add needed line in configure.ac to define
	   variable WARNING_FLAGS, containing only supported flags.

	Core: replace manual reference handling with macros
	 - lasso/xml/disco_insert_entry.c (lasso_disco_insert_entry_new) :
	   replace manual g_object_ref with assignment macro.

	Core: replace manual handling of references with macros
	 - lasso/xml/disco_resource_offering.c (lasso_disco_resource_offering_new)
	    replace manual g_object_ref with assignment macro.

	Core: synchronize lasso_verify_signature with new macros

	Core: add new error code to lasso_node_init_from_message
	 - add new return code LASSO_MESSAGE_FORMAT_XSCHEMA_ERROR
	 - fix SOAP_FORMAT bizarre if conditional
	 - remove old comments

	Core: review of lasso_node_encrypt
	 - use new memory macros
	 - copying nodes instead of stealing nodes

	ID-FF 1.2: fix leak of instance object

	Core: add a new messsage format error for XSchema constraint failure

	ID-FF 1.2: review logout_validate_request
	 * lasso/id-ff/logout.c (lasso_logout_validate_request):
	  - when signature verification failed in process_request_msg,
	    do not continue validation of the request, stop immediately and
	    return the signature status code.
	  - use utils.h macro for memory allocation handling. Fix potential leak
	    of the profile->response object.

	ID-FF 1.2: validate signatures on responses during the BRWS/Artifact profile
	- lasso/id-ff/login.c:
	  - the lasso_login_process_response_msg is used to process SOAP response
	    to artifact resolution requests. The answer contains an samlp:Response
	    that can be signed, and each contained assertion MUST be individually
	    signed.
	- lasso/xml/samlp_response.c:
	 - set keep_xmlnode flag on the class metadatas to help in signature
	   validations.

	ID-FF 1.2: add validation of assertion signatures
	 - lasso/id-ff/login.c:
	  - lasso_login_process_response_status_and_assertion:
	   - if signature_status is not 0 and an assertion is present, we
	     validate the signature on this assertion using the
	     internal API lasso_provider_verify_saml_signature.

	Core: add error code LOGIN_ERROR_REFER_TO_UNKNOWN_REQUEST
	* lasso/errors.h, lasso/errors.c:
	  - LASSO_LOGIN_ERROR_REFER_TO_UNKNOWN_REQUEST is raised when a
	    samlp:Response contains an attribute inResponseTo when when no
	    previous request can be found inside the LassoLogin object or if the
	    given ID is not the as the one fome the previous request.

	ID-FF 1.2: fix signature validation in login_process_authn_response_msg
	* lasso/id-ff/login.c:
	  when signature validation fails on a message, then return the
	  signature status as return code. There is a security fix.

	XML: new LassoProvider API to verify XMLDsig signatures
	* lasso/id-ff/provider.c, lasso/id-ff/providerprivate.h:
	  - (lasso_provider_verify_saml_signature) validate a signed
	    saml Request, Response or Assertion, using the public key
	    of the given provider.

	XML: Make LassoSamlAssertion keep its XML form when created by parsing
	* lasso/xml/saml_assertion.c: set the keep_original flag of class
	  LassoSamlAssertion to true, to keep a copy of the original libxml tree
	  used to initialize eache instance of this object.  We will use it to
	  validate signature on assertions.

	XML: Add internal API to validate XMLDsig signatures
	* lasso/xml/tools.c:
	  - lasso_saml_constrain_dsigctxt() add constraints following SAML
	    specifications on XMLDsig signatures to an libxmlsec DSig context.
	  - lasso_verify_signature() this function given an xmlNode and a key or
	    a keys manager (for a set of AC or AC chains) validate the
	    envelopped signature set upon this node. It can be instructed to
	    follow constraints of the SAML 1.0 specification.

	Core: add new error codes
	* lasso/errors.h: add error codes for,
	  - out of memory situation,
	  - excess of references during validation of signature on SAML
	    protocols message or assertions,
	  - an invalid reference during validation of signatures on SAML
	    protocols message or assertions,
	  - an mismatch between requested assertion issuer and received
	    assertion issuer.

	Autoconf: redirect shell warning in one of configure.ac tests
	 - configure.ac: when testing if bindings have been already generated
	   with differents settings do not let grep emit warnings.

	All: Fix missing field initializer problems
	* lots of files: Explicitely set all field of initialized structures,
	  in order to remove -Wno-missing-field-initilizers from needed
	  compiler options when using -Wall -Wextra.

	Core: add macros to assign list of things, rename xmlNode related macros
	* lasso/utils.h: added new macros, renamed others:
	  - macros handling xmlNode are renamed from _node to _xml_node,
	  - new macros for assign GList* of specific objects:
	    - lasso_assign_list_of_gobjects,
	    - lasso_assign_list_of_strings,
	    - lasso_assign_new_list_of_gobjects,
	  - macros for assigning xmlChar string (we need a specific macros
	    because, we must use xmlFree to release the destination string),
	  - macros to add string without duping: lasso_list_add_xml_string,
	  - macros to add anything non-null (no type cast):
	    lasso_list_add_non_null.

	Core: add references handling macros
	* lasso/utils.h:
	  - add macro lasso_transfer_string and lasso_transfer_gobject,
	    to transfer ownership of such objects without copying or
	    their changing reference count. The old containing variable is
	    NULLed.
	  - lasso_list_add_gobject,lasso_list_add_new_gobject: test if the added
	    object is a GObject, if not do not add it and print a warning.
	  - lasso_check_type_equality: this macro use special builtin functions
	    only with GCC (typeof and __builtin_types_compatible_p) and do
	    metaprogramming using anonymous enumeration type to make compile
	    time assertions. It is used
	 -  add macros to release XPathObject XPathContext, macro constructor to
	    make reference transfert macros (free dest, nullify dest, copy src
	    to dest without increasing refcount, nullify src), add a macro to
	    transfert xpath objects.

	Core: new goto_exit macro which produces warnings
	* lasso/utils.h:
	  similar macro to goto_exit_if_fail but also produce a printed warning.

	Core: new macros for adding string to GList
	* lasso/utils.h:
	  - lasso_list_add_string, add a copy of a string to a GList

	Core: Remove unused macro lasso_warn_deprecated
	* lasso/utils.h: remove macros lasso_warn_deprecated, use GCC
	  attributes and gtkdoc markers instead.

2009-01-22  Damien Laniel  <dlaniel@entrouvert.com>

	added documentation sections for ID-WSF 2.0 Discovery and DataService

	removed unused destroy functions (only defined in .c or .h files)

2009-01-13  Jean-Marc Liger  <jean-marc.liger@siris.sorbonne.fr>

	Fedora/Redhat spec file

2008-12-18  Frederic Peters  <fpeters@entrouvert.com>

	correctly check for successful return of DSA_verify

2008-12-16  Damien Laniel  <dlaniel@entrouvert.com>

	check in lasso_name_id_management_init_request if HTTP method is supported

2008-12-12  Damien Laniel  <dlaniel@entrouvert.com>

	fixed fault code and use a more precise fault string

	if no identity is found while building disco response, create a soap fault response

2008-12-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Use assignment macros in id-wsf 2.0 module
	 * lasso/id-wsf-2.0/data_service.c, lasso/id-wsf-2.0/discovery.c,
	   lasso/id-wsf-2.0/profile.c: use assignment macros to maintain proper
	   reference counting and ownership of object field values.

2008-11-28  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix lasso.pc.in Cflags field
	 * lasso.pc.in: cflags must contain include directory

2008-11-26  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add errors.h.in to EXTRA_DIST
	 * lasso/Makefile.am: errors.h.in must be distributed.

2008-11-20  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add me.

2008-11-19  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix refcounting error in SoapEnvelope class
	 - lasso/xml/soap_envelope.c (lasso_soap_envelope_new): fix forgotten
	   reference count increase when assigning the body.

2008-11-14  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix uninitialized local variable
	 - bindings/java/wrapper_top.c: (gobject_to_jobject_and_ref) initialize
	   local variable.

2008-11-10  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add support to in memory private key to lasso_query_sign
	 - lasso/xml/tools.c: use BIO_new_mem_buf instead of BIO_new_file
	   if private_key is not an existing file.

2008-11-06  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add missing intialization
	 - lasso/id-ff/provider.c,lasso/id-ff/server.c: add missing initialization
	   of return code variable.

2008-11-05  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix missing include

	Add log message in the metadata loading process
	 - lasso/id-ff/provider.c, lasso/saml-2.0/provider.c: add critical log
	   message in each failed loading of metadatas branch cases.

	Add new internal function to show safe extracts
	 - lasso/utils.c, lasso/utils.h:
	   New internal api lasso_safe_prefix_string that can show any string
	   taking care of escaping newlines,tabs and non-graphical ou non-ASCII
	   characters.

	Fix uninitialized return code
	Thanks Emmanuel Dreyfus

2008-11-04  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Fix overwriting of attributes ht by node lists
	 - lasso/xml/xml.c:
	   - In lasso_node_impl_init_from_xml fix really old bug seen when
	     running ID-WSF 2 python tests, when looking for snippet_any
	     field in the GObject we should not take the any attribute field,
	     otherwise the field value is gonna be overwritten with new GList
	     nodes. The problem ca be seen only with classes using the two kind
	     of snippets (ANY nodes and ANY attributs).

	Change style of error and dellocation handling
	 - lasso/id-ff/provider.c:
	   - in lasso_provider_verify_signature use standardised memory and
	     error handling macros, and also standard return code variable name
	     and exit label.
	   - in lasso_providerl_load_metadata_from_buffer and
	     lasso_provider_load_metadata use the standardised macros, exit
	     labels and return code variable.
	 - lasso/id-ff/server.c:
	   - in lasso_server_load_affiliation use standardised allocation and
	     error handling macros.
	 - lasso/id-wsf/wsf_profile.c:
	   - use standardised memory and error handling macros in
	     lasso_wsf_profile_build_soap_request_msg.

	Move xmlDoc release after xmlFreeXPath*
	 - lasso/xml/xml.c:
	   - in lasso_node_new_from_soap release xmlDoc (and the contained
	     nodes) after the XPath objects that can reference them.

	Remove use of xmlFreeDoc for lasso_release_doc
	  - bindings/java/wrapper_top.c, bindings/php4/lasso_php4_helper.c,
	    bindings/php5/wrapper_source_top.c, bindings/python/wrapper_top.c,
	    lasso/id-ff/identity.c, lasso/id-ff/lecp.c, lasso/id-ff/login.c,
	    lasso/id-ff/logout.c, lasso/id-ff/name_registration.c,
	    lasso/id-ff/profile.c, lasso/id-ff/provider.c, lasso/id-ff/server.c,
	    lasso/id-ff/session.c, lasso/id-wsf-2.0/data_service.c,
	    lasso/id-wsf/data_service.c, lasso/id-wsf/discovery.c,
	    lasso/id-wsf/wsf_profile.c, lasso/saml-2.0/ecp.c,
	    lasso/saml-2.0/login.c, lasso/saml-2.0/name_id_management.c,
	    lasso/utils.h, lasso/xml/tools.c, lasso/xml/xml.c, swig/Lasso.i:
	    Remove use of xmlFreeDoc. Use lasso_release_doc instead.

	Clean generated files in bindings
	  * bindings/java/Makefile.am:
	  * bindings/php5/Makefile.am:
	  * bindings/python/Makefile.am:
	   - reformat value and add generated files to the MOSTLYCLEANFILES
	     variable

	Add new utils macros
	 - lasso/utils.h:
	   - add goto_exit_with_rc a standardized macro that suppose having an
	     'int rc' variable and an exit label in the current function.
	   - add lasso_release_output_buffer macro

	Fix lasso_assign_node: wrong xmlFreeNodeList
	  * lasso/utils.h:
	   - (lasso_assign_node) This macro wrongly assumes that the destroy
	     function for xmlNode is xmlFreeNodeList but it's xmlFreeNode.
	     xmlFreeNodeList is for xmlNode list of children.

2008-11-03  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Restore ABI compatibility wrt original_xmlNode
	 * lasso/xml/xml.c:
	  - use set/get_qdata to store the original xmlnode, modify
	    init_from_xml and dispose function to cope with this new storage
	    place.
	 * lasso/xml/xml.h:
	  - remove field original_xmlNode from structure LassoNode to keep ABI
	    compatibility with previous versions.
	  - declare new API lasso_node_get_original_xmlnode

	API to cleanup LassoNode tree of keeped xmlNode
	 * lasso/xml/xml.c:
	  - add a new function lasso_node_cleanup_original_xmlnodes to
	    disallocate all keeped xmlNode inside a tree of LassoNodes.
	  - add internal function lasso_node_traversal to iterate across a
	    LassoNode tree (could be used to reimplement lasso_node_destroy)
	    It is a preorder traversal.

	Add support for keep_xmlnode flag
	 * lasso/xml/xml.c:
	   - (lasso_node_impl_init_from_xml) When the keep_xmlnode flag is true
	     for the currently parsed Node class, we copy the parsed xmlNode
	     and keep inside the LassoNode.
	   - (lasso_node_dispose) if an original_xmlNode is present, we disallocate
	     it.

	Add original_xmlNode pointer to LassoNode
	 * lasso/xml/xml.h: add an xmlNode field to base class LassoNode,
	   to permit retrieving the xmlNode originally parsed when the structure
	   is the result of parsing. Will be used by signature checking code.

	Add keep_xmlnode field to LassoNodeClassData
	 * lasso/xml/private.h: add a boolean flag named keep_xmlnode to
	   base class structure LassoNodeClassData.

2008-11-02  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add test case for loading server completely from memory
	* tests/login_test.c:
	  - add generateIdentityProviderContextDumpMemory that first load
	    metadata, private_key and certificate file using g_file_get_contents
	    then use the created buffers to initialize a LassoServer object.
	  - add test03_serviceProviderLogin that use the new function.

	LassoServer init_from_xml/new_from_buffer handling
	* lasso/id-ff/server.c: (init_from_xml) if load_metadata fail
	  try load_metadata_from_buffer instead using the content of the dumped
	  nodes.

	Add new constructor lasso_server_new_from_buffers
	 * lasso/id-ff/server.c, lasso/id-ff/server.h: add new function to build
	   a LassoServer object holding content of certificate and private key
	   files intead of loading them everytime signing is needed. You must
	   instead load them yourself the first time.

	Export lasso_provider_load_metadata_from_buffer
	* lasso/id-ff/providerprivate.h: add declaration for private function
	  lasso_provider_load_metadata_from_buffer

	Add verification of access before calling libxml loading function
	* lasso/id-ff/provider.c: (lasso_provider_load_metadata) libxml emit warning
	  when trying to parse non-existing or non-accessible file, so verify
	  that the file is accessible before calling libxml. (the corner
	  case of having warning when the file become inaccessible between
	  the two calls is non-interesting)

	First try accessing the file before calling key loading functions
	* lasso/xml/tools.c: (lasso_sign_node) instead of waiting
	  for the xmlsec key loading function to fail before trying to load
	  the key directly from the private_key buffer, test it using
	  POSIX function.

	Add possibility to sign using preloaded keys
	* lasso/xml/tools.c:
	 - (lasso_sign_node) if loading of the private_key or the certificate
	   file we try to use the filename directly as a key in the PEM format.

2008-10-22  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add missing initializations.

2008-10-16  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Add substitute code for g_strcmp0

2008-10-13  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Integrate modification from Olav Morken <olavmo@stud.ntnu.no>
	It fixes bad url encoding of relaystates for logout
	profile. A better fix for all profiles is coming.

	add files to nodist_HEADERS to pass distcheck

2008-10-01  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	add functionality to enable debugging flags at runtime
	This code permit to set flags, separated by commas, space,
	tabulations, or colons. This flags activates debug functions like,
	suppressing validations of signatures or print debugging message about
	deallocations.

	The new flags are defined in /lasso/debug.h they can be set using an
	environment variable named LASSO_FLAG or a function named
	lasso_set_flag.

	There are two flags currently:
	- verify-signature:
	  To deactivate it, pass 'no-verify-signature' inside LASSO_DEBUG.
	  It desactivate signature verification, inside two functions:
	  lasso_query_verify_signature and lasso_provider_verify_signature.
	- memory-debug:
	  It enabled reporting of memory deallocation inside generic memory
	  dellaocator for LassoNode objects and also in bindings.

	- lasso/xml/xml.c: do not free a null hash table pointer.

2008-10-01  Damien Laniel  <dlaniel@entrouvert.com>

	cleaned up some code

	fixed docstrings ; added an exported function ; reorganised functions in file

	fixed segfaults

	fixed xml indentation

2008-09-23  Damien Laniel  <dlaniel@entrouvert.com>

	If ProviderID isn't found in an AuthnResponse, immediately return a critical error

2008-09-23  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	Many fix to compile with --enable-wsf and --enable-debugging and also to remove valgrind errors through python tests.
	1. Rename lasso_wsf_profile_new_full for java bindings (cannot subclass
	   in overrides of static methods).
	2. Add const modifiers to many functon signatures in
	   bindings/python/wrapper_top.c.
	3. add initialisation of private_data->encryption_sym_key_type (to
	   please valgrind) in instance_init of LassoProvider.
	4. Add new macro to assign xmlNode, we consider xmlNode to be an
	   immutable value, and always use xmlCopyNode for assignment. The
	   macros is called named lasso_assign_node.
	5. Fix segfault, when using xmlSec to encrypt the newly created
	   encrypted node replace the original node inside the xmlDoc structure,
	   and the original node is freed automatically. So you cannot borrow
	   the encrypted if you do not remove it from xmlDoc first.

2008-09-17  Damien Laniel  <dlaniel@entrouvert.com>

	free xmlDoc only once

	fixed docstring

	php: added a root class to define generic getter and setter

	fixed docstrings which fucked php5 binding

2008-09-16  Damien Laniel  <dlaniel@entrouvert.com>

	fixed various bugs with new compilation flags

	enable optimisation flag when not debugging

2008-09-12  Benjamin Dauvergne  <bdauvergne@entrouvert.com>

	* Remove ending blanks

	* Reset CFLAGS when --enable-debugging is used (remove -g -O2 value setted by AC_PROG_CC). * Show AM_CFLAGS + CFLAGS in resume when configure finish.

	* When --enable-debugging is used, add -Wno-xxx options to AM_CFLAGS so that   bindings compile with -Werror (-Werror is activated by --enable-debugging now)

	* Add G_GNUC_UNUSED for unused parameter we can't remove (python wrappers).

	* Add options when DEBUGGING is activated, i.e. to permit compiling when -Werror is used. It removes   some of the warning for code we do not control.

	* Select bindings in bindings/Makefile not in bindings/*/Makefile.

